#include "stdafx.h"
#include "scripts.h"
#include "kak.h"
#include "PROFILE.h"
#include "date.h"
#include <stdio.h>
#include <windows.h>
#include <process.h>
#include <fstream>
#include <iostream.h>
#include <string>
#include <stdlib.h>
#include <sys/stat.h>
#include "ddeml.h"

bool ShowStartMessage = false;
bool Created_Nod_Veh_Zone = false;
bool Created_GDI_Veh_Zone = false;
bool AllowKillBuilding = false;
Vector3 GDI_Veh_Spawn;
Vector3 Nod_Veh_Spawn;
Vector3 GDI_Harv_Spawn;
Vector3 Nod_Harv_Spawn;
bool KilledWF = false;
bool KilledAir = false;
int WFID = 0;
int AirID = 0;
bool IsRepeate = false;
bool IsCrateCreated = false;

int BarrID = 0;
int MobiusID = 0;
int NeededCaps = 0;
int GDICaps = 0;
int NodCaps = 0;
int GDIFollower = 0;
int NodFollower = 0;
bool IsFollowing = false;

HDDEDATA CALLBACK DdeCallback(
    UINT uType,
    UINT uFmt,
    HCONV hconv,
    HSZ hsz1,
    HSZ hsz2,
    HDDEDATA hdata,
    DWORD dwData1,
    DWORD dwData2)
{
    return 0;
}

void DDEPoke(DWORD idInst, HCONV hConv, char* szData)
{
    HSZ hszItem = DdeCreateStringHandle(idInst, "command", 0);
	DdeClientTransaction((LPBYTE)szData, (DWORD)(lstrlen(szData)+1),
                          hConv, hszItem, CF_TEXT,
                          XTYP_POKE, 3000, NULL);
    DdeFreeStringHandle(idInst, hszItem);
}

int SendtoIRC (char* message)
{
	char szApp[20];
    getProfileString("Settings", "DDEName", "null", szApp, 20, "Scripts.ini");
    char szTopic[] = "COMMAND";

    DWORD idInst=0;
    UINT iReturn;
    iReturn = DdeInitialize(&idInst, (PFNCALLBACK)DdeCallback, 
                            APPCLASS_STANDARD | APPCMD_CLIENTONLY, 0 );
    if (iReturn!=DMLERR_NO_ERROR)
    {
        return 1;
    }

    HSZ hszApp, hszTopic;
    HCONV hConv;
    hszApp = DdeCreateStringHandle(idInst, szApp, 0);
    hszTopic = DdeCreateStringHandle(idInst, szTopic, 0);
    hConv = DdeConnect(idInst, hszApp, hszTopic, NULL);
    DdeFreeStringHandle(idInst, hszApp);
    DdeFreeStringHandle(idInst, hszTopic);
    if (hConv == NULL)
    {
        DdeUninitialize(idInst);
        return 2;
    }

    DDEPoke(idInst, hConv, message);
    DdeDisconnect(hConv);
    DdeUninitialize(idInst);

    return 0;
}

void FDSMessage (const char* Message, bool Log) {
	printf("%s\n",Message);
	if (Log == true) {
		renremdate.refreshdate();
		char FDSlogname[100];
		sprintf(FDSlogname, "renlog_%s.txt",renremdate.get_date_string());

		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			char messageprint[512];
			char hours[5];
			char mins[5];
			char secs[5];
			time_t rawtime;
			struct tm *timeinfo;
			time(&rawtime);
			timeinfo = localtime(&rawtime);

			int hour = timeinfo->tm_hour;
			int min = timeinfo->tm_min;
			int sec = timeinfo->tm_sec;
			if (hour < 10) sprintf(hours,"0%d",hour);
			else sprintf(hours,"%d",hour);
			if (min < 10) sprintf(mins,"0%d",min);
			else sprintf(mins,"%d",min);
			if (sec < 10) sprintf(secs,"0%d",sec);
			else sprintf(secs,"%d",sec);

			sprintf(messageprint,"[%s:%s:%s] %s\n",hours,mins,secs,Message);
			FDSLog << messageprint;
			FDSLog.close();
		}
	}
}

GameObject *Create_Mobius (int BarracksID) {
	SendtoIRC("/ctminfo MOBIUS created");
	char iniXName[100],iniYName[100],iniZName[100], map[256],IDs[100];
	Vector3 MobiusPos;
	sprintf(IDs,"%d",BarracksID);
	getProfileString("Map",IDs,"null",map,256,"CTM.ini");
	int Position = Commands->Get_Random_Int(1,(getProfileInt(map,"TotalMobiusSpot",0,"CTM.ini") + 1));

	sprintf(iniXName,"Mobius%d_X",Position);
	sprintf(iniYName,"Mobius%d_Y",Position);
	sprintf(iniZName,"Mobius%d_Z",Position);
	MobiusPos.X = getProfileFloat(map,iniXName,500,"CTM.ini");
	MobiusPos.Y = getProfileFloat(map,iniYName,500,"CTM.ini");
	MobiusPos.Z = getProfileFloat(map,iniZName,-500,"CTM.ini");

	GameObject *tempMob = Commands->Create_Object("CnC_Ignatio_Mobius",MobiusPos);
	Commands->Set_Player_Type(tempMob,2);
	Commands->Set_Is_Visible(tempMob,false);
	Commands->Clear_Weapons(tempMob);
	GameObject *AttachedPowerup = Commands->Create_Object_At_Bone(tempMob,"POW_Data_Disc","HEAD");
	Commands->Attach_To_Object_Bone(AttachedPowerup, tempMob, "HEAD");
	char param[256], param2[256];
	sprintf(param,"%d,%d",Commands->Get_ID(tempMob),Commands->Get_ID(AttachedPowerup));
	sprintf(param2,"%d",Commands->Get_ID(AttachedPowerup));
	Commands->Attach_Script(tempMob,"KAK_CTM_Mobius",param2);
	Commands->Attach_Script(AttachedPowerup,"KAK_CTM_Mobius_Powerup",param);

	MobiusID = Commands->Get_ID(tempMob);
	return tempMob;
}

void Attach_Powerup_To_Mobius () {
	GameObject *AttachedPowerup = Commands->Create_Object_At_Bone(Commands->Find_Object(MobiusID),"POW_Data_Disc","HEAD");
	Commands->Attach_To_Object_Bone(AttachedPowerup, Commands->Find_Object(MobiusID), "HEAD");
	Commands->Set_Player_Type(Commands->Find_Object(MobiusID),2);
	char param[256];
	sprintf(param,"%d,%d",MobiusID,Commands->Get_ID(AttachedPowerup));
	Commands->Attach_Script(AttachedPowerup,"KAK_CTM_Mobius_Powerup",param);
}

GameObject *Create_Pedestal (int Team, int ID) {
	Vector3 PedLoc, FlagLoc;
	GameObject *Ped;
    char scriptPar[256], map[256], IDs[100];
	sprintf(IDs,"%d",ID);
	getProfileString("Map",IDs,"NULL",map,256,"CTM.ini");

	if (Team == 0) {
		PedLoc.X = getProfileFloat(map,"NodPed_X",500.000,"CTM.ini");
		PedLoc.Y = getProfileFloat(map,"NodPed_Y",500.000,"CTM.ini");
		PedLoc.Z = getProfileFloat(map,"NodPed_Z",-500.000,"CTM.ini");
		Ped = Commands->Create_Object("CtfPedestalRed",PedLoc);
	}
	else if (Team == 1) {
		PedLoc.X = getProfileFloat(map,"GDIPed_X",500.000,"CTM.ini");
		PedLoc.Y = getProfileFloat(map,"GDIPed_Y",500.000,"CTM.ini");
		PedLoc.Z = getProfileFloat(map,"GDIPed_Z",-500.000,"CTM.ini");
		Ped = Commands->Create_Object("CtfPedestalGold",PedLoc);
	}

	FlagLoc.X = PedLoc.X + (float)0.031;
	FlagLoc.Y = PedLoc.Y + (float)0.003;
	FlagLoc.Z = PedLoc.Z + (float)0.693;
	GameObject *FlagCrate = Commands->Create_Object("POW_Data_Disc",FlagLoc);
	sprintf(scriptPar,"%d",Team);
	Commands->Attach_Script(FlagCrate,"KAK_CTM_PedCrate",scriptPar);

	return Ped;
}

void KAK_CTM_Mobius::Damaged(GameObject *obj, GameObject *damager, float damage) {

}

void KAK_CTM_Mobius::Killed(GameObject *obj, GameObject *shooter) {
	SendtoIRC("/ctminfo MOBIUS killed");
	Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("PowerupID")));
	GDIFollower = 0;
	NodFollower = 0;
	Create_Mobius(BarrID);
}

void KAK_CTM_Mobius_Powerup::Created(GameObject *obj) {
	RepeatAction = false;
	Commands->Give_Powerup(obj,"POW_Medal_Health",false);
	Commands->Give_Powerup(obj,"POW_Medal_Health",false);
	Commands->Give_Powerup(obj,"POW_Medal_Health",false);
	Commands->Give_Powerup(obj,"POW_Medal_Health",false);
	Commands->Give_Powerup(obj,"POW_Medal_Health",false);
	Commands->Give_Powerup(obj,"POW_Medal_Armor",false);
	Commands->Give_Powerup(obj,"POW_Medal_Armor",false);
	Commands->Give_Powerup(obj,"POW_Medal_Armor",false);
	Commands->Give_Powerup(obj,"POW_Medal_Armor",false);
	Commands->Give_Powerup(obj,"POW_Medal_Armor",false);
}

void KAK_CTM_Mobius_Powerup::Action_Complete(GameObject * obj,int action,ActionCompleteReason reason) {
	if (action == 777 && RepeatAction == true)
		if (IsFollowing == true) Commands->Action_Reset(obj,100);
	else
		RepeatAction = true;
}

void KAK_CTM_Mobius_Powerup::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 1000000025) {
		if (Commands->Get_Player_Type(sender) == 0) {
			NodFollower = Commands->Get_ID(sender);
			Commands->Set_Player_Type(Commands->Find_Object(MobiusID),0);
			SendtoIRC("/ctminfo MOBIUS stolen Nod");
			Commands->Start_Timer(obj,this,10,0);
		}
		else if (Commands->Get_Player_Type(sender) == 1) {
			GDIFollower = Commands->Get_ID(sender);
			Commands->Set_Player_Type(Commands->Find_Object(MobiusID),1);
			SendtoIRC("/ctminfo MOBIUS stolen GDI");
			Commands->Start_Timer(obj,this,10,1);
		}

		IsFollowing = true;
		Commands->Give_Money(sender,300,true);
		Commands->Give_Money(sender,-300,false);
		Commands->Give_Points(sender,600,false);
		ActionParamsStruct FollowParams;
		FollowParams.Set_Basic(this,100,777,-1);
		FollowParams.Set_Goto_Following(sender,1.5,2,true);
		Commands->Action_Goto(Commands->Find_Object(Get_Int_Parameter("MobiusID")),FollowParams);
	}
}

void KAK_CTM_Mobius_Powerup::Timer_Expired(GameObject *obj, int number) {
	if (IsFollowing == true) {
		if (number == 0) {
			if (!Commands->Find_Object(NodFollower)) {
				IsFollowing = false;
				Attach_Powerup_To_Mobius();
			}
		}
		if (number == 1) {
			if (!Commands->Find_Object(GDIFollower)) {
				IsFollowing = false;
				Attach_Powerup_To_Mobius();
			}
		}
	}
}

void KAK_CTM_PedCrate::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 1000000025) {
		if (Commands->Get_Player_Type(sender) == 0 && Get_Int_Parameter("Team") == 0 && NodFollower == Commands->Get_ID(sender)) {
			SendtoIRC("/ctminfo MOBIUS captured Nod");
			Commands->Destroy_Object(Commands->Find_Object(MobiusID));
			Create_Mobius(BarrID);
			NodFollower = 0;
			NodCaps++;
			Commands->Give_Money(sender,700,true);
			Commands->Give_Money(sender,-700,false);
			Commands->Give_Points(sender,1400,false);

			char map[256], IDs[100];
			sprintf(IDs,"%d",BarrID);
			getProfileString("Map",IDs,"NULL",map,256,"CTM.ini");
			if (NodCaps >= NeededCaps) {
				SendtoIRC("/ctminfo GAMEEND Nod");
				AllowKillBuilding = true;
				int BuildingAmount = getProfileInt(map,"GDIBuildings",0,"CTM.ini");
				int i = 1;
				while (i <= BuildingAmount) {
					char BuildingIDTxt[256];
					sprintf(BuildingIDTxt,"GDIBuilding%d",i);
					Commands->Apply_Damage(Commands->Find_Object(getProfileInt(map,BuildingIDTxt,0,"CTM.ini")),99999,"Explosive",false);
					i++;
				}
			}
			else {
				char IRCLeft[256];
				sprintf(IRCLeft,"/ctminfo CAPTLEFT Nod %d",(NeededCaps - GDICaps));
				SendtoIRC(IRCLeft);
				GameObject *FlagCrate;
				char scriptPar[256];
				FlagCrate = Commands->Create_Object("POW_Data_Disc",Commands->Get_Position(obj));
				sprintf(scriptPar,"%d",Commands->Get_Player_Type(sender));
				Commands->Attach_Script(FlagCrate,"KAK_CTM_PedCrate",scriptPar);
			}
		}
		else if (Commands->Get_Player_Type(sender) == 1 && Get_Int_Parameter("Team") == 1 && GDIFollower == Commands->Get_ID(sender)) {
			SendtoIRC("/ctminfo MOBIUS captured GDI");
			Commands->Destroy_Object(Commands->Find_Object(MobiusID));
			Create_Mobius(BarrID);
			GDIFollower = 0;
			GDICaps++;
			Commands->Give_Money(sender,700,true);
			Commands->Give_Money(sender,-700,false);
			Commands->Give_Points(sender,1400,false);

			char map[256], IDs[100];
			sprintf(IDs,"%d",BarrID);
			getProfileString("Map",IDs,"NULL",map,256,"CTM.ini");
			if (GDICaps >= NeededCaps) {
				SendtoIRC("/ctminfo GAMEEND GDI");
				AllowKillBuilding = true;
				int BuildingAmount = getProfileInt(map,"NodBuildings",0,"CTM.ini");
				int i = 1;
				while (i <= BuildingAmount) {
					char BuildingIDTxt[256];
					sprintf(BuildingIDTxt,"NodBuilding%d",i);
					Commands->Apply_Damage(Commands->Find_Object(getProfileInt(map,BuildingIDTxt,0,"CTM.ini")),99999,"Explosive",false);
					i++;
				}
			}
			else {
				char IRCLeft[256];
				sprintf(IRCLeft,"/ctminfo CAPTLEFT GDI %d",(NeededCaps - GDICaps));
				SendtoIRC(IRCLeft);
				GameObject *FlagCrate;
				char scriptPar[256];
				FlagCrate = Commands->Create_Object("POW_Data_Disc",Commands->Get_Position(obj));
				sprintf(scriptPar,"%d",Commands->Get_Player_Type(sender));
				Commands->Attach_Script(FlagCrate,"KAK_CTM_PedCrate",scriptPar);
			}
		}
		else {
			GameObject *FlagCrate;
			char scriptPar[256];
			FlagCrate = Commands->Create_Object("POW_Data_Disc",Commands->Get_Position(obj));
			sprintf(scriptPar,"%d",Commands->Get_Player_Type(sender));
			Commands->Attach_Script(FlagCrate,"KAK_CTM_PedCrate",scriptPar);
		}
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Created(GameObject *obj) {
	if (ShowStartMessage == false) {
		FDSMessage("Running in Capture The Mobius mode",false);
		ShowStartMessage = true;
	}
	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks")) {
		BarrID = Commands->Get_ID(obj);
		char map[256], IDs[100];
		sprintf(IDs,"%d",BarrID);
		getProfileString("Map",IDs,"NULL",map,256,"CTM.ini");
		AllowKillBuilding = false;
		IsFollowing = false;
		NeededCaps = getProfileInt(map,"TotalCaptures",1,"CTM.ini");
		GDICaps = 0;
		NodCaps = 0;
		IsRepeate = false;
		IsCrateCreated = false;
		Created_Nod_Veh_Zone = false;
		Created_GDI_Veh_Zone = false;
		SendtoIRC("/logparse 1 Level loaded OK");
		Create_Mobius(BarrID);
		Create_Pedestal(0,BarrID);
		Create_Pedestal(1,BarrID);
	}

	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_War_Factory")) {
		KilledWF = false;
		WFID = Commands->Get_ID(obj);
		Commands->Apply_Damage(obj,99999,"Explosive",false);
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Airstrip")) {
		KilledAir = false;
		AirID = Commands->Get_ID(obj);
		Commands->Apply_Damage(obj,99999,"Explosive",false);
	}
}
void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Destroyed(GameObject *obj) {
	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_War_Factory")) {
		KilledWF = true;
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Airstrip")) {
		KilledAir = true;
	}
	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks")) {
		AllowKillBuilding = false;
		IsFollowing = false;
		BarrID = 0;
		GDICaps = 0;
		NodCaps = 0;
		NeededCaps = 0;
		MobiusID = 0;
	}
}
void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (AllowKillBuilding == false) {
		if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_War_Factory")) {
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Airstrip")) {
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}
		else {
			if (Commands->Get_Player_Type(damager) == 1 && strstr(Commands->Get_Preset_Name(obj),"GDI")) {
				Commands->Give_Points(damager,damage,false);
				Commands->Give_Money(damager,(damage * (float)-1),false);
			}
			else if (Commands->Get_Player_Type(damager) == 1 && !strstr(Commands->Get_Preset_Name(obj),"GDI")) {
				Commands->Give_Points(damager,(damage * (float)-1),false);
				Commands->Give_Money(damager,(damage * (float)-1),false);
			}
			else if (Commands->Get_Player_Type(damager) == 0 && strstr(Commands->Get_Preset_Name(obj),"Nod")) {
				Commands->Give_Points(damager,damage,false);
				Commands->Give_Money(damager,(damage * (float)-1),false);
			}
			else if (Commands->Get_Player_Type(damager) == 0 && !strstr(Commands->Get_Preset_Name(obj),"Nod")) {
				Commands->Give_Points(damager,(damage * (float)-1),false);
				Commands->Give_Money(damager,(damage * (float)-1),false);
			}


			if (damage >= 500) {
				if (Commands->Get_Player_Type(damager) == 1 && strstr(Commands->Get_Preset_Name(obj),"GDI")) {
					Commands->Give_Points(damager,(float)250,false);
					Commands->Give_Money(damager,(float)-250,false);
				}
				else if (Commands->Get_Player_Type(damager) == 1 && !strstr(Commands->Get_Preset_Name(obj),"GDI")) {
					Commands->Give_Points(damager,(float)-250,false);
					Commands->Give_Money(damager,(float)-250,false);
				}
				else if (Commands->Get_Player_Type(damager) == 0 && strstr(Commands->Get_Preset_Name(obj),"Nod")) {
					Commands->Give_Points(damager,(float)250,false);
					Commands->Give_Money(damager,(float)-250,false);
				}
				else if (Commands->Get_Player_Type(damager) == 0 && !strstr(Commands->Get_Preset_Name(obj),"Nod")) {
					Commands->Give_Points(damager,(float)-250,false);
					Commands->Give_Money(damager,(float)-250,false);
				}
			}

			Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
		}
	}
}
void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Killed(GameObject *obj, GameObject *shooter) {
	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_War_Factory")) {
		KilledWF = true;
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Airstrip")) {
		KilledAir = true;
	}
}

void M00_Disable_Transition::Created(GameObject *obj) {
	Commands->Apply_Damage(obj,99999,"Explosive",false);
	if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester")) {
		if (Created_Nod_Veh_Zone == false) {
			Created_Nod_Veh_Zone = true;
			Nod_Veh_Spawn.X = 0;
			Nod_Veh_Spawn.Y = 0;
			Nod_Veh_Spawn.Z = 0;
			HarvyPos.X = 0;
			HarvyPos.Y = 0;
			HarvyPos.Z = 0;
			Commands->Start_Timer(obj,this,7,1);
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester")) {
		if (Created_GDI_Veh_Zone == false) {
			Created_GDI_Veh_Zone = true;
			GDI_Veh_Spawn.X = 0;
			GDI_Veh_Spawn.Y = 0;
			GDI_Veh_Spawn.Z = 0;
			HarvyPos.X = 0;
			HarvyPos.Y = 0;
			HarvyPos.Z = 0;
			Commands->Start_Timer(obj,this,4,0);
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}
	}

	if (KilledWF == false) {
		Commands->Apply_Damage(Commands->Find_Object(WFID),99999,"Explosive",false);
	}
	if (KilledAir == false) {
		Commands->Apply_Damage(Commands->Find_Object(AirID),99999,"Explosive",false);
	}
}
void M00_Disable_Transition::Timer_Expired(GameObject *obj,int number) {
	HarvyPos = Commands->Get_Position(obj);
	if (number == 0) {
		GDI_Veh_Spawn = HarvyPos;
		GDI_Harv_Spawn = HarvyPos;
	}
	else if (number == 1) {
		Nod_Veh_Spawn = HarvyPos;
		Nod_Harv_Spawn = HarvyPos;
	}
	Commands->Apply_Damage(obj,99999,"Explosive",false);
}

void M00_Disable_Transition::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (strstr(Commands->Get_Preset_Name(obj),"Nod_Turret")) {
		if (Commands->Get_Player_Type(damager) == 1 && strstr(Commands->Get_Preset_Name(obj),"GDI")) {
			Commands->Give_Points(damager,(damage * (float)0.330),false);
			Commands->Give_Money(damager,(damage * (float)-1),false);
		}
		else if (Commands->Get_Player_Type(damager) == 1 && !strstr(Commands->Get_Preset_Name(obj),"GDI")) {
			Commands->Give_Points(damager,(damage * (float)-0.330),false);
			Commands->Give_Money(damager,(damage * (float)-0.330),false);
		}
		else if (Commands->Get_Player_Type(damager) == 0 && strstr(Commands->Get_Preset_Name(obj),"Nod")) {
			Commands->Give_Points(damager,(damage * (float)0.330),false);
			Commands->Give_Money(damager,(damage * (float)-0.330),false);
		}
		else if (Commands->Get_Player_Type(damager) == 0 && !strstr(Commands->Get_Preset_Name(obj),"Nod")) {
			Commands->Give_Points(damager,(damage * (float)-0.330),false);
			Commands->Give_Money(damager,(damage * (float)-0.330),false);
		}


		if (damage >= 300) {
			if (Commands->Get_Player_Type(damager) == 1 && strstr(Commands->Get_Preset_Name(obj),"GDI")) {
				Commands->Give_Points(damager,(float)100,false);
				Commands->Give_Money(damager,(float)-100,false);
			}
			else if (Commands->Get_Player_Type(damager) == 1 && !strstr(Commands->Get_Preset_Name(obj),"GDI")) {
				Commands->Give_Points(damager,(float)-100,false);
				Commands->Give_Money(damager,(float)-100,false);
			}
			else if (Commands->Get_Player_Type(damager) == 0 && strstr(Commands->Get_Preset_Name(obj),"Nod")) {
				Commands->Give_Points(damager,(float)100,false);
				Commands->Give_Money(damager,(float)-100,false);
			}
			else if (Commands->Get_Player_Type(damager) == 0 && !strstr(Commands->Get_Preset_Name(obj),"Nod")) {
				Commands->Give_Points(damager,(float)-100,false);
				Commands->Give_Money(damager,(float)-100,false);
			}
		}

		Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
		Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj));
	}
}

void M00_GrantPowerup_Created::Created(GameObject *obj) {
	Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
	Commands->Set_Is_Visible(obj,false);

	if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
		Commands->Start_Timer(obj,this,1,5);
		IsDestroyed = false;
	}

	if (KilledWF == false) {
		Commands->Apply_Damage(Commands->Find_Object(WFID),99999,"Explosive",false);
	}
	if (KilledAir == false) {
		Commands->Apply_Damage(Commands->Find_Object(AirID),99999,"Explosive",false);
	}
}
void M00_GrantPowerup_Created::Timer_Expired(GameObject *obj, int number) {
	if (number == 5) {
		Commands->Give_Money(obj,1,false);
		Commands->Start_Timer(obj,this,1,5);
	}
}
void M00_GrantPowerup_Created::Destroyed(GameObject *obj) {
	if (IsDestroyed == false) {
		IsDestroyed = true;
		DeathPlace = Commands->Get_Position(obj);
		if (Commands->Get_Player_Type(obj) == 0 && NodFollower == Commands->Get_ID(obj)) {
			SendtoIRC("/ctminfo MOBIUS dropped");
			IsFollowing = false;
			GameObject *InvisTemp = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
			Commands->Attach_Script(InvisTemp,"KAK_Revert_Controller","");
		}
		else if (Commands->Get_Player_Type(obj) == 1 && GDIFollower == Commands->Get_ID(obj)) {
			SendtoIRC("/ctminfo MOBIUS dropped");
			IsFollowing = false;
			GameObject *InvisTemp = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
			Commands->Attach_Script(InvisTemp,"KAK_Revert_Controller","");
		}
	}
}
void M00_GrantPowerup_Created::Killed(GameObject *obj, GameObject *shooter) {
	if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
		DeathPlace = Commands->Get_Position(obj);
		BackpackObject = Commands->Create_Object("Invisible_Object",DeathPlace);
		Commands->Attach_Script(BackpackObject,"KAK_Backpack_Object",Commands->Get_Preset_Name(obj));

		if (Commands->Get_Player_Type(obj) == 0 && NodFollower == Commands->Get_ID(obj)) {
			SendtoIRC("/ctminfo MOBIUS dropped");
			IsFollowing = false;
			GameObject *InvisTemp = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
			Commands->Attach_Script(InvisTemp,"KAK_Revert_Controller","");
			Commands->Give_Money(shooter,100,true);
			Commands->Give_Money(shooter,-100,false);
			Commands->Give_Points(shooter,200,false);
		}
		else if (Commands->Get_Player_Type(obj) == 1 && GDIFollower == Commands->Get_ID(obj)) {
			SendtoIRC("/ctminfo MOBIUS dropped");
			IsFollowing = false;
			GameObject *InvisTemp = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
			Commands->Attach_Script(InvisTemp,"KAK_Revert_Controller","");
			Commands->Give_Money(shooter,100,true);
			Commands->Give_Money(shooter,-100,false);
			Commands->Give_Points(shooter,200,false);
		}
	}
}

void KAK_Revert_Controller::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,5,7);
}
void KAK_Revert_Controller::Timer_Expired(GameObject *obj, int number) {
	if (number == 7) Attach_Powerup_To_Mobius();
}


void KAK_Backpack_Object::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,5,1);
}

void KAK_Backpack_Object::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		DeathPlace = Commands->Get_Position(obj);

		int RandomNum = Commands->Get_Random_Int(1,4);

		if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player_Nod",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_ChemSprayer_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_0")) {
			BackpackScript = Commands->Create_Object("POW_Flamethrower_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Grenadier_0")) {
			BackpackScript = Commands->Create_Object("POW_GrenadeLauncher_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserChaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Technician_0")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney_PowerSuit")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_PersonalIonCannon_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_Railgun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("CnC_POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_TiberiumAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Grenadier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_TiberiumFlechetteGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Ignatio_Mobius")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_VoltAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("CnC_POW_VoltAutoRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else {
			BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		Commands->Send_Custom_Event(obj,BackpackScript,6000,Commands->Get_ID(obj),0);
	}
}

void KAK_Backpack::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 6000) {
		SpawnedByID = param;
	}

	else if (message == 1000000025) {
		if (SpawnedByID != Commands->Get_ID(sender)) {
			Commands->Give_Powerup(obj,GunToGive,true);
			Commands->Destroy_Object(obj);
		}
	}

}

void M00_CNC_Crate::Created(GameObject *obj) {
	if (IsCrateCreated == false) {
		vehBlocker = Commands->Create_Object("Vehicle_Blocker",Commands->Get_Position(obj));
		IsCrateCreated = true;
	}
}
void M00_CNC_Crate::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 1000000025) {
		if (IsRepeate == false) {
			IsRepeate = true;
			Commands->Destroy_Object(vehBlocker);
			IsCrateCreated = false;
			GameObject *tempObj = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
			Commands->Attach_Script(tempObj,"KAK_Temp_Crate","");
			Commands->Send_Custom_Event(sender,tempObj,990000,0,1);
			RandomIntCrate = Commands->Get_Random_Int(1,101);

			// Points and Depoints Crate
			if (RandomIntCrate > 0 && RandomIntCrate <= 14) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);
				if (RandomGoodNum == 1) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Points(sender,500,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Points(sender,250,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Points(sender,125,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 125", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Points(sender,50,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 50", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Points(sender,50,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 50", Commands->Get_Player_Type(sender));
					}
				}
				else if (RandomGoodNum == 2) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Points(sender,-500,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Points(sender,-250,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Points(sender,-125,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 125", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Points(sender,-50,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 50", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Points(sender,-50,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 50", Commands->Get_Player_Type(sender));
					}
				}
				SendtoIRC(CrateMessage);
			}

		
			//Money and Demoney Crate
			else if (RandomIntCrate > 14 && RandomIntCrate <= 28) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);
				if (RandomGoodNum == 1) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Money(sender,1000,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 1000", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Money(sender,500,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Money(sender,250,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Money(sender,100,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 100", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Money(sender,100,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 100", Commands->Get_Player_Type(sender));
					}
				}
				else if (RandomGoodNum == 2) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Money(sender,-1000,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 1000", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Money(sender,-500,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Money(sender,-250,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Money(sender,-100,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 100", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Money(sender,-100,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 100", Commands->Get_Player_Type(sender));
					}
					if (Commands->Get_Money(sender) < 0) Commands->Give_Money(sender,(Commands->Get_Money(sender) * -1),false);
				}
				SendtoIRC(CrateMessage);
			}

			//Random Weapon Crate
			else if (RandomIntCrate > 28 && RandomIntCrate <= 47) {
				int RandomWeapNum = Commands->Get_Random_Int(1,201);
				if (RandomWeapNum > 0 && RandomWeapNum <= 20) {
					Commands->Give_Powerup(sender,"POW_AutoRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d AutoRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 20 && RandomWeapNum <= 40) {
					Commands->Give_Powerup(sender,"POW_Shotgun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Shotgun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 40 && RandomWeapNum <= 60) {
					Commands->Give_Powerup(sender,"POW_Flamethrower_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Flamethrower", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 60 && RandomWeapNum <= 80) {
					Commands->Give_Powerup(sender,"POW_GrenadeLauncher_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d GrenadeLauncher", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 80 && RandomWeapNum <= 100) {
					Commands->Give_Powerup(sender,"POW_RepairGun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RepairGunWeak", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 100 && RandomWeapNum <= 120) {
					Commands->Give_Powerup(sender,"CnC_POW_MineRemote_02",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RemoteMine2", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 120 && RandomWeapNum <= 130) {
					if (Commands->Get_Player_Type(sender) == 1) 
						Commands->Give_Powerup(sender,"POW_Chaingun_Player",true);
					else if (Commands->Get_Player_Type(sender) == 0)
						Commands->Give_Powerup(sender,"POW_Chaingun_Player_Nod",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Chaingun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 130 && RandomWeapNum <= 140) {
					Commands->Give_Powerup(sender,"POW_RocketLauncher_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RocketLauncherWeak", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 140 && RandomWeapNum <= 150) {
					Commands->Give_Powerup(sender,"POW_ChemSprayer_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d ChemSprayer", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 150 && RandomWeapNum <= 160) {
					Commands->Give_Powerup(sender,"POW_TiberiumAutoRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d TiberiumAutoRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 160 && RandomWeapNum <= 166) {
					if (Commands->Get_Player_Type(sender) == 1) 
						Commands->Give_Powerup(sender,"POW_SniperRifle_Player",true);
					else if (Commands->Get_Player_Type(sender) == 0)
						Commands->Give_Powerup(sender,"POW_SniperRifle_Player_Nod",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d SniperRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 166 && RandomWeapNum <= 172) {	
					Commands->Give_Powerup(sender,"POW_LaserChaingun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d LaserChaingun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 172 && RandomWeapNum <= 178) {
					Commands->Give_Powerup(sender,"POW_LaserRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d LaserRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 178 && RandomWeapNum <= 184) {
					Commands->Give_Powerup(sender,"CnC_POW_RocketLauncher_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RocketLauncherStrong", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 184 && RandomWeapNum <= 190) {
					Commands->Give_Powerup(sender,"POW_TiberiumFlechetteGun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d TiberiumFlechetteGun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 190 && RandomWeapNum <= 193) {
					Commands->Give_Powerup(sender,"POW_PersonalIonCannon_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d PersonalIonCannon", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 193 && RandomWeapNum <= 196) {
					Commands->Give_Powerup(sender,"POW_Railgun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Railgun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 196 && RandomWeapNum <= 198) {
					Commands->Give_Powerup(sender,"POW_RamjetRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RamjetRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 198 && RandomWeapNum <= 199) {
					Commands->Give_Powerup(sender,"POW_VoltAutoRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d VoltAutoRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 199 && RandomWeapNum <= 200) {
					Commands->Give_Powerup(sender,"CnC_POW_VoltAutoRifle_Player_Nod",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d VoltAutoRifle_Nod", Commands->Get_Player_Type(sender));
				}

				else {
					Commands->Give_Powerup(sender,"POW_Pistol_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Pistol", Commands->Get_Player_Type(sender));
				}
				SendtoIRC(CrateMessage);
			}

			//Death Crate
			else if (RandomIntCrate > 47 && RandomIntCrate <= 56) {
				Commands->Apply_Damage(sender,99999,"Shrapnel",false);
				sprintf(CrateMessage,"/crateinfo Death_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Tiberium Death and Tiberium Suit Crate
			else if (RandomIntCrate > 56 && RandomIntCrate <= 65) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);
				if (RandomGoodNum == 1) {
					Commands->Apply_Damage(sender,99999,"TiberiumRaw",false);
					sprintf(CrateMessage,"/crateinfo Tiberium_Death_Crate %d", Commands->Get_Player_Type(sender));
				}
				else if (RandomGoodNum == 2) {
					Commands->Set_Shield_Type(sender,"ShieldChemWarrior");
					Commands->Send_Custom_Event(obj,sender,270000,0,0);
					sprintf(CrateMessage,"/crateinfo Tiberium_Suit_Crate %d", Commands->Get_Player_Type(sender));
				}
				SendtoIRC(CrateMessage);		
			}

			//Beacon Death and Beacon Crate
			else if (RandomIntCrate > 65 && RandomIntCrate <= 67) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);
				if (RandomGoodNum == 1) {
					int RandomSWNum = Commands->Get_Random_Int(1,3);
					if (RandomSWNum == 1) {
						Commands->Apply_Damage(sender,99999,"IonCannon",false);
						sprintf(CrateMessage,"/crateinfo Beacon_Death_Crate %d IonCannon", Commands->Get_Player_Type(sender));
					}
					else if (RandomSWNum == 2) {
						Commands->Apply_Damage(sender,99999,"Nuke",false);
						sprintf(CrateMessage,"/crateinfo Beacon_Death_Crate %d Nuke", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Apply_Damage(sender,99999,"Nuke",false);
						sprintf(CrateMessage,"/crateinfo Beacon_Death_Crate %d Nuke", Commands->Get_Player_Type(sender));
					}
				}
				else if (RandomGoodNum == 2) {
					if (Commands->Get_Player_Type(sender) == 1) {
						Commands->Give_Powerup(sender,"CnC_POW_IonCannonBeacon_Player",true);
						sprintf(CrateMessage,"/crateinfo Beacon_Crate %d Ion", Commands->Get_Player_Type(sender));
					}
					else if (Commands->Get_Player_Type(sender) == 0) {
						Commands->Give_Powerup(sender,"CnC_POW_Nuclear_Missle_Beacon",true);
						sprintf(CrateMessage,"/crateinfo Beacon_Crate %d Nuke", Commands->Get_Player_Type(sender));
					}
				}
				SendtoIRC(CrateMessage);	
			}

			//Full Health and Dehealth Crate
			else if (RandomIntCrate > 67 && RandomIntCrate <= 72) {
				int RandomGoodNum = Commands->Get_Random_Int(1,4);
				if (RandomGoodNum == 1 || RandomGoodNum == 2) {
					Commands->Set_Health(sender,Commands->Get_Max_Health(sender));
					sprintf(CrateMessage,"/crateinfo Full_Health_Crate %d", Commands->Get_Player_Type(sender));
				}
				else if (RandomGoodNum == 3) {
					Commands->Set_Health(sender,1);
					sprintf(CrateMessage,"/crateinfo Dehealth_Crate %d", Commands->Get_Player_Type(sender));
				}
				SendtoIRC(CrateMessage);
			}

			//Full Armor Crate
			else if (RandomIntCrate > 72 && RandomIntCrate <= 77) {
				int RandomGoodNum = Commands->Get_Random_Int(1,4);
				if (RandomGoodNum == 1 || RandomGoodNum == 2) {
					Commands->Set_Shield_Strength(sender,Commands->Get_Max_Shield_Strength(sender));
					sprintf(CrateMessage,"/crateinfo Full_Armor_Crate %d", Commands->Get_Player_Type(sender));
				}
				else if (RandomGoodNum == 3) {
					Commands->Set_Shield_Strength(sender,1);
					sprintf(CrateMessage,"/crateinfo Dearmor_Crate %d", Commands->Get_Player_Type(sender));
				}
				SendtoIRC(CrateMessage);
			}

			//Full Ammo Crate
			else if (RandomIntCrate > 77 && RandomIntCrate <= 82) {
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				sprintf(CrateMessage,"/crateinfo Full_Ammo_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Refill Crate
			else if (RandomIntCrate > 82 && RandomIntCrate <= 84) {
				Commands->Set_Health(sender,Commands->Get_Max_Health(sender));
				Commands->Set_Shield_Strength(sender,Commands->Get_Max_Shield_Strength(sender));
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				sprintf(CrateMessage,"/crateinfo Refill_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Butter Fingers Crate
			else if (RandomIntCrate > 84 && RandomIntCrate <= 87) {
				Commands->Clear_Weapons(sender);

				int RandomBFNum = Commands->Get_Random_Int(1,3);
				if (RandomBFNum == 1) Commands->Give_Powerup(sender,"POW_Pistol_Player",false);
				else if (RandomBFNum == 2) Commands->Give_Powerup(sender,"CnC_POW_MineTimed_Player_01",false);
				else Commands->Give_Powerup(sender,"CnC_POW_MineTimed_Player_01",false);

				sprintf(CrateMessage,"/crateinfo Butter_Fingers_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Kamikaze Suit Crate
			else if (RandomIntCrate > 87 && RandomIntCrate <= 92) {
				Commands->Send_Custom_Event(obj,sender,250000,0,0);
				sprintf(CrateMessage,"/crateinfo KamiKaze_Suit_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Thief Crate
			else if (RandomIntCrate > 92 && RandomIntCrate <= 94) {
				Commands->Give_Money(sender,(Commands->Get_Money(sender) * -1),false);
				sprintf(CrateMessage,"/crateinfo Thief_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Second Wind Crate
			else if (RandomIntCrate > 94 && RandomIntCrate <= 100) {
				Commands->Send_Custom_Event(obj,sender,260000,0,0);
				sprintf(CrateMessage,"/crateinfo Second_Wind_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			// Nothing Else
			else {
				sprintf(CrateMessage,"/crateinfo Debug %d %d",RandomIntCrate);
				SendtoIRC(CrateMessage);
			}
		}
	}
}
void M00_CNC_Crate::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {

	}
}

void KAK_Temp_Crate::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 990000) {
		IsRepeate = false;
		Commands->Destroy_Object(obj);
	}
}


void M00_Death_Powerup::Created(GameObject *obj) {
	//ensure override
}
void M00_Death_Powerup::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	//ensure override
}

ScriptRegistrant<M00_BUILDING_EXPLODE_NO_DAMAGE_DAK> M00_BUILDING_EXPLODE_NO_DAMAGE_DAK_Registrant("M00_BUILDING_EXPLODE_NO_DAMAGE_DAK","");
ScriptRegistrant<M00_Disable_Transition> M00_Disable_Transition_Registrant("M00_Disable_Transition","");
ScriptRegistrant<M00_GrantPowerup_Created> M00_GrantPowerup_Created_Registrant("M00_GrantPowerup_Created","WeaponDef:string");
ScriptRegistrant<KAK_Backpack> KAK_Backpack_Registrant("KAK_Backpack","");
ScriptRegistrant<KAK_Backpack_Object> KAK_Backpack_Object_Registrant("KAK_Backpack_Object","CharacterType:string");
ScriptRegistrant<M00_CNC_Crate> M00_CNC_Crate_Registrant("M00_CNC_Crate","");
ScriptRegistrant<KAK_Temp_Crate> KAK_Temp_Crate_Registrant("KAK_Temp_Crate","");
ScriptRegistrant<M00_Death_Powerup> M00_Death_Powerup_Registrant("M00_Death_Powerup","");
ScriptRegistrant<KAK_CTM_Mobius> KAK_CTM_Mobius_Registrant("KAK_CTM_Mobius","PowerupID:int");
ScriptRegistrant<KAK_CTM_Mobius_Powerup> KAK_CTM_Mobius_Powerup_Registrant("KAK_CTM_Mobius_Powerup","MobiusID:int,PowerupID:int");
ScriptRegistrant<KAK_CTM_PedCrate> KAK_CTM_PedCrate_Registrant("KAK_CTM_PedCrate","Team:int");
ScriptRegistrant<KAK_Revert_Controller> KAK_Revert_Controller_Registrant("KAK_Revert_Controller","");