#define min(a,b)            (((a) < (b)) ? (a) : (b))
typedef unsigned long DWORD;
typedef int GameObject;
class ScriptFactory;
class ScriptClass;
typedef void (*rdf) (ScriptClass *scr);
typedef void (*srdf) (rdf);
typedef void (*ds) (ScriptClass *scr);
typedef ScriptClass *(*cs) (const char *);
typedef int (*gsc) ();
typedef char *(*gsn) (int);
typedef char *(*gspd) (int);
typedef enum  {
	ACTION_COMPLETE_ATTACK_OUT_OF_RANGE = 1,
	ACTION_COMPLETE_MOVE_NO_PROGRESS_MADE = 2,
	ACTION_COMPLETE_PATH_BAD_DEST = 3,
	ACTION_COMPLETE_PATH_BAD_START = 4,
	ACTION_COMPLETE_LOW_PRIORITY = 5,
	ACTION_COMPLETE_NORMAL = 6
} ActionCompleteReason;
struct SeralizeInfoStr {
	void *data;
	int size;
	int number;
	SeralizeInfoStr *next;
};
struct Vector3 {
	float X;
	float Y;
	float Z;
};
class GameObjObserverClass {
protected:
	DWORD data1;
public:
	virtual ~GameObjObserverClass();
	virtual char *Get_Name() = 0;
	virtual void Attatch(GameObject * newobj) = 0;
	virtual void Detatch(GameObject *obj) = 0;
	virtual void Created(GameObject *obj) = 0;
	virtual void Destroyed(GameObject *obj) = 0;
	virtual void Killed(GameObject *obj,GameObject * shooter) = 0;
	virtual void Damaged(GameObject *obj,GameObject * damager,float damage) = 0;
	virtual void Custom(GameObject *obj,int message,int param,GameObject * sender) = 0;
	virtual void Sound_Heard(GameObject *obj,DWORD sound) = 0;
	virtual void Enemy_Seen(GameObject *obj,GameObject * seen) = 0;
	virtual void Action_Complete(GameObject *obj,int action,ActionCompleteReason reason) = 0;
	virtual void Timer_Expired(GameObject *obj,int number) = 0;
	virtual void Animation_Complete(GameObject *obj,const char *anim) = 0;
	virtual void Poked(GameObject *obj,GameObject * poker) = 0;
	virtual void Entered(GameObject *obj,GameObject * enter) = 0;
	virtual void Exited(GameObject *obj,GameObject * exit) = 0;
	DWORD GetData1()
	{
		return data1;
	}
};
class ScriptClass : public GameObjObserverClass {
};
class ScriptImpClass : public ScriptClass {
private:
	GameObject *OwnerAddr;
	int mArgC;
	char **mArgV;
	ScriptFactory *Factory;
	SeralizeInfoStr *seralizeinfo;
	static rdf RequestDestroyScript;
public:
	static void Set_Request_Destroy_Func(rdf Func);
	void SetFactory(ScriptFactory *ptr)
	{
		Factory = ptr;
	}
	ScriptImpClass();
	void Destroy_Script();
	int CheckPlayerType(GameObject *obj,int type);
	void Auto_Save_Variable(int number,int size,void *var);
	~ScriptImpClass();
	char *Get_Name();
	void Attatch(GameObject * newobj);
	void Detatch(GameObject *obj);
	void Created(GameObject *obj); //triggers on script creation
	void Destroyed(GameObject *obj); //triggers on script shutdown
	void Killed(GameObject *obj,GameObject * shooter); //triggers when the object script is attatched to dies
	void Damaged(GameObject *obj,GameObject * damager,float damage); //triggers when the object script is attatched to is damaged
	void Custom(GameObject *obj,int message,int param,GameObject * sender); //triggers when the script is sent a custom (aka message). Several system events are triggered by Customs as well, see the #defines below
	void Sound_Heard(GameObject *obj,DWORD sound); //something to do with sound, I think it triggers when the object the script is attatched to hears a sound)
	void Enemy_Seen(GameObject *obj,GameObject * seen); //triggers when the object script is attatched to spots an enemy
	void Action_Complete(GameObject *obj,int action,ActionCompleteReason reason); //triggers when an action on the object the script is attatched to completes
	void Timer_Expired(GameObject *obj,int number); //triggers when a timer goes off
	void Animation_Complete(GameObject *obj,const char *anim); //triggers when an animation on the object the script is attatched to completes
	void Poked(GameObject *obj,GameObject * poker); //triggers when the object that this scripts is attatched to is poked (i.e. player pushes the action key while this object is active)
	void Entered(GameObject *obj,GameObject * enter); //triggers when the zone this script is attatched to is entered
	void Exited(GameObject *obj,GameObject * exit); //triggers when the zone this script is attatched to is exited
	virtual GameObject *Owner();
	virtual GameObject **Get_Owner_Ptr();
	virtual void Set_Parameters_String(const char *params);
	virtual void Get_Parameters_String(char *params,unsigned int size);
	virtual void Save(DWORD saver);
	virtual void Load(DWORD loader);
	virtual void Save_Data(DWORD saver);
	virtual void Load_Data(DWORD loader);
	virtual void Register_Auto_Save_Variables();
	void Clear_Parameters();
	const char* Get_Parameter(const char* v);
	const char* Get_Parameter(int v);
	int Get_Int_Parameter(const char* v);
	float Get_Float_Parameter(const char *v);
	Vector3 Get_Vector3_Parameter(int v);
	Vector3 Get_Vector3_Parameter(const char* v);
	int Get_Parameter_Index(const char* v);
	int Get_Parameter_Count();
	int Get_Int_Parameter(int v);
	float Get_Float_Parameter(int v);
	void Set_Parameter(int pos,char const *v);
};
class ActionParamsStruct {
public:
	unsigned long Action_Priority;
	unsigned long Action_ID;
	DWORD varBC;
	Vector3 varB8;
	GameObject * varAC;
	float varA8;
	Vector3 Move_Destination;
	GameObject * Move_Target;
	Vector3 var94;
	float Move_Speed;
	float Move_Arrive_Distance;
	bool Move_Backwards;
	bool Move_Following;
	bool Move_Crouch;
	bool Move_Pathfind;
	bool var7C;
	float Attack_Range;
	float Attack_Deviation;
	bool var70;
	GameObject * Attack_Target;
	bool Attack_Primary;
	bool Attack_Crouched;
	Vector3 Attack_Location;
	bool var58;
	bool var57;
	bool var56;
	bool var55;
	bool var54;
	bool var53;
	Vector3 Face_Location;
	float var44;
	bool var40;
	unsigned long Move_Waypath_ID;
	unsigned long Move_Waypath_Start_ID;
	unsigned long Move_Waypath_End_ID;
	bool Move_Waypath_Splined;
	const char *Anim_Name;
	bool Anim_Enable;
	DWORD var24;
	const char *var20;
	long var1C;
	Vector3 Dock_Location;
	Vector3 Dock_Entrance;
	ActionParamsStruct();
	void Set_Basic(ScriptClass *s,unsigned long priority,unsigned long ID,long var1C);
	void Set_Attack(GameObject * Target,float range,float deviation,bool primary);
	void Set_Attack_v58(GameObject * Target,float range,float deviation,bool primary,bool v58);
	void Set_Attack_Position(const Vector3 & position,float Range,float Deviation,bool Primary);
	void Set_Animation(const char *animname);
	void Set_Face_Location(const Vector3 & facelocation,float unk);
	void Set_Dock(const Vector3 & docklocation,const Vector3 & dockentrance);
	void Set_Goto_Location(const Vector3 & position,float speed,float arrivedistance,bool crouch);
	void Set_Goto_Following(GameObject * Target,float speed,float arrivedistance,bool following);
	void Set_Goto_Crouch(GameObject * Target,float speed,float arrivedistance,bool crouch);
	void Set_Goto_Crouch_Following(GameObject * Target,float speed,float arrivedistance,bool crouch,bool following);
	void Set_Goto(GameObject * Target,float speed,float arrivedistance);
	void Set_Goto_Waypath_Start(unsigned long waypathID,unsigned long waypathstartID,unsigned long waypathendID,bool splined);
	void Set_Goto_Waypath(unsigned long waypathID,bool splined,bool v57,bool v58);
	void Set_Goto_Waypath_ID(unsigned long waypathID);
};
extern float MoveArriveDistance;
inline ActionParamsStruct::ActionParamsStruct()
{
	Action_Priority = 0;
	Action_ID = 0;
	varBC = 0;
	varB8.X = 0;
	varB8.Y = 0;
	varB8.Z = 0;
	varAC = 0;
	varA8 = 0;
	Move_Destination.X = 0;
	Move_Destination.Y = 0;
	Move_Destination.Z = 0;
	Move_Target = 0;
	var94.X = 0;
	var94.Y = 0;
	var94.Z = 0;
	Move_Speed = 1.0;
	Move_Arrive_Distance = MoveArriveDistance;
	Move_Backwards = false;
	Move_Following = false;
	Move_Crouch = false;
	Move_Pathfind = true;
	var7C = false;
	Attack_Range = 20;
	Attack_Deviation = 0;
	var70 = false;
	Attack_Target = 0;
	Attack_Primary = true;
	Attack_Crouched = false;
	Attack_Location.X = 0;
	Attack_Location.Y = 0;
	Attack_Location.Z = 0;
	var58 = true;
	var57 = true;
	var56 = false;
	var55 = true;
	var54 = false;
	var53 = false;
	Face_Location.X = 0;
	Face_Location.Y = 0;
	Face_Location.Z = 0;
	var44 = 2.0;
	var40 = false;
	Move_Waypath_ID = 0;
	Move_Waypath_Start_ID = 0;
	Move_Waypath_End_ID = 0;
	Move_Waypath_Splined = false;
	Anim_Name = 0;
	Anim_Enable = false;
	var24 = 0;
	var20 = 0;
	var1C = -1;
	Dock_Location.X = 0;
	Dock_Location.Y = 0;
	Dock_Location.Z = 0;
	Dock_Entrance.X = 0;
	Dock_Entrance.Y = 0;
	Dock_Entrance.Z = 0;
}
void inline ActionParamsStruct::Set_Goto_Location(const Vector3 & position,float speed,float arrivedistance,bool crouch)
{
	Move_Destination.X = position.X;
	Move_Destination.Y = position.Y;
	Move_Destination.Z = position.Z;
	Move_Speed = speed;
	Move_Arrive_Distance = arrivedistance;
	Move_Crouch = crouch;
}
void inline ActionParamsStruct::Set_Goto_Following(GameObject * Target,float speed,float arrivedistance,bool following)
{
	Move_Target = Target;
	Move_Speed = speed;
	Move_Arrive_Distance = arrivedistance;
	Move_Following = following;
}
void inline ActionParamsStruct::Set_Goto_Crouch(GameObject * Target,float speed,float arrivedistance,bool crouch)
{
	Move_Target = Target;
	Move_Speed = speed;
	Move_Arrive_Distance = arrivedistance;
	Move_Crouch = crouch;
}
void inline ActionParamsStruct::Set_Goto_Crouch_Following(GameObject * Target,float speed,float arrivedistance,bool crouch,bool following)
{
	Move_Target = Target;
	Move_Speed = speed;
	Move_Arrive_Distance = arrivedistance;
	Move_Crouch = crouch;
	Move_Following = following;
}
void inline ActionParamsStruct::Set_Goto(GameObject * Target,float speed,float arrivedistance)
{
	Move_Target = Target;
	Move_Speed = speed;
	Move_Arrive_Distance = arrivedistance;
}
void inline ActionParamsStruct::Set_Goto_Waypath_Start(unsigned long waypathID,unsigned long waypathstartID,unsigned long waypathendID,bool splined)
{
	Move_Waypath_ID = waypathID;
	Move_Waypath_Start_ID = waypathstartID;
	Move_Waypath_End_ID = waypathendID;
	Move_Waypath_Splined = splined;
}
void inline ActionParamsStruct::Set_Goto_Waypath(unsigned long waypathID,bool splined,bool v57,bool v58)
{
	Move_Waypath_ID = waypathID;
	Move_Waypath_Splined = splined;
	var57 = v57;
	var58 = v58;
}
void inline ActionParamsStruct::Set_Goto_Waypath_ID(unsigned long waypathID)
{
	Move_Waypath_ID = waypathID;
}
void inline ActionParamsStruct::Set_Dock(const Vector3 & docklocation,const Vector3 & dockentrance)
{
	Dock_Location.X = docklocation.X;
	Dock_Location.Y = docklocation.Y;
	Dock_Location.Z = docklocation.Z;
	Dock_Entrance.X = dockentrance.X;
	Dock_Entrance.Y = dockentrance.Y;
	Dock_Entrance.Z = dockentrance.Z;
}
void inline ActionParamsStruct::Set_Face_Location(const Vector3 & facelocation,float unk)
{
	Face_Location.X = facelocation.X;
	Face_Location.Y = facelocation.Y;
	Face_Location.Z = facelocation.Z;
	var44 = unk;
}
void inline ActionParamsStruct::Set_Animation(const char *animname)
{
	Anim_Name = animname;
	Anim_Enable = true;
}
void inline ActionParamsStruct::Set_Basic(ScriptClass *s,unsigned long priority,unsigned long ID,long v1C)
{
	varBC = s->GetData1();
	Action_Priority = priority;
	Action_ID = ID;
	var1C = v1C;
}
void inline ActionParamsStruct::Set_Attack(GameObject * Target,float Range,float Deviation,bool Primary)
{
	Attack_Target = Target;
	Attack_Range = Range;
	Attack_Deviation = Deviation;
	Attack_Primary = Primary;
}
void inline ActionParamsStruct::Set_Attack_v58(GameObject * Target,float Range,float Deviation,bool Primary,bool v58)
{
	Attack_Target = Target;
	Attack_Range = Range;
	Attack_Deviation = Deviation;
	Attack_Primary = Primary;
	var58 = v58;
}
void inline ActionParamsStruct::Set_Attack_Position(const Vector3 & position,float Range,float Deviation,bool Primary)
{
	Attack_Range = Range;
	Attack_Location.X = position.X;
	Attack_Location.Y = position.Y;
	Attack_Location.Z = position.Z;
	Attack_Deviation = Deviation;
	Attack_Primary = Primary;
}
#define CUSTOM_EVENT_SYSTEM_FIRST 1000000000 //this is what I believe is the marker that specifies the first system message
#define CUSTOM_EVENT_SOUND_ENDED 1000000001 //this one is sent when a sound finishes playing
#define CUSTOM_EVENT_TOGGLE_POWER 1000000002 //this one is sent on toggle power
#define CUSTOM_EVENT_ARRIVED_AT_DOCK 1000000003 //this one is sent when the thing gets to the dock
#define CUSTOM_EVENT_POWERUP 1000000025 //this one is sent to an item when its collected
#define CUSTOM_EVENT_DAMAGE 1000000026 //all I know is that this one has something to do with damage
#define CUSTOM_EVENT_HEAL 1000000027 //all I know is that this one has something to do with getting health back
#define CUSTOM_EVENT_VEHICLE_ENTER 1000000028 //this one gets sent to a vechicle when something enters it
#define CUSTOM_EVENT_VEHICLE_EXIT 1000000029 //this one gets sent to a vechicle when something exits it
#define CUSTOM_EVENT_ATTACK_ARRIVE 1000000030 //this one gets sent on something to do with arriving at attack location
#define CUSTOM_EVENT_AUDIENCE 1000000031 //this one gets sent on something to do with audience for a conversation
#define CUSTOM_EVENT_NEXT_REMARK 1000000032 //this one gets sent on something to do with say next remark
#define CUSTOM_EVENT_NEXT_REMARK2 1000000033 //this one also gets sent on something to do with say next remark but a different bit of code
#define CUSTOM_EVENT_JUMP_COMPLETE 1000000035 //this one gets sent when the jump is complete
class ScriptFactory {
private:
	ScriptFactory *next;
	char *name;
	char *params;
	int temp;
public:
	virtual ~ScriptFactory();
	virtual ScriptImpClass *Create() = 0;
	ScriptFactory(char *n,char *p);
	ScriptFactory *GetNext();
	void SetNext(ScriptFactory *ptr);
	char *GetName();
	char *GetParamDescription();
};
class ScriptRegistrar {
private:
	static ScriptFactory *mScriptFactories;
public:
	static void RegisterScript(ScriptFactory *ptr);
	static void UnregisterScript(ScriptFactory *ptr);
	static ScriptImpClass *CreateScript(const char *name);
	static ScriptFactory *GetScriptFactory(const char *name);
	static ScriptFactory *GetScriptFactory(int);
	static int Count();
};
template <class T> class ScriptRegistrant : public ScriptFactory {
	public:
	ScriptRegistrant(char *n,char *p) : ScriptFactory(n,p)
	{
	}
	ScriptImpClass *Create();
};
template <class T> ScriptImpClass *ScriptRegistrant<T>::Create()
	{
		ScriptImpClass *scr = new T;
		scr->SetFactory(this);
		scr->Register_Auto_Save_Variables();
		return scr;
	}
struct TimerParams {
	int number;
	float time;
	int repeat;
};
typedef TimerParams *PTimerParams;
typedef void (*Debug_Message) (const char * msg,...);
typedef void (*Action_Reset) (GameObject *obj,float reset);
typedef void (*Action_Goto) (GameObject *obj,const ActionParamsStruct & params);
typedef void (*Action_Attack) (GameObject *obj,const ActionParamsStruct & params);
typedef void (*Action_Play_Animation) (GameObject *obj,const ActionParamsStruct & params);
typedef void (*Action_Enter_Exit) (GameObject *obj,const ActionParamsStruct & params);
typedef void (*Action_Face_Location) (GameObject *obj,const ActionParamsStruct & params);
typedef void (*Action_Dock) (GameObject *obj,const ActionParamsStruct & params);
typedef void (*Action_Follow_Input) (GameObject *obj,const ActionParamsStruct & params);
typedef void (*Modify_Action) (GameObject *obj,int actionid,const ActionParamsStruct & params,bool unk1,bool unk2);
typedef int (*Get_Action_ID) (GameObject *obj);
typedef void (*Get_Action_Params) (GameObject *obj,ActionParamsStruct & params);
typedef bool (*Is_Performing_Pathfind_Action) (GameObject *obj);
typedef void (*Set_Position) (GameObject *obj,const Vector3 & position);
typedef Vector3 (*Get_Position) (GameObject *obj);
typedef Vector3 (*Get_Bone_Position) (GameObject *obj,const char *bone);
typedef float (*Get_Facing) (GameObject *obj);
typedef void (*Set_Facing) (GameObject *obj,float facing);
typedef void (*Disable_All_Collisions) (GameObject *obj);
typedef void (*Disable_Physical_Collisions) (GameObject *obj);
typedef void (*Enable_Collisions) (GameObject *obj);
typedef void (*Destroy_Object) (GameObject *obj);
typedef GameObject *(*Find_Object) (int id);
typedef GameObject *(*Create_Object) (const char *preset,const Vector3 & Position);
typedef GameObject *(*Create_Object_At_Bone) (GameObject *obj,const char *preset,const char *bone);
typedef int (*Get_ID) (GameObject *obj);
typedef int (*Get_Preset_ID) (GameObject *obj);
typedef const char *(*Get_Preset_Name) (GameObject *obj);
typedef void (*Attach_Script) (GameObject *obj,const char *scrname,const char *params);
typedef void (*Add_To_Dirty_Cull_List) (GameObject *obj);
typedef void (*Start_Timer) (GameObject *obj,ScriptClass *scr,float time,int number);
typedef void (*Trigger_Weapon) (GameObject *obj,bool fire,const Vector3 & v ,bool primary);
typedef void (*Select_Weapon) (GameObject *obj,const char *weapon);
typedef void (*Send_Custom_Event) (GameObject *sender,GameObject *reciever,int message,int param,float delay);
typedef void (*Send_Damaged_Event) (GameObject *obj,GameObject *unk);
typedef float (*Get_Random) (float min,float max);
typedef int (*Get_Random_Int) (int min,int max);
typedef void (*Find_Random_Simple_Object) (const char *obj);
typedef void (*Set_Model) (GameObject *obj,const char *model);
typedef void (*Set_Animation) (GameObject *obj,const char *animation,bool loop,const char *unk1,float unk2,float frame,bool unk3);
typedef void (*Set_Animation_Frame) (GameObject *obj,const char *animation,int frame);
typedef int (*Create_Sound) (const char *soundname,const Vector3 & position, GameObject *obj);
typedef int (*Create_2D_Sound) (const char *soundname);
typedef int (*Create_2D_WAV_Sound) (const char *soundname);
typedef int (*Create_3D_WAV_Sound_At_Bone) (const char *soundname,GameObject *obj,const char *bonename);
typedef int (*Create_3D_Sound_At_Bone) (const char *soundname,GameObject *obj,const char *bonename);
typedef int (*Create_Logical_Sound) (GameObject *obj,int soundnum,const Vector3 & pos,float unk);
typedef void (*Start_Sound) (int soundnum);
typedef void (*Stop_Sound) (int soundnum,bool unk);
typedef void (*Monitor_Sound) (GameObject *obj,int sound);
typedef void (*Set_Background_Music) (const char *music);
typedef void (*Fade_Background_Music) (const char *music,int unk1,int unk2);
typedef void (*Stop_Background_Music) ();
typedef float (*Get_Health) (GameObject *obj);
typedef float (*Get_Max_Health) (GameObject *obj);
typedef void (*Set_Health) (GameObject *obj,float health);
typedef float (*Get_Shield_Strength) (GameObject *obj);
typedef float (*Get_Max_Shield_Strength) (GameObject *obj);
typedef void (*Set_Shield_Strength) (GameObject *obj,float armour);
typedef void (*Set_Shield_Type) (GameObject *obj,const char *type);
typedef int (*Get_Player_Type) (GameObject *obj);
typedef void (*Set_Player_Type) (GameObject *obj,int type);
typedef float (*Get_Distance) (const Vector3 & pos1,const Vector3 & pos2);
typedef void (*Set_Camera_Host) (GameObject *obj);
typedef void (*Force_Camera_Look) (const Vector3 & look);
typedef GameObject *(*Get_The_Star) ();
typedef GameObject *(*Get_A_Star) (const Vector3 & pos);
typedef GameObject *(*Find_Closest_Soldier) (const Vector3 & pos,float unk1,float unk2,bool unk3);
typedef bool (*Is_A_Star) (GameObject *obj);
typedef void (*Control_Enable) (GameObject *obj,bool enable);
typedef const char *(*Get_Damage_Bone_Name) ();
typedef float (*Get_Damage_Bone_Direction) ();
typedef bool (*Is_Object_Visible) (GameObject *obj);
typedef void (*Enable_Enemy_Seen) (GameObject *obj,bool enable);
typedef void (*Set_Display_Color) (unsigned char red,unsigned char green, unsigned char blue);
typedef void (*Display_Text) (int strnum);
typedef void (*Display_Float) (float num,const char *msg);
typedef void (*Display_Int) (int num,const char *msg);
typedef void (*Save_Data) (DWORD saver,int number,int size,void *data);
typedef void (*Save_Pointer) (DWORD saver,int number,void *data);
typedef char (*Load_Begin) (DWORD loader,int *subchunkno);
typedef void (*Load_Data) (DWORD loader,int size,void *data);
typedef void (*Load_Pointer) (DWORD loader,void **data);
typedef void (*Load_End) (DWORD loader);
typedef void (*Begin_Chunk) (DWORD saver,unsigned int chunktype);
typedef void (*End_Chunk) (DWORD saver);
typedef char (*Open_Chunk) (DWORD loader,unsigned int *chunktype);
typedef void (*Close_Chunk) (DWORD loader);
typedef void (*Clear_Radar_Markers) ();
typedef void (*Clear_Radar_Marker) (int marker);
typedef void (*Add_Radar_Marker) (int marker, const Vector3 & pos,int shape, int color);
typedef void (*Set_Obj_Radar_Blip_Shape) (GameObject *obj,int shape);
typedef void (*Set_Obj_Radar_Blip_Color) (GameObject *obj,int color);
typedef void (*Enable_Radar) (bool enable);
typedef void (*Clear_Map_Cell) (int x,int y);
typedef void (*Clear_Map_Cell_By_Pos) (const Vector3 & pos);
typedef void (*Clear_Map_Cell_By_Pixel_Pos) (int x,int y);
typedef void (*Clear_Map_Region_By_Pos) (const Vector3 & pos,int reigon);
typedef void (*Reveal_Map) ();
typedef void (*Shroud_Map) ();
typedef void (*Show_Player_Map_Marker) (bool show);
typedef float (*Get_Safe_Flight_Height) (float x,float y);
typedef void (*Create_Explosion) (const char *explosion,const Vector3 & pos,GameObject *obj);
typedef void (*Create_Explosion_At_Bone) (const char *explosion,GameObject *obj1,const char *bone,GameObject *obj2);
typedef void (*Enable_HUD) (bool enable);
typedef void (*Mission_Complete) (bool won);
typedef void (*Give_Powerup) (GameObject *obj,const char *powerup,bool showonhud);
typedef void (*Innate_Disable) (GameObject *obj);
typedef void (*Innate_Enable) (GameObject *obj);
typedef void (*Innate_Soldier_Enable_Enemy_Seen) (GameObject *obj,bool enable);
typedef void (*Innate_Soldier_Enable_Gunshot_Heard) (GameObject *obj,bool enable);
typedef void (*Innate_Soldier_Enable_Footsteps_Heard) (GameObject *obj,bool enable);
typedef void (*Innate_Soldier_Enable_Bullet_Heard) (GameObject *obj,bool enable);
typedef void (*Innate_Soldier_Enable_Actions) (GameObject *obj,bool enable);
typedef void (*Set_Innate_Soldier_Home_Location) (GameObject *obj,const Vector3 & pos, float facing);
typedef void (*Set_Innate_Aggressiveness) (GameObject *obj,float aggressiveness);
typedef void (*Set_Innate_Take_Cover_Probability) (GameObject *obj,float probobility);
typedef void (*Set_Innate_Is_Stationary) (GameObject *obj,bool is_stationary);
typedef void (*Innate_Force_State_Bullet_Heard) (GameObject *obj,const Vector3 & pos);
typedef void (*Innate_Force_State_Footsteps_Heard) (GameObject *obj,const Vector3 & pos);
typedef void (*Innate_Force_State_Gunshots_Heard) (GameObject *obj,const Vector3 & pos);
typedef void (*Innate_Force_State_Enemy_Seen) (GameObject *obj,GameObject * seen);
typedef void (*Static_Anim_Phys_Goto_Frame) (int ID,float frame,const char *anim);
typedef void (*Static_Anim_Phys_Goto_Last_Frame) (int ID,const char *anim);
typedef float (*Get_Sync_Time) ();
typedef void (*Add_Objective) (int objectivenum,int type,int objtitleid,int unk,char *soundname,int descriptionid);
typedef void (*Remove_Objective) (int objectivenum);
typedef void (*Set_Objective_Status) (int objectivenum,int status);
typedef void (*Change_Objective_Type) (int objectivenum,int type);
typedef void (*Set_Objective_Radar_Blip) (int objectivenum,const Vector3 & pos);
typedef void (*Set_Objective_Radar_Blip_Object) (int objectivenum,GameObject *obj);
typedef void (*Set_Objective_HUD_Info) (int objectivenum,float priority,const char *pogfile,int pogtitleid);
typedef void (*Set_Objective_HUD_Info_Position) (int objectivenum,float priority,const char *pogfile,int pogtitleid,const Vector3 & pos);
typedef void (*Shake_Camera) (const Vector3 & pos,float unk1,float unk2,float unk3);
typedef void (*Enable_Spawner) (int ID,bool enable);
typedef void (*Trigger_Spawner) (int ID);
typedef void (*Enable_Engine) (GameObject *obj,bool enable);
typedef int (*Get_Difficulty_Level) ();
typedef void (*Grant_Key) (GameObject *obj,int keynum,bool grant);
typedef bool (*Has_Key) (GameObject *obj,int keynum);
typedef void (*Enable_Hibernation) (GameObject *obj,bool enable);
typedef void (*Attach_To_Object_Bone) (GameObject *obj,GameObject * attatch,const char *bonename);
typedef int (*Create_Conversation) (const char *conv,int unk1,float unk2,bool unk3);
typedef void (*Join_Conversation) (GameObject *obj,int convno,bool unk1,bool unk2,bool unk3);
typedef void (*Join_Conversation_Facing) (GameObject *obj,int convno,int facing);
typedef void (*Start_Conversation) (int convno,int unk);
typedef void (*Monitor_Conversation) (GameObject *obj,int convno);
typedef void (*Start_Random_Conversation) (GameObject *obj);
typedef void (*Stop_Conversation) (int convno);
typedef void (*Stop_All_Conversations) ();
typedef void (*Lock_Soldier_Facing) (GameObject *obj,GameObject * unk1,bool unk2);
typedef void (*Unlock_Soldier_Facing) (GameObject *obj);
typedef void (*Apply_Damage) (GameObject *obj,float damage,const char *warhead,GameObject *unk);
typedef void (*Set_Loiters_Allowed) (GameObject *obj,bool enable);
typedef void (*Set_Is_Visible) (GameObject *obj,bool enable);
typedef void (*Set_Is_Rendered) (GameObject *obj,bool enable);
typedef float (*Get_Points) (GameObject *obj);
typedef void (*Give_Points) (GameObject *obj,float points,bool entire_team);
typedef float (*Get_Money) (GameObject *obj);
typedef void (*Give_Money) (GameObject *obj,float money,bool entire_team);
typedef bool (*Get_Building_Power) (GameObject *obj);
typedef void (*Set_Building_Power) (GameObject *obj,bool enable);
typedef void (*Play_Building_Announcement) (GameObject *obj, int announcement);
typedef void (*Find_Nearest_Building) (GameObject *obj, const char *building);
typedef void (*Find_Nearest_Building_To_Pos) (const Vector3 & pos, const char *building);
typedef void (*Team_Members_In_Zone) (GameObject *obj, int team);
typedef void (*Set_Clouds) (float param1, float param2, bool param3);
typedef void (*Set_Lightning) (float param1, float param2, float param3, float param4, float parmam5, bool param6);
typedef void (*Set_War_Blitz) (float param1, float param2, float param3, float param4, float parmam5, bool param6);
typedef void (*Set_Wind) (float param1, float param2, float param3, bool param4);
typedef void (*Set_Rain) (float param1, float param2, bool param3);
typedef void (*Set_Snow) (float param1, float param2, bool param3);
typedef void (*Set_Ash) (float param1, float param2, bool param3);
typedef void (*Set_Fog_Enable) (bool enable);
typedef void (*Set_Fog_Range) (float param1, float param2, bool param3);
typedef void (*Enable_Stealth) (GameObject *obj,bool enable);
typedef void (*Cinematic_Sniper_Control) (bool enable,float zoom);
typedef int (*Text_File_Open) (const char *filename);
typedef bool (*Text_File_Get_String) (int handle,char *data,int size);
typedef void (*Text_File_Close) (int handle);
typedef void (*Enable_Vehicle_Transitions) (GameObject *obj,bool enable);
typedef void (*Display_GDI_Player_Terminal) ();
typedef void (*Display_NOD_Player_Terminal) ();
typedef void (*Display_Mutant_Player_Terminal) ();
typedef bool (*Reveal_Encyclopedia_Character) (int EncyclopediaID);
typedef bool (*Reveal_Encyclopedia_Weapon) (int EncyclopediaID);
typedef bool (*Reveal_Encyclopedia_Vehicle) (int EncyclopediaID);
typedef bool (*Reveal_Encyclopedia_Building) (int EncyclopediaID);
typedef void (*Display_Encyclopedia_Event_UI) ();
typedef void (*Scale_AI_Awareness) (float globalsightrangescale, float unused);
typedef void (*Enable_Cinematic_Freeze) (GameObject *obj,bool enable);
typedef void (*Expire_Powerup) (GameObject *obj);
typedef void (*Set_HUD_Help_Text) (int id,const Vector3 & color);
typedef void (*Enable_HUD_Pokable_Indicator) (GameObject *obj,bool is_pokeable);
typedef void (*Enable_Innate_Conversations) (GameObject *obj,bool enable);
typedef void (*Display_Health_Bar) (GameObject *obj, bool display);
typedef void (*Enable_Shadow) (GameObject *obj,bool enable);
typedef void (*Clear_Weapons) (GameObject *obj);
typedef void (*Set_Num_Tertiary_Objectives) (int num);
typedef void (*Enable_Letterbox) (bool enable,float unk);
typedef void (*Set_Screen_Fade_Color) (float red,float green,float blue,float unk);
typedef void (*Set_Screen_Fade_Opacity) (float unk1,float unk2);
//note: "//tested" after a script command means that someone has actually used it in a script and we have verified that it does what we think it does and that we know how to use it.
struct ScriptCommandsClass {
	DWORD version1;
	DWORD version2;
	Debug_Message Debug_Message; //doesnt work in the public builds of renegade, one can always use your own calls to _fopen and _fwrite and etc
	Action_Reset Action_Reset; //tested
	Action_Goto Action_Goto; //partially tested (command works but there is a lot more testing to figure out all the fields in the ActionParamsStruct to do)
	Action_Attack Action_Attack; //partially tested (command works but there is a lot more testing to figure out all the fields in the ActionParamsStruct to do)
	Action_Play_Animation Action_Play_Animation; //partially tested (command works but there is a lot more testing to figure out all the fields in the ActionParamsStruct to do), may not work in MP
	Action_Enter_Exit Action_Enter_Exit;
	Action_Face_Location Action_Face_Location; //partially tested (command works but there is a lot more testing to figure out all the fields in the ActionParamsStruct to do)
	Action_Dock Action_Dock;
	Action_Follow_Input Action_Follow_Input; //partially tested (command works but there is a lot more testing to figure out all the fields in the ActionParamsStruct to do)
	Modify_Action Modify_Action; //partially tested (command works but there is a lot more testing to figure out all the fields in the ActionParamsStruct to do)
	Get_Action_ID Get_Action_ID;
	Get_Action_Params Get_Action_Params;
	Is_Performing_Pathfind_Action Is_Performing_Pathfind_Action;
	Set_Position Set_Position; //tested
	Get_Position Get_Position; //tested
	Get_Bone_Position Get_Bone_Position;
	Get_Facing Get_Facing; //tested
	Set_Facing Set_Facing; //tested
	Disable_All_Collisions Disable_All_Collisions; //tested
	Disable_Physical_Collisions Disable_Physical_Collisions; //tested
	Enable_Collisions Enable_Collisions;
	Destroy_Object Destroy_Object; //tested
	Find_Object Find_Object; //tested
	Create_Object Create_Object; //tested
	Create_Object_At_Bone Create_Object_At_Bone; //tested
	Get_ID Get_ID; //tested
	Get_Preset_ID Get_Preset_ID; //tested
	Get_Preset_Name Get_Preset_Name; //tested
	Attach_Script Attach_Script; //tested
	Add_To_Dirty_Cull_List Add_To_Dirty_Cull_List; //tested
	Start_Timer Start_Timer; //tested
	Trigger_Weapon Trigger_Weapon;
	Select_Weapon Select_Weapon; //tested
	Send_Custom_Event Send_Custom_Event; //tested
	Send_Damaged_Event Send_Damaged_Event;
	Get_Random Get_Random; //tested
	Get_Random_Int Get_Random_Int; //tested
	Find_Random_Simple_Object Find_Random_Simple_Object;
	Set_Model Set_Model; //tested, might not work in MP
	Set_Animation Set_Animation; //should work in MP, untested though
	Set_Animation_Frame Set_Animation_Frame; //tested, doesnt work in MP
	Create_Sound Create_Sound; //tested, this one takes a preset
	Create_2D_Sound Create_2D_Sound; //tested, this one takes a preset, doesnt work in MP
	Create_2D_WAV_Sound Create_2D_WAV_Sound; //probobly doesnt work in MP, untested though
	Create_3D_WAV_Sound_At_Bone Create_3D_WAV_Sound_At_Bone;
	Create_3D_Sound_At_Bone Create_3D_Sound_At_Bone;
	Create_Logical_Sound Create_Logical_Sound;
	Start_Sound Start_Sound;
	Stop_Sound Stop_Sound;
	Monitor_Sound Monitor_Sound;
	Set_Background_Music Set_Background_Music; //tested, might not work in MP
	Fade_Background_Music Fade_Background_Music; //might not work in MP
	Stop_Background_Music Stop_Background_Music; //tested, might not work in MP
	Get_Health Get_Health; //tested
	Get_Max_Health Get_Max_Health; //tested
	Set_Health Set_Health; //tested
	Get_Shield_Strength Get_Shield_Strength; //tested
	Get_Max_Shield_Strength Get_Max_Shield_Strength; //tested
	Set_Shield_Strength Set_Shield_Strength; //tested
	Set_Shield_Type Set_Shield_Type; //tested
	Get_Player_Type Get_Player_Type; //tested, doesnt work on Script Zones
	Set_Player_Type Set_Player_Type; //tested, doesnt work on Script Zones
	Get_Distance Get_Distance; //tested
	Set_Camera_Host Set_Camera_Host;
	Force_Camera_Look Force_Camera_Look; //tested
	Get_The_Star Get_The_Star;  //tested
	Get_A_Star Get_A_Star; //tested
	Find_Closest_Soldier Find_Closest_Soldier; //tested
	Is_A_Star Is_A_Star; //tested
	Control_Enable Control_Enable;
	Get_Damage_Bone_Name Get_Damage_Bone_Name;
	Get_Damage_Bone_Direction Get_Damage_Bone_Direction;
	Is_Object_Visible Is_Object_Visible;
	Enable_Enemy_Seen Enable_Enemy_Seen; //tested
	Set_Display_Color Set_Display_Color; //doesnt work in MP
	Display_Text Display_Text; //doesnt work in MP
	Display_Float Display_Float; //tested, doesnt work in MP
	Display_Int Display_Int; //tested, doesnt work in MP
	Save_Data Save_Data; //tested, doesnt work in MP
	Save_Pointer Save_Pointer; //doesnt work in MP
	Load_Begin Load_Begin; //tested, doesnt work in MP
	Load_Data Load_Data; //tested, doesnt work in MP
	Load_Pointer Load_Pointer; //doesnt work in MP
	Load_End Load_End; //tested, doesnt work in MP
	Begin_Chunk Begin_Chunk; //tested, doesnt work in MP
	End_Chunk End_Chunk; //tested, doesnt work in MP
	Open_Chunk Open_Chunk; //tested, doesnt work in MP
	Close_Chunk Close_Chunk; //tested, doesnt work in MP
	Clear_Radar_Markers Clear_Radar_Markers;
	Clear_Radar_Marker Clear_Radar_Marker;  //tested
	Add_Radar_Marker Add_Radar_Marker; //tested
	Set_Obj_Radar_Blip_Shape Set_Obj_Radar_Blip_Shape; //tested
	Set_Obj_Radar_Blip_Color Set_Obj_Radar_Blip_Color; //tested
	Enable_Radar Enable_Radar; //tested, doesnt work in MP
	Clear_Map_Cell Clear_Map_Cell; //tested, doesnt work in MP
	Clear_Map_Cell_By_Pos Clear_Map_Cell_By_Pos; //doesnt work in MP
	Clear_Map_Cell_By_Pixel_Pos Clear_Map_Cell_By_Pixel_Pos; //doesnt work in MP
	Clear_Map_Region_By_Pos Clear_Map_Region_By_Pos; //doesnt work in MP
	Reveal_Map Reveal_Map; //doesnt work in MP
	Shroud_Map Shroud_Map; //doesnt work in MP
	Show_Player_Map_Marker Show_Player_Map_Marker; //doesnt work in MP
	Get_Safe_Flight_Height Get_Safe_Flight_Height; //tested
	Create_Explosion Create_Explosion; //tested
	Create_Explosion_At_Bone Create_Explosion_At_Bone; //tested
	Enable_HUD Enable_HUD; //tested, doesnt work in MP
	Mission_Complete Mission_Complete; //tested,  doesnt work in MP
	Give_Powerup Give_Powerup; //tested
	Innate_Disable Innate_Disable; //tested
	Innate_Enable Innate_Enable; //tested
	Innate_Soldier_Enable_Enemy_Seen Innate_Soldier_Enable_Enemy_Seen; //tested
	Innate_Soldier_Enable_Gunshot_Heard Innate_Soldier_Enable_Gunshot_Heard; //tested
	Innate_Soldier_Enable_Footsteps_Heard Innate_Soldier_Enable_Footsteps_Heard; //tested
	Innate_Soldier_Enable_Bullet_Heard Innate_Soldier_Enable_Bullet_Heard; //tested
	Innate_Soldier_Enable_Actions Innate_Soldier_Enable_Actions; //tested
	Set_Innate_Soldier_Home_Location Set_Innate_Soldier_Home_Location;
	Set_Innate_Aggressiveness Set_Innate_Aggressiveness;
	Set_Innate_Take_Cover_Probability Set_Innate_Take_Cover_Probability;
	Set_Innate_Is_Stationary Set_Innate_Is_Stationary;
	Innate_Force_State_Bullet_Heard Innate_Force_State_Bullet_Heard;
	Innate_Force_State_Footsteps_Heard Innate_Force_State_Footsteps_Heard;
	Innate_Force_State_Gunshots_Heard Innate_Force_State_Gunshots_Heard;
	Innate_Force_State_Enemy_Seen Innate_Force_State_Enemy_Seen;
	Static_Anim_Phys_Goto_Frame Static_Anim_Phys_Goto_Frame; //tested, might not work in MP
	Static_Anim_Phys_Goto_Last_Frame Static_Anim_Phys_Goto_Last_Frame; //tested, might not work in MP
	Get_Sync_Time Get_Sync_Time; //tested
	Add_Objective Add_Objective; //tested, doesnt work in MP
	Remove_Objective Remove_Objective; //tested, doesnt work in MP
	Set_Objective_Status Set_Objective_Status; //tested, doesnt work in MP
	Change_Objective_Type Change_Objective_Type; //tested, doesnt work in MP
	Set_Objective_Radar_Blip Set_Objective_Radar_Blip; //tested, doesnt work in MP
	Set_Objective_Radar_Blip_Object Set_Objective_Radar_Blip_Object; //tested, doesnt work in MP
	Set_Objective_HUD_Info Set_Objective_HUD_Info; //tested, doesnt work in MP
	Set_Objective_HUD_Info_Position Set_Objective_HUD_Info_Position; //tested, doesnt work in MP
	Shake_Camera Shake_Camera; //tested
	Enable_Spawner Enable_Spawner;
	Trigger_Spawner Trigger_Spawner;
	Enable_Engine Enable_Engine; //tested but still no clue what it does, relates to vechicles tho
	Get_Difficulty_Level Get_Difficulty_Level; //tested
	Grant_Key Grant_Key; //tested
	Has_Key Has_Key; //tested
	Enable_Hibernation Enable_Hibernation; //tested
	Attach_To_Object_Bone Attach_To_Object_Bone; //tested
	Create_Conversation Create_Conversation; // doesnt work in MP
	Join_Conversation Join_Conversation; // doesnt work in MP
	Join_Conversation_Facing Join_Conversation_Facing; // doesnt work in MP
	Start_Conversation Start_Conversation; // doesnt work in MP
	Monitor_Conversation Monitor_Conversation; // doesnt work in MP
	Start_Random_Conversation Start_Random_Conversation; // doesnt work in MP
	Stop_Conversation Stop_Conversation; // doesnt work in MP
	Stop_All_Conversations Stop_All_Conversations; // doesnt work in MP
	Lock_Soldier_Facing Lock_Soldier_Facing;
	Unlock_Soldier_Facing Unlock_Soldier_Facing;
	Apply_Damage Apply_Damage; //tested
	Set_Loiters_Allowed Set_Loiters_Allowed;
	Set_Is_Visible Set_Is_Visible; //tested (only affects the Is_Object_Visible command)
	Set_Is_Rendered Set_Is_Rendered; //tested
	Get_Points Get_Points;
	Give_Points Give_Points; //tested
	Get_Money Get_Money;
	Give_Money Give_Money; //tested, negative numbers work
	Get_Building_Power Get_Building_Power; //tested
	Set_Building_Power Set_Building_Power; //tested (only the base defences seem to actually power down)
	Play_Building_Announcement Play_Building_Announcement;
	Find_Nearest_Building Find_Nearest_Building;
	Find_Nearest_Building_To_Pos Find_Nearest_Building_To_Pos;
	Team_Members_In_Zone Team_Members_In_Zone;
	Set_Clouds Set_Clouds;
	Set_Lightning Set_Lightning;
	Set_War_Blitz Set_War_Blitz;
	Set_Wind Set_Wind;
	Set_Rain Set_Rain;
	Set_Snow Set_Snow;
	Set_Ash Set_Ash;
	Set_Fog_Enable Set_Fog_Enable;
	Set_Fog_Range Set_Fog_Range;
	Enable_Stealth Enable_Stealth; //tested
	Cinematic_Sniper_Control Cinematic_Sniper_Control; //tested (the sniper effect probobly only happens if you call other commands first or something, more work needed), doesnt work in MP
	Text_File_Open Text_File_Open;
	Text_File_Get_String Text_File_Get_String;
	Text_File_Close Text_File_Close;
	Enable_Vehicle_Transitions Enable_Vechicle_Transitions;
	Display_GDI_Player_Terminal Display_GDI_Player_Terminal; //tested (note: the player terminal always shows up on the machine of the person hosting the game, dont use this)
	Display_NOD_Player_Terminal Display_NOD_Player_Terminal; //tested (note: the player terminal always shows up on the machine of the person hosting the game, dont use this)
	Display_Mutant_Player_Terminal Display_Mutant_Player_Terminal; //crashes renegade if you use it (well actually, its more complicated but the general thing is that the mutants stuff is non-functional)
	Reveal_Encyclopedia_Character Reveal_Encyclopedia_Character; //tested, doesnt work in MP
	Reveal_Encyclopedia_Weapon Reveal_Encyclopedia_Weapon; //tested, doesnt work in MP
	Reveal_Encyclopedia_Vehicle Reveal_Encyclopedia_Vehicle; //tested, doesnt work in MP
	Reveal_Encyclopedia_Building Reveal_Encyclopedia_Building; //tested, doesnt work in MP
	Display_Encyclopedia_Event_UI Display_Encyclopedia_Event_UI; //tested, doesnt work in MP
	Scale_AI_Awareness Scale_AI_Awareness;
	Enable_Cinematic_Freeze Enable_Cinematic_Freeze;
	Expire_Powerup Expire_Powerup;
	Set_HUD_Help_Text Set_HUD_Help_Text; //tested, doesnt work in MP
	Enable_HUD_Pokable_Indicator Enable_HUD_Pokable_Indicator; //tested
	Enable_Innate_Conversations Enable_Innate_Conversations;
	Display_Health_Bar Display_Health_Bar; //tested
	Enable_Shadow Enable_Shadow; //tested
	Clear_Weapons Clear_Weapons; //tested
	Set_Num_Tertiary_Objectives Set_Num_Tertiary_Objectives; //tested, doesnt work in MP
	Enable_Letterbox Enable_Letterbox; //tested, doesnt work in MP
	Set_Screen_Fade_Color Set_Screen_Fade_Color;
	Set_Screen_Fade_Opacity Set_Screen_Fade_Opacity;
};
extern ScriptCommandsClass *Commands;
typedef bool (*ssc) (ScriptCommandsClass **);
