#include "stdafx.h"
#include "scripts.h"
#include "engine.h"
#ifndef WIN32
#include <wchar.h>
#endif
int Exe = 6;
typedef char DefinitionClass;
#ifdef WIN32
struct GameObjListNode {
	GameObjListNode *next;
	GameObject *obj;
};
struct GameObjList {
	unsigned int *vtable;
	GameObjListNode *head;
	GameObjListNode *tail;
};
#else
#ifdef RH8
struct GameObjListNode {
	GameObjListNode *next;
	GameObject *obj;
};
struct GameObjList {
	unsigned int *vtable;
	GameObjListNode *head;
	GameObjListNode *tail;
};
#else
struct GameObjListNode {
	int unknown;
	GameObjListNode *next;
	GameObject *obj;
};
struct GameObjList {
	GameObjListNode *head;
	GameObjListNode *tail;
	unsigned int *vtable;
};
#endif
#endif

typedef GameObject *(*ago) (GameObject *obj);
typedef const char *(*Get_Name) (char *ro);
typedef int (*Get_ClassID) (DefinitionClass *def);

typedef unsigned long (*Find_Player) (int);
Find_Player FindPlayer;
typedef DefinitionClass *(*Find_Named_Def) (const char *name, bool unk);
Find_Named_Def FindNamedDef;
#ifdef WIN32
typedef void (*ReInit) (DefinitionClass *def);
#else
typedef void (*ReInit) (GameObject *obj,DefinitionClass *def);
#endif
ReInit SoldierReInit;
#ifdef WIN32
typedef void (*PostReInit) (void);
#else
typedef void (*PostReInit) (GameObject *obj);
#endif
PostReInit Post_ReInit;
#ifdef WIN32
typedef void (*SetMax) (float max);
#else
typedef void (*SetMax) (unsigned int *def,float max);
#endif
SetMax SetMaxHealth;
SetMax SetMaxShieldStrength;
typedef void (*GrantSupplies) (GameObject *obj);
GrantSupplies Grant_Supplies;
#ifdef WIN32
typedef void (*PowerupGrant) (GameObject *obj,int powerup,bool unk);
#else
typedef void (*PowerupGrant) (DefinitionClass *def,GameObject *obj,int powerup,bool unk);
#endif
PowerupGrant Powerup_Grant;
typedef const char *(*GetArmorName) (unsigned int ID);
GetArmorName Get_Armor_Name;
typedef unsigned int(*GetArmorType) (const char *name);
GetArmorType Get_Armor_Type;
#ifdef WIN32
typedef void (*MarkOwnerDirty) (void);
#else
typedef void (*MarkOwnerDirty) (unsigned int *def);
#endif
MarkOwnerDirty Mark_Owner_Dirty;
#ifdef WIN32
typedef bool (*IsAvailable) (void);
#else
typedef bool (*IsAvailable) (GameObject *obj);
#endif
IsAvailable Is_Available_For_Purchase;
#ifdef WIN32
typedef bool (*RequestVehicle) (int Preset,float Delay,GameObject *Owner);
#else
typedef bool (*RequestVehicle) (GameObject *obj,int Preset,float Delay,GameObject *Owner);
#endif
RequestVehicle Request_Vehicle;
#ifdef WIN32
typedef void (*ToggleFlyMode) (void);
#else
typedef void (*ToggleFlyMode) (GameObject *obj);
#endif
ToggleFlyMode ToggleFly;
GameObjList *BuildingGameObjList;
GameObjList *SmartGameObjList;
GameObjList *BaseGameObjList;
void InitEngine()
{
	if (Exe == 0) //game.exe
	{
		BuildingGameObjList = (GameObjList *)0x00856FE8;
		SmartGameObjList = (GameObjList *)0x00856FD8;
		BaseGameObjList = (GameObjList *)0x00856FF8;
		FindPlayer = (Find_Player)0x004157E0;
		FindNamedDef = (Find_Named_Def)0x00526860;
		SoldierReInit = (ReInit)0x006C7410;
		Post_ReInit = (PostReInit)0x006B65F0;
		SetMaxHealth = (SetMax)0x00691820;
		SetMaxShieldStrength = (SetMax)0x006930E0;
		Grant_Supplies = (GrantSupplies)0x00470AC0;
		Powerup_Grant = (PowerupGrant)0x006F09F0;
		Get_Armor_Name = (GetArmorName)0x006877D0;
		Get_Armor_Type = (GetArmorType)0x00687750;
		Mark_Owner_Dirty = (MarkOwnerDirty)0x00693740;
		Is_Available_For_Purchase = (IsAvailable)0x006EE010;
		Request_Vehicle = (RequestVehicle)0x006EE1A0;
		ToggleFly = (ToggleFlyMode)0x006CFC80;
	}
	if (Exe == 1) //server.dat
	{
		BuildingGameObjList = (GameObjList *)0x008561D0;
		SmartGameObjList = (GameObjList *)0x008561C0;
		BaseGameObjList = (GameObjList *)0x008561E0;
		FindPlayer = (Find_Player)0x004157E0;
		FindNamedDef = (Find_Named_Def)0x00526100;
		SoldierReInit = (ReInit)0x006C6CB0;
		Post_ReInit = (PostReInit)0x006B5E90;
		SetMaxHealth = (SetMax)0x006910C0;
		SetMaxShieldStrength = (SetMax)0x00692980;
		Grant_Supplies = (GrantSupplies)0x00470230;
		Powerup_Grant = (PowerupGrant)0x006EFFB0;
		Get_Armor_Name = (GetArmorName)0x00687700;
		Get_Armor_Type = (GetArmorType)0x00686FF0;
		Mark_Owner_Dirty = (MarkOwnerDirty)0x00692FE0;
		Is_Available_For_Purchase = (IsAvailable)0x006ED5D0;
		Request_Vehicle = (RequestVehicle)0x006ED760;
		ToggleFly = (ToggleFlyMode)0x006CF520;
	}
	if (Exe == 2) //RH73
	{
		BuildingGameObjList = (GameObjList *)0x08BA05FC;
		SmartGameObjList = (GameObjList *)0x08BA05D8;
		BaseGameObjList = (GameObjList *)0x08BA05D8;
		FindPlayer = (Find_Player)0x080A9CDC;
		FindNamedDef = (Find_Named_Def)0x0836557C;
		SoldierReInit = (ReInit)0x006C6CB0;
		Post_ReInit = (PostReInit)0x081528EC;
		SetMaxHealth = (SetMax)0x08111B88;
		SetMaxShieldStrength = (SetMax)0x08111C9C;
		Grant_Supplies = (GrantSupplies)0x080C472C;
		Powerup_Grant = (PowerupGrant)0x08144268;
		Get_Armor_Name = (GetArmorName)0x0810F87C;
		Get_Armor_Type = (GetArmorType)0x0810F7B4;
		Mark_Owner_Dirty = (MarkOwnerDirty)0x08111D84;
		Is_Available_For_Purchase = (IsAvailable)0x0818C8C4;
		Request_Vehicle = (RequestVehicle)0x0818CAF0;
		ToggleFly = (ToggleFlyMode)0x08168740;
	}
	if (Exe == 3) //RH8
	{
		BuildingGameObjList = (GameObjList *)0x089A9090;
		SmartGameObjList = (GameObjList *)0x089A9078;
		BaseGameObjList = (GameObjList *)0x089A906C;
		FindPlayer = (Find_Player)0x080A510A;
		FindNamedDef = (Find_Named_Def)0x0831890A;
		SoldierReInit = (ReInit)0x0814A676;
		Post_ReInit = (PostReInit)0x08140AB8;
		SetMaxHealth = (SetMax)0x08103C18;
		SetMaxShieldStrength = (SetMax)0x08103D2E;
		Grant_Supplies = (GrantSupplies)0x080BC8D8;
		Powerup_Grant = (PowerupGrant)0x081332C6;
		Get_Armor_Name = (GetArmorName)0x08101AB8;
		Get_Armor_Type = (GetArmorType)0x081019FC;
		Mark_Owner_Dirty = (MarkOwnerDirty)0x08103E20;
		Is_Available_For_Purchase = (IsAvailable)0x008175F7A;
		Request_Vehicle = (RequestVehicle)0x08176184;
		ToggleFly = (ToggleFlyMode)0x08155762;
	}
	if (Exe == 4) //leveledit
	{
		BuildingGameObjList = (GameObjList *)0;
		SmartGameObjList = (GameObjList *)0;
		BaseGameObjList = (GameObjList *)0;
		FindPlayer = (Find_Player)0;
		FindNamedDef = (Find_Named_Def)0;
		SoldierReInit = (ReInit)0;
		Post_ReInit = (PostReInit)0;
		SetMaxHealth = (SetMax)0;
		SetMaxShieldStrength = (SetMax)0;
		Grant_Supplies = (GrantSupplies)0;
		Powerup_Grant = (PowerupGrant)0;
		Get_Armor_Name = (GetArmorName)0;
		Get_Armor_Type = (GetArmorType)0;
		Mark_Owner_Dirty = (MarkOwnerDirty)0;
		Is_Available_For_Purchase = (IsAvailable)0;
		Request_Vehicle = (RequestVehicle)0;
		ToggleFly = (ToggleFlyMode)0;
	}
}

GameObject *As_PhysicalGameObj(GameObject *obj)
{
#ifdef WIN32
	_asm {
		mov ecx, obj
		mov ebx, [ecx]
		mov eax, [ebx+0x24]
		call eax
	}
#else
#ifdef RH8
    char *c = (char *)*(unsigned int *)obj;
	c += 0x28;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#else
	GameObject *o = obj + 4;
	char *c = (char *)*(unsigned int *)o;
	c += 0x2C;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#endif
#endif
}
GameObject *As_CinematicGameObj(GameObject *obj)
{
#ifdef WIN32
	_asm {
		mov ecx, obj
		mov ebx, [ecx]
		mov eax, [ebx+0x98]
		call eax
	}
#else
#ifdef RH8
    char *c = (char *)*(unsigned int *)obj;
	c += 0xC0;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#else
	GameObject *o = obj + 4;
	char *c = (char *)*(unsigned int *)o;
	c += 0xA0;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#endif
#endif
}
GameObject *As_VehicleGameObj(GameObject *obj)
{
#ifdef WIN32
	_asm {
		mov ecx, obj
		mov ebx, [ecx]
		mov eax, [ebx+0x28]
		call eax
	}
#else
#ifdef RH8
    char *c = (char *)*(unsigned int *)obj;
	c += 0x2C;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#else
	GameObject *o = obj + 4;
	char *c = (char *)*(unsigned int *)o;
	c += 0x30;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#endif
#endif
}
GameObject *As_SmartGameObj(GameObject *obj)
{
#ifdef WIN32
	_asm {
		mov ecx, obj
		mov ebx, [ecx]
		mov eax, [ebx+0x2C]
		call eax
	}
#else
#ifdef RH8
    char *c = (char *)*(unsigned int *)obj;
	c += 0x30;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#else
	GameObject *o = obj + 4;
	char *c = (char *)*(unsigned int *)o;
	c += 0x34;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#endif
#endif
}
GameObject *As_DamageableGameObj(GameObject *obj)
{
#ifdef WIN32
	_asm {
		mov ecx, obj
		mov ebx, [ecx]
		mov eax, [ebx+0x3C]
		call eax
	}
#else
#ifdef RH8
    char *c = (char *)*(unsigned int *)obj;
	c += 0x4C;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#else
	GameObject *o = obj + 4;
	char *c = (char *)*(unsigned int *)o;
	c += 0x44;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#endif
#endif
}
GameObject *As_SoldierGameObj(GameObject *obj)
{
#ifdef WIN32
	_asm {
		mov ecx, obj
		mov ebx, [ecx]
		mov eax, [ebx+0x44]
		call eax
	}
#else
#ifdef RH8
    char *c = (char *)*(unsigned int *)obj;
	c += 0x54;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#else
	GameObject *o = obj + 4;
	char *c = (char *)*(unsigned int *)o;
	c += 0x4C;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#endif
#endif
}
GameObject *As_ScriptZoneGameObj(GameObject *obj)
{
#ifdef WIN32
	_asm {
		mov ecx, obj
		mov ebx, [ecx]
		mov eax, [ebx+0x48]
		call eax
	}
#else
#ifdef RH8
    char *c = (char *)*(unsigned int *)obj;
	c += 0x58;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#else
	GameObject *o = obj + 4;
	char *c = (char *)*(unsigned int *)o;
	c += 0x50;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#endif
#endif
}
GameObject *As_BuildingGameObj(GameObject *obj)
{
#ifdef WIN32
	_asm {
		mov ecx, obj
		mov ebx, [ecx]
		mov eax, [ebx+0x40]
		call eax
	}
#else
#ifdef RH8
    char *c = (char *)*(unsigned int *)obj;
	c += 0x50;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#else
	GameObject *o = obj + 4;
	char *c = (char *)*(unsigned int *)o;
	c += 0x48;
	ago *t = (ago *)c;
	ago agox = *t;
	return agox(obj);
#endif
#endif
}
const char *Get_Model(GameObject *obj)
{
	GameObject *o = As_PhysicalGameObj(obj);
	if (o == 0)
	{
		return "DUMMY";
	}
#ifdef WIN32
	_asm{
		mov eax, o
		mov ebx, [eax+0x774]
		mov ecx, [ebx+0x3C]
		mov eax, [ecx]
		mov ebx, [eax+0x10]
		call ebx
	}
#else
	o+=0x774;
	char *p = (char *)*(unsigned int *)o;
	p+=0x54;
	char *r = (char *)*(unsigned int *)p;
#ifndef RH8
	r += 0x1C;
#endif
	char *v = (char *)*(unsigned int *)r;
#ifndef RH8
	r -= 0x1C;
	v += 4;
#endif
	v += 0x14;
	Get_Name *n = (Get_Name*)v;
	Get_Name gn = (Get_Name)*n;
	return gn(r);
#endif
}
int Get_Object_Type(GameObject *obj)
{
	GameObject *o = As_DamageableGameObj(obj);
	if (o == 0)
	{
		return 0;
	}
	char *c = (char *)obj;
	c += 0x764;
	return *(int *)c;
}
DefinitionClass *Get_Definition(GameObject *obj)
{
	char *c = (char *)obj;
	c += 0x6BC;
	return (DefinitionClass *)*(unsigned int *)c;
}
DefinitionClass *Get_Phys_Definition(GameObject *obj)
{
	GameObject *o = As_PhysicalGameObj(obj);
	if (o == 0)
	{
		return 0;
	}
	o+=0x774;
	char *p = (char *)*(unsigned int *)o;
#ifdef WIN32
	p += 0x50;
#else
	p += 0x68;
#endif
	return (DefinitionClass *)*(unsigned int *)p;
}
int Get_Class_ID(DefinitionClass *def)
{
#ifdef WIN32
	_asm{
		mov ecx, def
		mov eax, [ecx]
		mov ebx, [eax+0x20]
		call ebx
	}
#else
#ifdef RH8
    char *c = (char *)*(unsigned int *)def;
	c += 0x24;
	Get_ClassID *gcid = (Get_ClassID *)c;
	Get_ClassID cid = *gcid;
	return cid(def);
#else
	DefinitionClass *d = def + 4;
	char *c = (char *)*(unsigned int *)d;
	c += 0x28;
	Get_ClassID *gcid = (Get_ClassID *)c;
	Get_ClassID cid = *gcid;
	return cid(def);
#endif
#endif
}
const char *Get_Definition_Name(DefinitionClass *def)
{
	char *c = (char *)def;
	c += 0x0C;
	return (const char *)*(unsigned int *)c;
}
unsigned int Get_Definition_ID(DefinitionClass *def)
{
	char *c = (char *)def;
	c += 0x10;
	return (unsigned int)*(unsigned int *)c;
}
void Soldier_Re_Init(GameObject *obj,DefinitionClass *def)
{
#ifdef WIN32
	_asm {
		mov ecx,obj
		mov eax,def
		mov ebx,SoldierReInit
		push eax
		call ebx
	}
#else
	SoldierReInit(obj,def);
#endif
}
DefinitionClass *Find_Named_Definition(const char *name)
{
	return FindNamedDef(name,1);
}
void Post_Re_Init(GameObject *obj)
{
#ifdef WIN32
	_asm {
		mov ecx,obj
		mov ebx,Post_ReInit
		call ebx
	}
#else
	Post_ReInit(obj);
#endif
}
bool Change_Character(GameObject *obj,const char *Preset_Name)
{
	DefinitionClass *def = Find_Named_Definition(Preset_Name);
	if (def == 0)
	{
		return false;
	}
	if (Get_Class_ID(def) != 0x3001)
	{
		return false;
	}
	GameObject *o = As_SoldierGameObj(obj);
	if (o == 0)
	{
		return false;
	}
	Soldier_Re_Init(o,def);
	Post_Re_Init(o);
	return true;
}
const char *WideCharToChar(const wchar_t* ptr)
{
	int length = wcslen(ptr);
	char *text = (char *)malloc(length+1);
	wcstombs(text,ptr,length+1);
	return text;
}
const char *Get_Player_Name(GameObject *obj)
{
	GameObject *o = As_SoldierGameObj(obj);
	char *c = (char *)o;
	if (o == 0)
	{
		return 0;
	}
	c += 0x960;
	char *x = (char *)*(unsigned int *)c;
	if (x == 0)
	{
		return 0;
	}
	x += 0x758;
	return WideCharToChar((const wchar_t *)*(unsigned int *)x);
}
GameObject *Find_Player_GameObj(const char *Name) {
	GameObjListNode *z = BaseGameObjList->head;
	while (z != 0) {
		GameObject *obj = z->obj;
		if (obj != 0 && strstr(Name,Get_Player_Name(obj)) == 0) return obj;
		z = z->next;
	}
	return 0;
}
int Get_Player_ID(GameObject *obj)
{
	GameObject *o = As_SoldierGameObj(obj);
	if (o == 0)
	{
		return 0;
	}
	char *c = (char *)o;
	c += 0x960;
	char *x = (char *)*(unsigned int *)c;
	if (x == 0)
	{
		return 0;
	}
	x += 0x75C;
	return (int)*(unsigned int *)x;
}
GameObject *Get_GameObj(int ID)
{
	unsigned long _ptr = FindPlayer(ID);
	if (_ptr){
#ifdef WIN32
	unsigned char *playerdata = (unsigned char *)_ptr + 0x14;
#else
	unsigned char *playerdata = (unsigned char *)_ptr + 0x10;
#endif
	unsigned char *y = (unsigned char*)*((unsigned char **)playerdata);
	y += 4;
	GameObject *z = (GameObject *)*(GameObject **)y;
	return z;
	} else {
		return NULL;
	}
}
GameObject *Find_Building_By_Class_ID(int Team, int Class_ID)
{
	if (BuildingGameObjList->head == 0)
	{
		return 0;
	}
	GameObjListNode *x = BuildingGameObjList->head;
	while (x != 0)
	{
		GameObject *o = As_BuildingGameObj(x->obj);
		if (o != 0)
		{
			DefinitionClass *d = Get_Definition(x->obj);
			if (Get_Class_ID(d) == Class_ID)
			{
				if ((Get_Object_Type(o) == Team) || (Team == 2))
				{
					return o;
				}
			}
		}
		x = x->next;
	}
	return 0;
}
GameObject *Find_Building_By_Team(int Team)
{
	if (BuildingGameObjList->head == 0)
	{
		return 0;
	}
	GameObjListNode *x = BuildingGameObjList->head;
	while (x != 0)
	{
		GameObject *o = As_BuildingGameObj(x->obj);
		if (o != 0)
		{
			if (Get_Object_Type(o) == Team)
			{
				return o;
			}
		}
		x = x->next;
	}
	return 0;
}
GameObject *Find_Building_By_Name(int Team, const char *Preset_Name)
{
	if (BuildingGameObjList->head == 0)
	{
		return 0;
	}
	GameObjListNode *x = BuildingGameObjList->head;
	while (x != 0)
	{
		GameObject *o = As_BuildingGameObj(x->obj);
		if (o != 0)
		{
			DefinitionClass *d = Get_Definition(x->obj);
			if (stricmp(Get_Definition_Name(d),Preset_Name) == 0)
			{
				if ((Get_Object_Type(o) == Team) || (Team == 2))
				{
					return o;
				}
			}
		}
		x = x->next;
	}
	return 0;
}
void Kill_All_Buildings_By_Team(int Team)
{
	if (BuildingGameObjList->head == 0)
	{
		return;
	}
	GameObjListNode *x = BuildingGameObjList->head;
	while (x != 0)
	{
		GameObject *o = As_BuildingGameObj(x->obj);
		if (o != 0)
		{
			if (Get_Object_Type(o) == Team)
			{
				Commands->Apply_Damage(o,10000,"Explosive",0);
			}
		}
		x = x->next;
	}
}
void Damage_All_Buildings_By_Team(int Team,float Damage,const char *Warhead)
{
	if (BuildingGameObjList->head == 0)
	{
		return;
	}
	GameObjListNode *x = BuildingGameObjList->head;
	while (x != 0)
	{
		GameObject *o = As_BuildingGameObj(x->obj);
		if (o != 0)
		{
			if (Get_Object_Type(o) == Team)
			{
				Commands->Apply_Damage(o,Damage,Warhead,0);
			}
		}
		x = x->next;
	}
}
void Damage_All_Buildings_By_Team_Nearest(int Team,float Damage,const char *Warhead,const Vector3 &Position,float Distance)
{
	if (BuildingGameObjList->head == 0)
	{
		return;
	}
	GameObjListNode *x = BuildingGameObjList->head;
	while (x != 0)
	{
		GameObject *o = As_BuildingGameObj(x->obj);
		if (o != 0)
		{
			if (Get_Object_Type(o) == Team)
			{
				Vector3 pos = Commands->Get_Position(o);
				Vector3 pos2 = Position;
				pos.Z = 0;
				pos2.Z = 0;
				float dist = Commands->Get_Distance(pos,pos2);
				if (dist <= Distance)
				{
					Commands->Apply_Damage(o,Damage,Warhead,0);
				}
			}
		}
		x = x->next;
	}
}
void Damage_All_Buildings_By_Team_Nearest_Scale(int Team,float Damage,const char *Warhead,const Vector3 &Position,float Distance)
{
	if (BuildingGameObjList->head == 0)
	{
		return;
	}
	GameObjListNode *x = BuildingGameObjList->head;
	while (x != 0)
	{
		GameObject *o = As_BuildingGameObj(x->obj);
		if (o != 0)
		{
			if (Get_Object_Type(o) == Team)
			{
				Vector3 pos = Commands->Get_Position(o);
				Vector3 pos2 = Position;
				pos.Z = 0;
				pos2.Z = 0;
				float dist = Commands->Get_Distance(pos,pos2);
				if (dist <= Distance)
				{
					float scaledamage = (Damage - (dist * (Damage/Distance)));
					Commands->Apply_Damage(o,scaledamage,Warhead,0);
				}
			}
		}
		x = x->next;
	}
}
void Repair_All_Buildings_By_Team(int Team,int ConstructionYardID,float Health)
{
	if (BuildingGameObjList->head == 0)
	{
		return;
	}
	GameObjListNode *x = BuildingGameObjList->head;
	while (x != 0)
	{
		GameObject *o = As_BuildingGameObj(x->obj);
		if (o != 0)
		{
			if ((Get_Object_Type(o) == Team) && (Commands->Get_ID(o) != ConstructionYardID))
			{
				float amount = Commands->Get_Health(o);
				if (amount>0)
				{
					Commands->Set_Health(o,(amount+Health));
				}
			}
		}
		x = x->next;
	}
}
void Damage_All_Objects_Area(float Damage,const char *Warhead,const Vector3 &Position,float Distance,GameObject *Host,GameObject *Damager) {
	GameObjListNode *x = BuildingGameObjList->head;
	while (x != 0) {
		GameObject *obj = x->obj;
		if (obj != 0) {
			Vector3 ObjPosition = Commands->Get_Position(obj);
			Vector3 TestPosition = Position;
			ObjPosition.Z = 0;
			TestPosition.Z = 0;
			if (Commands->Get_Distance(ObjPosition,TestPosition) <= Distance && Commands->Get_ID(obj) != Commands->Get_ID(Host)) Commands->Apply_Damage(obj,Damage,Warhead,Damager);
		}
		x = x->next;
	}
	GameObjListNode *z = BaseGameObjList->head;
	while (z != 0) {
		GameObject *obj = z->obj;
		if (obj != 0) {
			Vector3 ObjPosition = Commands->Get_Position(obj);
			Vector3 TestPosition = Position;
			ObjPosition.Z = 0;
			TestPosition.Z = 0;
			if (Commands->Get_Distance(ObjPosition,TestPosition) <= Distance && Commands->Get_ID(obj) != Commands->Get_ID(Host)) Commands->Apply_Damage(obj,Damage,Warhead,Damager);
		}
		z = z->next;
	}
}
void Damage_All_Vehicles_Area(float Damage,const char *Warhead,const Vector3 &Position,float Distance,GameObject *Host,GameObject *Damager) {
	GameObjListNode *x = BuildingGameObjList->head;
	while (x != 0) {
		GameObject *obj = As_VehicleGameObj(x->obj);
		if (obj != 0) {
			Vector3 ObjPosition = Commands->Get_Position(obj);
			Vector3 TestPosition = Position;
			ObjPosition.Z = 0;
			TestPosition.Z = 0;
			if (Commands->Get_Distance(ObjPosition,TestPosition) <= Distance && Commands->Get_ID(obj) != Commands->Get_ID(Host)) Commands->Apply_Damage(obj,Damage,Warhead,Damager);
		}
		x = x->next;
	}
	GameObjListNode *z = BaseGameObjList->head;
	while (z != 0) {
		GameObject *obj = As_VehicleGameObj(z->obj);
		if (obj != 0) {
			Vector3 ObjPosition = Commands->Get_Position(obj);
			Vector3 TestPosition = Position;
			ObjPosition.Z = 0;
			TestPosition.Z = 0;
			if (Commands->Get_Distance(ObjPosition,TestPosition) <= Distance && Commands->Get_ID(obj) != Commands->Get_ID(Host)) Commands->Apply_Damage(obj,Damage,Warhead,Damager);
		}
		z = z->next;
	}
}
GameObject *Find_Smart_Object_By_Team(int Team)
{
	if (SmartGameObjList->head == 0)
	{
		return 0;
	}
	GameObjListNode *x = SmartGameObjList->head;
	while (x != 0)
	{
		GameObject *o = As_SmartGameObj(x->obj);
		if (o != 0)
		{
			if (Get_Object_Type(o) == Team)
			{
				return o;
			}
		}
		x = x->next;
	}
	return 0;
}
GameObject *Find_Object_By_Team(int Team)
{
	if (BaseGameObjList->head == 0)
	{
		return 0;
	}
	GameObjListNode *x = BaseGameObjList->head;
	while (x != 0)
	{
		GameObject *o = x->obj;
		if (o != 0)
		{
			if (Get_Object_Type(o) == Team)
			{
				return o;
			}
		}
		x = x->next;
	}
	return 0;
}
GameObject *Find_Non_Player_Object_By_Team(int Team)
{
	if (SmartGameObjList->head == 0)
	{
		return 0;
	}
	GameObjListNode *x = SmartGameObjList->head;
	while (x != 0)
	{
		GameObject *o = As_SmartGameObj(x->obj);
		if (o != 0)
		{
			if ((Get_Object_Type(o) == Team) && (!Commands->Is_A_Star(o)))
			{
				return o;
			}
		}
		x = x->next;
	}
	return 0;
}
GameObject *Find_Object_By_Preset(int Team,const char *Preset_Name)
{
	if (BaseGameObjList->head == 0)
	{
		return 0;
	}
	GameObjListNode *x = BaseGameObjList->head;
	while (x != 0)
	{
		GameObject *o = x->obj;
		if (o != 0)
		{
			DefinitionClass *d = Get_Definition(x->obj);
			if (stricmp(Get_Definition_Name(d),Preset_Name))
			{
				if ((Get_Object_Type(o) == Team) || (Team == 2))
				{
					return o;
				}
			}
		}
		x = x->next;
	}
	return 0;
}
GameObject *Find_Base_Defense(int Team) {
	if (Team == 0) return Find_Building_By_Name(0,"mp_Nod_Obelisk");
	return Find_Building_By_Name(1,"mp_GDI_Advanced_Guard_Tower");
}
GameObject *Find_Power_Plant(int Team)
{
	return Find_Building_By_Class_ID(Team,0xD003);
}
GameObject *Find_Refinery(int Team)
{
	return Find_Building_By_Class_ID(Team,0xD002);
}
GameObject *Find_Repair_Bay(int Team)
{
	return Find_Building_By_Class_ID(Team,0xD009);
}
GameObject *Find_Soldier_Factory(int Team)
{
	return Find_Building_By_Class_ID(Team,0xD004);
}
GameObject *Find_Airstrip(int Team)
{
	return Find_Building_By_Class_ID(Team,0xD006);
}
GameObject *Find_War_Factory(int Team)
{
	return Find_Building_By_Class_ID(Team,0xD007);
}
GameObject *Find_Vehicle_Factory(int Team)
{
	GameObject *o = Find_Airstrip(Team);
	if (o != 0)
	{
		return o;
	}
	return Find_War_Factory(Team);
}
GameObject *Find_Com_Center(int Team)
{
	return Find_Building_By_Class_ID(Team,0xD008);
}
bool Is_Building(GameObject *obj)
{
	if (As_BuildingGameObj(obj) != 0)
	{
		return true;
	}
	return false;
}
bool Is_Soldier(GameObject *obj)
{
	if (As_SoldierGameObj(obj) != 0)
	{
		return true;
	}
	return false;
}
bool Is_Vehicle(GameObject *obj)
{
	if (As_VehicleGameObj(obj) != 0)
	{
		return true;
	}
	return false;
}
bool Is_Cinematic(GameObject *obj)
{
	if (As_CinematicGameObj(obj) != 0)
	{
		return true;
	}
	return false;
}
bool Is_ScriptZone(GameObject *obj)
{
	if (As_ScriptZoneGameObj(obj) != 0)
	{
		return true;
	}
	return false;
}
bool Is_TrackedVehicle(GameObject *obj)
{
	GameObject *o = As_PhysicalGameObj(obj);
	if (o == 0)
	{
		return false;
	}
	int Class_ID = Get_Class_ID(Get_Phys_Definition(o));
	if (Class_ID != 0x900C)
	{
		return false;
	}
	return true;
}
bool Is_VTOLVehicle(GameObject *obj)
{
	GameObject *o = As_PhysicalGameObj(obj);
	if (o == 0)
	{
		return false;
	}
	int Class_ID = Get_Class_ID(Get_Phys_Definition(o));
	if (Class_ID != 0x900D)
	{
		return false;
	}
	return true;
}
bool Is_WheeledVehicle(GameObject *obj)
{
	GameObject *o = As_PhysicalGameObj(obj);
	if (o == 0)
	{
		return false;
	}
	int Class_ID = Get_Class_ID(Get_Phys_Definition(o));
	if (Class_ID != 0x9006)
	{
		return false;
	}
	return true;
}
bool Is_Motorcycle(GameObject *obj)
{
	GameObject *o = As_PhysicalGameObj(obj);
	if (o == 0)
	{
		return false;
	}
	int Class_ID = Get_Class_ID(Get_Phys_Definition(o));
	if (Class_ID != 0x9002)
	{
		return false;
	}
	return true;
}
void Set_Max_Health(GameObject *obj,float health)
{
	GameObject *o = As_DamageableGameObj(obj);
	if (o == 0)
	{
		return;
	}
	unsigned int *def = (unsigned int *)(o+0x72C);
#ifdef WIN32
	_asm {
		mov ecx,def
		mov eax,health
		mov ebx,SetMaxHealth
		push eax
		call ebx
	}
#else
	SetMaxHealth(def,health);
#endif
	Commands->Set_Health(obj,health);
}
void Set_Max_Shield_Strength(GameObject *obj,float shieldstrength)
{
	GameObject *o = As_DamageableGameObj(obj);
	if (o == 0)
	{
		return;
	}
	unsigned int *def = (unsigned int *)(o+0x72C);
#ifdef WIN32
	_asm {
		mov ecx,def
		mov eax,shieldstrength
		mov ebx,SetMaxShieldStrength
		push eax
		call ebx
	}
#else
	SetMaxShieldStrength(def,shieldstrength);
#endif
	Commands->Set_Shield_Strength(obj,shieldstrength);
}
GameObject *Find_First_Player(int Team)
{
	if (BaseGameObjList->head == 0)
	{
		return 0;
	}
	GameObjListNode *x = BaseGameObjList->head;
	while (x != 0)
	{
		GameObject *o = x->obj;
		if (o != 0)
		{
			if (Commands->Is_A_Star(o))
			{
				if ((Get_Object_Type(o) == Team) || (Team == 2))
				{
					return o;
				}
			}
		}
		x = x->next;
	}
	return 0;
}
//doesnt work for CinematicGameObjs
float Get_Animation_Frame(GameObject *obj)
{
	GameObject *o = As_PhysicalGameObj(obj);
	if (o == 0)
	{
		return 0;
	}
	char *c = (char *)o+0x778;
	float a = (float)*(float *)(c+14);
	return a;
}
void Grant_Refill(GameObject *obj)
{
	GameObject *o = As_SoldierGameObj(obj);
	if (o != 0)
	{
		Grant_Supplies(obj);
	}
}
void Grant_Powerup(GameObject *obj,const char *Preset_Name)
{
	GameObject *o = As_SmartGameObj(obj);
	if (o != 0)
	{
		DefinitionClass *def = Find_Named_Definition(Preset_Name);
#ifdef WIN32
		_asm {
			mov ecx,def
			mov eax,o
			mov ebx,Powerup_Grant
			push 1
			push 0
			push eax
			call ebx
		}
#else
		Powerup_Grant(def,o,0,true);
#endif
	}
}
GameObject *Get_Vehicle(GameObject *obj)
{
	GameObject *o = As_SoldierGameObj(obj);
	if (o != 0)
	{
		char *c = (char *)o;
		c += 0x98C;
		unsigned long *l = (unsigned long *)c;
		GameObject *vehicle = (GameObject *)*l;
		if (vehicle != 0)
		{
			GameObject *v = As_VehicleGameObj(vehicle);
			return v;
		}
		return 0;
	}
	return 0;
}
const char *Get_Shield_Type(GameObject *obj)
{
	GameObject *o = As_DamageableGameObj(obj);
	if (o == 0)
	{
		return "";
	}
	unsigned int *def = (unsigned int *)(o+0x72C);
#ifdef WIN32
	def+=0x6;
#else
	def+=0x5;
#endif
	return Get_Armor_Name(*def);
}
const char *Get_Skin(GameObject *obj)
{
	GameObject *o = As_DamageableGameObj(obj);
	if (o == 0)
	{
		return "";
	}
	unsigned int *def = (unsigned int *)(o+0x72C);
#ifdef WIN32
	def+=0x3;
#else
	def+=0x2;
#endif
	return Get_Armor_Name(*def);
}
void Set_Skin(GameObject *obj,const char *Skintype)
{
	GameObject *o = As_DamageableGameObj(obj);
	if (o == 0)
	{
		return;
	}
	unsigned int *def = (unsigned int *)(o+0x72C);
	unsigned int skin = Get_Armor_Type(Skintype);
#ifdef WIN32
	unsigned int *sk = def+0x3;
#else
	unsigned int *sk = def+0x2;
#endif
	*sk = skin;
#ifdef WIN32
	_asm {
		mov ecx,def
		mov ebx,Mark_Owner_Dirty
		call ebx
	}
#else
	Mark_Owner_Dirty(def);
#endif
}
void Create_Vehicle(const char *Preset_Name, float Delay, GameObject *Owner, int Team)
{
	GameObject *o = 0;
	if (Owner != 0)
	{
		o = As_SoldierGameObj(Owner);
	}
	DefinitionClass *def = Find_Named_Definition(Preset_Name);
	if (def != 0)
	{
		if (Get_Vehicle(o) == 0)
		{
			GameObject *factory = Find_Vehicle_Factory(Team);
			if (factory != 0)
			{
				bool IsAvail;
#ifdef WIN32
				_asm {
					mov ecx,factory
					mov ebx,Is_Available_For_Purchase
					call ebx
					mov IsAvail, al;
				}
#else
				IsAvail = Is_Available_For_Purchase(factory);
#endif
				if (IsAvail == true)
				{
					unsigned int ID = Get_Definition_ID(def);
#ifdef WIN32
					_asm {
						mov ecx,factory
						mov ebx,Request_Vehicle
						mov eax,o
						push eax
						mov eax,Delay
						push eax
						mov eax,ID
						push eax
						call ebx
					}
#else
					Request_Vehicle(factory,ID,Delay,o);
#endif
				}
			}
		}
	}
}
void Toggle_Fly_Mode(GameObject *obj)
{
	GameObject *o = As_SoldierGameObj(obj);
	if (o != 0)
	{
#ifdef WIN32
		_asm {
			mov ecx,o
			mov ebx,ToggleFly
			call ebx
		}
#else
		ToggleFly(o);
#endif
		Commands->Enable_Collisions(o);
	}
}
/*
commented out for now since I dont need them yet
GameObject *Get_Driver(GameObject *obj)
{
}
GameObject *Get_Gunner(GameObject *obj)
{
}
bool Contains_Occupant(GameObject *obj)
{
}
GameObject *Get_Occupant(int seat)
{
}
int Get_Occupant_Count()
{
}*/
