#include "stdafx.h"
#include "scripts.h"
#include "engine.h"
#include "RenAlert.h"

//////////////RA_Thief_Script//////////////

/*
NeoSaber's Note: This script is currently obsolete. It's been
replaced with the combination of the three scripts RA_Allied_Thief, 
RA_Soviet_Refinery_Controller, and RA_Soviet_Refinery_Theft_Zone
*/

void RA_Thief_Script::Entered(GameObject * obj,GameObject *enter)
{
	//0 = Soviet, 1 = Allies for team #
	if ((enabled != false ) && (Get_Int_Parameter("Thief_Preset_ID") == Commands->Get_Preset_ID(enter)))
	{
		enabled = false;
		Commands->Give_Money(enter,Get_Float_Parameter("Credits_To_Award"),true);
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Prevent_Theft_Timer"),1);
	}
}

void RA_Thief_Script::Timer_Expired(GameObject * obj,int number)
{
	enabled = true;
}

void RA_Thief_Script::Created(GameObject * obj)
{
	enabled = true;
}

void RA_Thief_Script::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&enabled);
}

//////////////RA_Soviet_Defence//////////////

void RA_Soviet_Defence::Created(GameObject * obj)
{
	Vector3 pos,pos1,pos2,pos3;
	GameObject * object;
	objtype = Commands->Get_Player_Type(obj);
	Commands->Enable_Hibernation(obj,false);
	Commands->Innate_Enable(obj);
	Commands->Enable_Enemy_Seen(obj,true);
	pos = Commands->Get_Position(obj);
	pos1.X = pos.X - 10;
	pos1.Y = pos.Y - 10;
	pos1.Z = pos.Z + 2;
	pos2.X = pos.X + 10;
	pos2.Y = pos.Y;
	pos2.Z = pos.Z + 2;
	pos3.X = pos.X + 10;
	pos3.Y = pos.Y - 10;
	pos3.Z = pos.Z + 2;
	object = Commands->Create_Object("Invisible_Object", pos1);
	if (object)
		id1 = Commands->Get_ID(object);
	object = Commands->Create_Object("Invisible_Object", pos2);
	if (object)
		id2 = Commands->Get_ID(object);
	object = Commands->Create_Object("Invisible_Object", pos3);
	if (object)
		id3 = Commands->Get_ID(object);
	Commands->Start_Timer(obj, this, 10, 1);
}
void RA_Soviet_Defence::Enemy_Seen(GameObject * obj,GameObject * seen)
{
	ActionParamsStruct params;
	Vector3 pos,pos2;
	float distance;
	float minattack,maxattack;
	float attacktimer;
	int IgnorePreset;
	IgnorePreset = Commands->Get_Preset_ID(seen);
	if ((IgnorePreset != Get_Int_Parameter("Spy_Preset_ID")) && (IgnorePreset != Get_Int_Parameter("Aircraft_Preset_ID"))) 
	{
		pos = Commands->Get_Position(obj);
		pos2 = Commands->Get_Position(seen);
		distance = Commands->Get_Distance(pos2,pos);
		minattack = Get_Float_Parameter("MinAttackDistance");
		if (distance >= minattack) 
		{
			maxattack = Get_Float_Parameter("MaxAttackDistance");
			params.Set_Basic(this,100,2,-1);
			params.Set_Attack_v58(seen,maxattack,0.0,true,false);
			Commands->Action_Attack(obj,params);
			attacktimer = Get_Float_Parameter("AttackTimer");
			Commands->Start_Timer(obj,this,attacktimer,2);
		}
	}
}
void RA_Soviet_Defence::Action_Complete(GameObject * obj,int action,ActionCompleteReason reason)
{
	if (action == 2) {
		Commands->Action_Reset(obj,100);
	}
}
void RA_Soviet_Defence::Timer_Expired(GameObject * obj,int number)
{
	ActionParamsStruct var;
	GameObject * object;
	float f;
	switch (number)
	{
	case 1:
		f = Commands->Get_Random(0.0f, 2.9999f);
		switch (__min(int(f), 2))
		{
		case 0:
			object = Commands->Find_Object(id1);
			if (object)
			{
				var.Set_Basic(this, 70, 1, -1);
				var.Set_Attack(object, 0.0, 0.0, true);
				Commands->Action_Attack(obj, var);
			}
			break;
		case 1:
			object = Commands->Find_Object(id2);
			if (object)
			{
				var.Set_Basic(this, 70, 1, -1);
				var.Set_Attack(object, 0.0, 0.0, true);
				Commands->Action_Attack(obj, var);
			}
			break;
		default:
			object = Commands->Find_Object(id3);
			if (object)
			{
				var.Set_Basic(this, 70, 1, -1);
				var.Set_Attack(object, 0.0, 0.0, true);
				Commands->Action_Attack(obj, var);
			}
		}
	Commands->Start_Timer(obj, this, 10, 1);
	break;
	case 2:
		Commands->Action_Reset(obj, 100);
		break;
	}
}
void RA_Soviet_Defence::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&id1);
	Auto_Save_Variable(2,4,&id2);
	Auto_Save_Variable(3,4,&id3);
	Auto_Save_Variable(4,4,&objtype);
}

//////////////RA_Repair_Controller//////////////

void RA_Repair_Controller::Killed(GameObject * obj,GameObject * shooter)
{
	Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("ScriptZoneID")));
}

//////////////RA_Repair_Script//////////////

void RA_Repair_Script::Timer_Expired(GameObject * obj,int number)
{
	Vector3 pos1;
	Vector3 pos2;
	float distance;
	pos1 = Commands->Get_Position(obj);
	pos2 = Commands->Get_Position(Commands->Find_Object(number));
	distance = Commands->Get_Distance(pos1,pos2);
	if (distance <= 10.0)
	{
		float Max_Health = Commands->Get_Max_Health(Commands->Find_Object(number));
		float Health = Commands->Get_Health(Commands->Find_Object(number));
		float Max_Shield_Strength = Commands->Get_Max_Shield_Strength(Commands->Find_Object(number));
		float Shield_Strength = Commands->Get_Shield_Strength(Commands->Find_Object(number));
		if (Health < Max_Health)
		{
			Commands->Set_Health(Commands->Find_Object(number), Health + (float)40.0);
		}
		if (Shield_Strength < Max_Shield_Strength)
		{
			Commands->Set_Shield_Strength(Commands->Find_Object(number), Shield_Strength + (float)40.0);
		}
		Commands->Start_Timer(obj, this, 1.0, number);
	}
}
void RA_Repair_Script::Entered(GameObject * obj,GameObject *enter)
{
	if(Commands->Get_Player_Type(enter) == Get_Int_Parameter("TeamSelection"))
	{
		int preset = Commands->Get_Preset_ID(enter);
		switch(preset)
		{
		case 82080019: //Soviet Transport Helicopter
		case 82080024: //Soviet Ore Truck (AI Controlled)
		case 82080026: //Allied Medium Tank
		case 82080029: //Allied Ore Truck (AI Controlled)
		case 82080043: //Allied Apache
		case 82080048: //Allied APC
		case 82080051: //Allied Mobile Artillery
		case 82080052: //Allied Light Tank
		case 82080055: //Soviet Mammoth Tank
		case 82080056: //Soviet Heavy Tank
		case 82080082: //Allied Phase Tank
		case 82080115: //Soviet V2 Launcher
		case 82080121: //Allied Ranger
		case 82080124: //Soviet Hind
		case 82080141: //Allied Ore Truck (Player Controlled)
		case 82080144: //Soviet Ore Truck (Player Controlled)
		case 82080164: //Soviet Tesla Tank
		case 82080178: //Allied Mine Layer
		case 82080181: //Soviet Mine Layer
		case 82080182: //Soviet Demolition Truck
		case 82080183: //Allied Demolition Truck
		case 82080185: //Soviet Attack Sub
		case 82080188: //Soviet MAD Tank
		case 82080189: //Allied Supply Truck
		case 82080190: //Soviet Supply Truck
		case 82080192: //Allied Destroyer
		case 82080193: //Allied Gunboat
		case 82080194: //Allied Naval Transport
		case 82080195: //Soviet Missile Sub
		case 82080196: //Soviet Naval Transport
			Commands->Start_Timer(obj, this, 1.0, Commands->Get_ID(enter));
		}
	}
}

//////////////RA_Soviet_Refinery_Controller//////////////

void RA_Soviet_Refinery_Controller::Killed(GameObject *obj, GameObject *shooter)
{
	GameObject *zone = Commands->Find_Object(Get_Int_Parameter("ScriptZoneID"));
	Commands->Send_Custom_Event(obj, zone, 0, 0, 0.0);
}

//////////////RA_Soviet_Refinery_Theft_Zone//////////////

void RA_Soviet_Refinery_Theft_Zone::Created(GameObject *obj)
{
	refinery = true;
}

void RA_Soviet_Refinery_Theft_Zone::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if(message == 0)
	{
		refinery = false;
	}
}

void RA_Soviet_Refinery_Theft_Zone::Entered(GameObject *obj, GameObject*enter)
{
	if ((refinery == true ) && (Get_Int_Parameter("Thief_Preset_ID") == Commands->Get_Preset_ID(enter)))
	{
		Commands->Send_Custom_Event(obj, enter, 1, /*sovietID*/0, 0.0);
	}
}

void RA_Soviet_Refinery_Theft_Zone::Exited(GameObject *obj, GameObject *exit)
{
	if ((Get_Int_Parameter("Thief_Preset_ID") == Commands->Get_Preset_ID(exit)))
	{
		Commands->Send_Custom_Event(obj, exit, 0, 0, 0.0);
	}
}

void RA_Soviet_Refinery_Theft_Zone::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&refinery);
}

//////////////RA_Allied_Thief//////////////

void RA_Allied_Thief::Created(GameObject *obj)
{
	stealing = false;
	ready = true;
}

void RA_Allied_Thief::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if(message == 1)
	{
		stealing = true;

		if(ready == true) //check if thief has entered zone before timer expired
		{
			ready = false; //prevent another zone entry theft for now
			Commands->Start_Timer(obj,this,0.0,1); //immediately grant money
		}
	}
	else if(message == 0)
	{
		stealing = false;
	}
}

void RA_Allied_Thief::Timer_Expired(GameObject *obj, int number)
{
	if(stealing == true)
	{
		//Give to teammates
		Commands->Give_Money(obj,Get_Float_Parameter("Credits_To_Award"),true);
		
		//Steal from enemy (code doesn't work, so it was removed)
		//GameObject *victim = 0 //Don't have a way to handle this yet, 0 was a placeholder
		//Commands->Give_Money(victim, (-1 * (Get_Float_Parameter("Credits_To_Award"))), true);

		Commands->Start_Timer(obj,this,Get_Float_Parameter("Prevent_Theft_Timer"),1);
		ready = false; // just making sure this stays false for now
	}
	else if(stealing == false)
	{
		ready = true; // all timers have expired, thief can now get credits for zone entry again
	}
}

void RA_Allied_Thief::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&stealing);
	Auto_Save_Variable(2,1,&ready);
}

//////////////RA_Infantry_Spy//////////////

void RA_Infantry_Spy::Created(GameObject *obj)
{
	Commands->Set_Is_Visible(obj,false);
}

//////////////RA_Infantry_NotSpy//////////////

void RA_Infantry_NotSpy::Created(GameObject *obj)
{
	Commands->Set_Is_Visible(obj,true);
}

//////////////RA_Helipad_Zone//////////////

void RA_Helipad_Zone::Entered(GameObject *obj, GameObject *enter)
{
	if(Commands->Get_Player_Type(enter) == Get_Int_Parameter("TeamSelection"))
	{
		Commands->Start_Timer(obj, this, 1.0, Commands->Get_ID(enter));
	}
}

void RA_Helipad_Zone::Timer_Expired(GameObject *obj, int number)
{
	//Distance checking code copied from RA_Repair_Script
	Vector3 pos1;
	Vector3 pos2;
	float distance;
	pos1 = Commands->Get_Position(obj);
	pos2 = Commands->Get_Position(Commands->Find_Object(number));
	distance = Commands->Get_Distance(pos1,pos2);

	if (distance <= 10.0) //reloads vehicle up to 10m from zone center
	{
		if(Commands->Get_Preset_ID(Commands->Find_Object(number)) == Get_Int_Parameter("Apache_Preset_ID"))
		{
			Commands->Give_Powerup(Commands->Find_Object(number),Get_Parameter("Apache_Reload_Powerup"),0);
		}
		else if(Commands->Get_Preset_ID(Commands->Find_Object(number)) == Get_Int_Parameter("Hind_Preset_ID"))
		{
			Commands->Give_Powerup(Commands->Find_Object(number),Get_Parameter("Hind_Reload_Powerup"),0);
		}

		Commands->Start_Timer(obj, this, Get_Float_Parameter("Reload_Interval"), number);
	}
}

//////////////RA_MineLayer//////////////

void RA_MineLayer::Created(GameObject *obj)
{
	driverID = 0;
}

void RA_MineLayer::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if(message == CUSTOM_EVENT_VEHICLE_ENTER)
	{
		driverID = Commands->Get_ID(sender); //record driver's ID
	}
	else if(message == CUSTOM_EVENT_VEHICLE_EXIT)
	{
		driverID = 0; //driver jumped out, forget ID
	}

}

void RA_MineLayer::Damaged(GameObject *obj, GameObject *damager, float damage)
{
	if(driverID != 0) //If there's no driver, do nothing
	{
		int hitter; //This will store the ID of the damager
		hitter = Commands->Get_ID(damager);

		if(hitter == driverID)//checking if the driver 'shot' the vehicle
		{
			if(damage == 0.0)//checking if precise ammount of damage was done
			{
				Commands->Send_Custom_Event(obj, Commands->Find_Object(Get_Int_Parameter("Mine_Manager_ID")), 300300, driverID, 0.0);
			}
		}
	}
}

void RA_MineLayer::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&driverID);
}

//////////////RA_Mine//////////////

void RA_Mine::Created(GameObject *obj)
{
	//Copied Code: I assume this 'activates' the mine or something...
	Commands->Enable_Hibernation(obj,false);
	Commands->Innate_Enable(obj);
	Commands->Enable_Enemy_Seen(obj,true);

	int ap_check;
	int at_check;

	ap_check = Get_Int_Parameter("Is_Anti-Personnel");
	at_check = Get_Int_Parameter("Is_Anti-Tank");

	if(ap_check == 0)
	{
		AP_mine = false;
	}
	else
	{
		AP_mine = true;
	}

	if(at_check == 0)
	{
		AT_mine = false;
	}
	else
	{
		AT_mine = true;
	}

}

void RA_Mine::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if(message == 656565) //Is the mine manager saying something?
	{
		ownerID = Get_Player_ID(Commands->Find_Object(param));
	}
}

void RA_Mine::Enemy_Seen(GameObject *obj, GameObject *seen)
{
	/*Note: The mine will detonate as soon as it sees its target.
	Therefore the proximity range is the 'Sight Range' on the vehicle
	*/
	if(AP_mine) //Is this mine anti-personnel?
	{
		if(Commands->Is_A_Star(seen))//Is it a player?
		{
			GameObject *damager = Get_GameObj(ownerID);
			Commands->Set_Player_Type(obj, 2); //Change teams to avoid friendly fire
			Commands->Apply_Damage(obj,Get_Float_Parameter("Trigger_Damage"),Get_Parameter("Trigger_Warhead"),damager); //Die Infidel!
			return; //the mine is dead, end now
		}
	}

	if(AT_mine) //Is this mine anti-tank?
	{
		if(!Commands->Is_A_Star(seen))//Is it a vehicle?
		{
			GameObject *damager = Commands->Find_Object(ownerID);  //Temp code, only works until owner is killed/buys a new soldier
			Commands->Set_Player_Type(obj, 2); //Change teams to avoid friendly fire
			Commands->Apply_Damage(obj,Get_Float_Parameter("Trigger_Damage"),Get_Parameter("Trigger_Warhead"), damager); //Good-bye cruel world!
			return; //the mine is dead, end now
		}
	}
}

void RA_Mine::Destroyed(GameObject *obj)
{
	//Blaaargh! I'm dead!
	Commands->Send_Custom_Event(obj, Commands->Find_Object(Get_Int_Parameter("Mine_Manager_ID")), 200200, Commands->Get_Player_Type(obj), 0.0);
}

void RA_Mine::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&AP_mine);
	Auto_Save_Variable(2,1,&AT_mine);
	Auto_Save_Variable(3,4,&ownerID);
}

//////////////RA_Mine_Manager//////////////

void RA_Mine_Manager::Created(GameObject *obj)
{
	all_mines = 0;
	sov_mines = 0;
}

void RA_Mine_Manager::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	// message 300300: MineLayer requesting Mine placement
	// message 200200: Mine announcing its destruction
	// message 656565: MineManager informing Mine of its Owner
	// param is driver's ID number

    /*Variables moved within the 'if's so they aren't created unless
	the mesage is valid. No need to take up space if it isn't needed*/

	if(message == 300300)
	{
		int team = Commands->Get_Player_Type(Commands->Find_Object(param));

		if(team == 0)//check if this is a soviet request
		{
			int limit = Get_Int_Parameter("Mine_Limit");

			if(sov_mines < limit) //is team under the limit
			{
				//Under limit, request approved, mine created
				sov_mines++;
				GameObject *mine;
				mine = Commands->Create_Object_At_Bone(sender,Get_Parameter("Soviet_Mine"),Get_Parameter("BoneName"));
				Commands->Send_Custom_Event(obj, mine, 656565, param, 1.0);
			}
			else
			{
				//Team at mine limit, request denied, refunding ammo
				Commands->Give_Powerup(sender, Get_Parameter("Mine_Reload"), false);
			}
		}
		else if(team == 1)//check if its an allied request
		{
			int limit = Get_Int_Parameter("Mine_Limit");

			if(all_mines < limit) //is team under the limit
			{
				//Under limit, request approved, mine created
				all_mines++;
				GameObject *mine;
				mine = Commands->Create_Object_At_Bone(sender,Get_Parameter("Allied_Mine"),Get_Parameter("BoneName"));
				Commands->Send_Custom_Event(obj, mine, 656565, param, 1.0);
			}
			else
			{
				//Team at mine limit, request denied, refunding ammo
				Commands->Give_Powerup(sender, Get_Parameter("Mine_Reload"), false);
			}
		}
	}
	else if(message == 200200)
	{
		int team = Commands->Get_Player_Type(Commands->Find_Object(param));

		if(team == 0)//Is this a soviet mine?
		{
			//A moment of silence for out fallen comrade
			sov_mines--;
		}
		else if(team == 1)//or is it an allied mine?
		{
			//Why, God?! Why did it have to die?!
			all_mines--;
		}
	}
}

void RA_Mine_Manager::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&all_mines);
	Auto_Save_Variable(2,4,&sov_mines);
}

//////////////RA_ObjectDeath_OnCreate//////////////

void RA_ObjectDeath_OnCreate::Created(GameObject *obj)
{
	/*NeoSaber's Note: The purpose of this script is to create a new 
	object at the location of another object's creation, then kill 
	the script generated one to use its KilledExplosion setting to 
	place a sound on the map. Only way I've found to 'create' sounds 
	with scripts in multiplayer*/

	const char *c;
	const char *war = "Death";
	Vector3 v;
	c = Get_Parameter("Object");
	v = Commands->Get_Position(obj);
	Commands->Apply_Damage(Commands->Create_Object(c,v),100,war,0);
}

//////////////RA_Naval_Yard//////////////

void RA_Naval_Yard::Created(GameObject *obj)
{
	team_count = 0;
	active = true;
	ready = true;
}

void RA_Naval_Yard::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	//951951 = purchase authorization request
	//753753 = naval unit died

	if(message == 951951) //Authorize request?
	{
		if(active) //am I still alive?
		{
			if(ready)//was a unit just built?
			{
				int limit = Get_Int_Parameter("Limit");

				if(team_count < limit) //Are we under limit?
				{			
					//Authorize purchase and increase count by 1
					Commands->Send_Custom_Event(obj, sender, 159159, 1, 0.0);
					team_count++;
					ready = false;
					Commands->Start_Timer(obj, this, Get_Float_Parameter("Disable_Time"), 0);
									}
				else
				{
					//Authorization denied
					Commands->Send_Custom_Event(obj, sender, 159159, 0, 0.0);
				}
			}
			else//Not ready to build yet
			{	
				//Authorization denied
				Commands->Send_Custom_Event(obj, sender, 159159, 0, 0.0);
			}
		}
		else
		{
			//If I'm dead, everyone dies too! Hahahahaha!
			Commands->Destroy_Object(sender);
		}
	}
	else if(message == 753753) //Death Announcement?
	{
		//Why do the young die?! Why!?
		team_count--;
	}
}

void RA_Naval_Yard::Killed(GameObject *obj, GameObject *shooter)
{
	active = false;
}

void RA_Naval_Yard::Timer_Expired(GameObject *obj, int number)
{
	//'cool down' time complete, construction allowed again
	ready = true;
}

void RA_Naval_Yard::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1, 4, &team_count);
	Auto_Save_Variable(2, 4, &active);
	Auto_Save_Variable(3, 4, &ready);
}

//////////////RA_Naval_PT//////////////

void RA_Naval_PT::Created(GameObject *obj)
{
	storedID = Get_Int_Parameter("TestID");
	Commands->Display_Health_Bar(obj, false);
	Commands->Set_Player_Type(obj, Get_Int_Parameter("Team"));
}

void RA_Naval_PT::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	//159159 = authorization response

	if(message == CUSTOM_EVENT_VEHICLE_ENTER)
	{
		bool send = false; //for later use
		//first check if player matches team

		int teamtest = Get_Int_Parameter("Team");

		if((Commands->Get_Player_Type(sender)) == teamtest)
		{
			//ok, player is on my team, does he have the cash?
			float cost = Get_Float_Parameter("Cost");

			if(Commands->Get_Money(sender) >= cost)
			{
				//player has the money, are they allowed?
				storedID = Commands->Get_ID(sender); //remember for later
				send = true; //get ready to ask controller
			}
		}

		//Now to 'refresh' the PT
		//All the info we'll need from this terminal
		Vector3 pos = Commands->Get_Position(obj);
		float face = Commands->Get_Facing(obj);
		GameObject *newobj;
		char params[100];
		sprintf(params,"%s,%s,%s,%s,%s,%d",Get_Parameter("Preset_Name"),Get_Parameter("Cost"),Get_Parameter("Team"),Get_Parameter("Controller_ID"),Get_Parameter("Zone_ID"),storedID); //Get parameters

		//time to die
		Commands->Destroy_Object(obj);
		
		//Create new terminal and attach script
		newobj = Commands->Create_Object(Commands->Get_Preset_Name(obj), pos);
		Commands->Set_Facing(newobj, face);
		Commands->Attach_Script(newobj, "RA_Naval_PT", params);

		if(send) //should I bother the boss?
		{
			//Have the new PT send message so it receives response
			Commands->Send_Custom_Event(newobj, Commands->Find_Object(Get_Int_Parameter("Controller_ID")), 951951, 0, 0.0);
		}
	}
	else if(message == 159159)
	{
		if(param == 1)
		{
			if(storedID != 0) //Do I remember a player?
			{
				float cost = Get_Float_Parameter("Cost");
				cost = -cost;

				Commands->Give_Money(Commands->Find_Object(storedID),cost,false);

				//tell zone to clear the the construction zone
				Commands->Send_Custom_Event(obj, Commands->Find_Object(Get_Int_Parameter("Zone_ID")), 846846, 0, 0.0);

				//1 second delay to allow zone to clear
				Commands->Start_Timer(obj,this,1.0, 0);

				//clear the ID, we don't need it now
				storedID = 0;
			}
		}
		else
		{
			storedID = 0; //request denied, erase ID
		}
	}
}

void RA_Naval_PT::Timer_Expired(GameObject *obj, int number)
{
	GameObject *newobj;
	//Create the object
	newobj = Commands->Create_Object(Get_Parameter("Preset_Name"), Commands->Get_Position(Commands->Find_Object(Get_Int_Parameter("Zone_ID"))));
	Commands->Set_Facing(newobj, Commands->Get_Facing(Commands->Find_Object(Get_Int_Parameter("Zone_ID"))));//Set_Facing won't work on a script zone
	Commands->Attach_Script(newobj, "RA_Naval_Unit", Get_Parameter("Controller_ID"));
}

void RA_Naval_PT::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1, 4, &storedID);
}

//////////////RA_Naval_Unit//////////////

void RA_Naval_Unit::Destroyed(GameObject *obj)
{
	int controller = Get_Int_Parameter("Controller_ID");

	Commands->Send_Custom_Event(obj, Commands->Find_Object(controller), 753753, 0, 0.0);
}

//////////////RA_Naval_Zone//////////////

void RA_Naval_Zone::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if(message == 846846)
	{
		//Fire in the hole!!!!
		Commands->Create_Explosion(Get_Parameter("Explosion"), Commands->Get_Position(obj), 0);
	}
}

//////////////RA_Damaged_Credits//////////////

void RA_Damaged_Credits::Damaged(GameObject *obj, GameObject *damager, float damage)
{
	if(Commands->Is_A_Star(damager)) //Ignore if not a player
	{
		int objtype1 = Commands->Get_Player_Type(obj);
		int objtype2 = Commands->Get_Player_Type(damager);

		if(objtype1 == 0 || objtype1 == 1) //Ignore if not soviet or allied
		{
			if(objtype1 != objtype2) //Test if on different teams
			{
				float divisor = Get_Float_Parameter("Divisor");
				Commands->Give_Money(damager, damage/divisor, false);
			}
		}
	}
}

//////////////RA_GameStart_Detector//////////////

void RA_GameStart_Detector::Created(GameObject *obj)
{
	Commands->Start_Timer(obj, this, Get_Float_Parameter("Interval"), 564);
}

void RA_GameStart_Detector::Killed(GameObject *obj, GameObject *shooter)
{
	int receiverID = Get_Int_Parameter("ReceiverID");
	int message = Get_Int_Parameter("Message");
	int param = Get_Int_Parameter("Parameter");

	Commands->Send_Custom_Event(obj, Commands->Find_Object(receiverID), message, param, 0.0);
}

void RA_GameStart_Detector::Timer_Expired(GameObject *obj, int number)
{
	if(number == 564)
	{
		Commands->Apply_Damage(obj, 100.0, "BlamoKiller", 0);
		Commands->Start_Timer(obj, this, Get_Float_Parameter("Interval"), 564);
	}
}

//////////////RA_DriverDeath//////////////

void RA_DriverDeath::Created(GameObject *obj)
{
	Commands->Start_Timer(obj, this, 0.5, 12121);
}

void RA_DriverDeath::Timer_Expired(GameObject *obj, int number)
{
	if(number == 12121)
		Commands->Apply_Damage(obj, 100, "Death", 0);
}

//////////////RA_Conyard_Controller//////////////

void RA_Conyard_Controller::Created(GameObject *obj)
{
	GameObject * object;
	int id = 0;
	int message = 3000;
	int param = 230032;
	id = Get_Int_Parameter("Building1_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 1);
	}
	id = Get_Int_Parameter("Building2_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 1);
	}
	id = Get_Int_Parameter("Building3_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 1);
	}
	id = Get_Int_Parameter("Building4_ID");
	if (id != 0) 
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 1);
	}
	id = Get_Int_Parameter("Building5_ID");
	if (id != 0) 
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 1);
	}
	id = Get_Int_Parameter("Building6_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 1);
	}
	id = Get_Int_Parameter("Building7_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 1);
	}
	id = Get_Int_Parameter("Building8_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 1);
	}
	id = Get_Int_Parameter("Building9_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 1);
	}
	id = Get_Int_Parameter("Building10_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 1);
	}
}

void RA_Conyard_Controller::Killed(GameObject * obj, GameObject * shooter)
{
	GameObject * object;
	int id = 0;
	int message = 3000;
	int param = 320023;
	id = Get_Int_Parameter("Building1_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 0);
	}
	id = Get_Int_Parameter("Building2_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 0);
	}
	id = Get_Int_Parameter("Building3_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 0);
	}
	id = Get_Int_Parameter("Building4_ID");
	if (id != 0) 
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 0);
	}
	id = Get_Int_Parameter("Building5_ID");
	if (id != 0) 
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 0);
	}
	id = Get_Int_Parameter("Building6_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 0);
	}
	id = Get_Int_Parameter("Building7_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 0);
	}
	id = Get_Int_Parameter("Building8_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 0);
	}
	id = Get_Int_Parameter("Building9_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 0);
	}
	id = Get_Int_Parameter("Building10_ID");
	if (id != 0)
	{
		object = Commands->Find_Object(id);
		Commands->Send_Custom_Event(obj, object, message, param, 0);
	}
}

//////////////RA_Conyard_Repair//////////////

void RA_Conyard_Repair::Created(GameObject * obj)
{
	Enabled = false;
	objID = Commands->Get_ID(obj);
}

void RA_Conyard_Repair::Custom(GameObject * obj, int message, int param, GameObject * sender)
{
	if (message == 3000)
	{
		if(param == 230032)
		{
			Enabled = true;
			Commands->Start_Timer(obj, this, Get_Float_Parameter("Repair_Frequency"), objID);
		}
		else if(param == 320023)
			Enabled = false;
	}
}

void RA_Conyard_Repair::Timer_Expired(GameObject * obj,int number)
{
	float amount = Commands->Get_Health(obj);
	if (amount>0) 
	{
		Commands->Set_Health(obj,(amount+2));
		if (Enabled == true)
			Commands->Start_Timer(obj, this, Get_Float_Parameter("Repair_Frequency"), objID);
		else
			return;
	}
}

void RA_Conyard_Repair::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1, 4, &Enabled);
	Auto_Save_Variable(2, 4, &objID);
}

//////////////RA_ObjectDeath_OnDeath//////////////

void RA_ObjectDeath_OnDeath::Killed(GameObject *obj, GameObject *shooter)
{
	GameObject *BoomBox;
	BoomBox = Commands->Create_Object(Get_Parameter("Preset"),Commands->Get_Position(obj));
	Commands->Apply_Damage(BoomBox, 100, "BlamoKiller", 0);
}

//////////////Script Registrants//////////////

/********************************************************************/
ScriptRegistrant<RA_Thief_Script> RA_Thief_Script_Registrant("RA_Thief_Script","Credits_To_Award=500.00:float,Prevent_Theft_Timer=30.00:float,Thief_Preset_ID:int");
ScriptRegistrant<RA_Repair_Controller> RA_Repair_Controller_Registrant("RA_Repair_Controller","ScriptZoneID=0:int");
ScriptRegistrant<RA_Soviet_Defence> RA_Soviet_Defence_Registrant("RA_Soviet_Defence","MinAttackDistance=0.0:float,MaxAttackDistance=300.0:float,AttackTimer=10.00:float,Spy_Preset_ID:int,Aircraft_Preset_ID:int");
ScriptRegistrant<RA_Repair_Script> RA_Repair_Script_Registrant("RA_Repair_Script","TeamSelection=0:int");
ScriptRegistrant<RA_Soviet_Refinery_Controller> RA_Soviet_Refinery_Controller_Registrant("RA_Soviet_Refinery_Controller", "ScriptZoneID=0:int");
ScriptRegistrant<RA_Soviet_Refinery_Theft_Zone> RA_Soviet_Refinery_Theft_Zone_Registrant("RA_Soviet_Refinery_Theft_Zone", "Thief_Preset_ID=0:int");
ScriptRegistrant<RA_Allied_Thief> RA_Allied_Thief_Registrant("RA_Allied_Thief", "Credits_To_Award=500.00:float, Prevent_Theft_Timer=30.00:float");
ScriptRegistrant<RA_Infantry_Spy> RA_Infantry_Spy_Registrant("RA_Infantry_Spy", "");
ScriptRegistrant<RA_Infantry_NotSpy> RA_Infantry_NotSpy_Registrant("RA_Infantry_NotSpy", "");
ScriptRegistrant<RA_Helipad_Zone> RA_Helipad_Zone_Registrant("RA_Helipad_Zone", "TeamSelection=0:int,Reload_Interval=2.00:float,Apache_Preset_ID=0:int,Apache_Reload_Powerup=Blank:string,Hind_Preset_ID=0:int,Hind_Reload_Powerup=Blank:string");
ScriptRegistrant<RA_MineLayer> RA_MineLayer_Registrant("RA_MineLayer", "Mine_Manager_ID=0:int");
ScriptRegistrant<RA_Mine> RA_Mine_Registrant("RA_Mine", "Mine_Manager_ID=0:int,Is_Anti-Personnel=0:int,Is_Anti-Tank=0:int,Trigger_Damage=1.0:float,Trigger_Warhead=Death:string");
ScriptRegistrant<RA_Mine_Manager> RA_Mine_Manager_Registrant("RA_Mine_Manager", "Allied_Mine=Blank:string,Soviet_Mine=Blank:string,Mine_Reload=Blank:string,BoneName=mine:string,Mine_Limit=30:int");
ScriptRegistrant<RA_ObjectDeath_OnCreate> RA_ObjectDeath_OnCreate_Registrant("RA_ObjectDeath_OnCreate","Object=null:string");
ScriptRegistrant<RA_Naval_Yard> RA_Naval_Yard_Registrant("RA_Naval_Yard", "Limit=8:int,Disable_Time=5.0:float");
ScriptRegistrant<RA_Naval_PT> RA_Naval_PT_Registrant("RA_Naval_PT", "Preset_Name=blank:string,Cost=0.0:float,Team=0:int,Controller_ID=0:int,Zone_ID=0:int,TestID=0:int");
ScriptRegistrant<RA_Naval_Unit> RA_Naval_Unit_Registrant("RA_Naval_Unit", "Controller_ID=0:int");
ScriptRegistrant<RA_Naval_Zone> RA_Naval_Zone_Registrant("RA_Naval_Zone", "Explosion=blank:string");
ScriptRegistrant<RA_Damaged_Credits> RA_Damaged_Credits_Registrant("RA_Damaged_Credits","Divisor=4.0:float");
ScriptRegistrant<RA_GameStart_Detector> RA_GameStart_Detector_Registrant("RA_GameStart_Detector", "Interval=5.0:float,ReceiverID=0:int,Message=0:int,Parameter=0:int");
ScriptRegistrant<RA_DriverDeath> RA_DriverDeath_Registrant("RA_DriverDeath", "");
ScriptRegistrant<RA_Conyard_Controller> RA_Conyard_Controller_Registrant("RA_Conyard_Controller", "Building1_ID=0:int,Building2_ID=0:int,Building3_ID=0:int,Building4_ID=0:int,Building5_ID=0:int,Building6_ID=0:int,Building7_ID=0:int,Building8_ID=0:int,Building9_ID=0:int,Building10_ID=0:int");
ScriptRegistrant<RA_Conyard_Repair> RA_Conyard_Repair_Registrant("RA_Conyard_Repair", "Repair_Frequency=1.0:float");
ScriptRegistrant<RA_ObjectDeath_OnDeath> RA_ObjectDeath_OnDeath_Registrant("RA_ObjectDeath_OnDeath","Preset=blank:string");
