/* This file is part of the Server Side AOW Library.

  The Server Side AOW Library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  The Server Side AOW Library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along with
  the Server Side AOW Library; if not, write to the Free Software Foundation,
  Inc.,  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/

#include "scripts.h"
#include "AOW.h"
#include "PROFILE.h"
#include "Date.h"
#include <fstream>
#include <stdlib.h>
#include <iostream.h>
#include <time.h>
#include <windows.h>
#include <string>
#include <vector>
#pragma warning(disable: 4035)
#pragma warning(disable: 4786)

date renremdate;
bool FirstGame = true;
char CurrMap[30];
std::vector<std::string> SvSKillMsg;
std::vector<std::string> VvSKillMsg;
std::vector<std::string> DisableList;
std::vector<std::string> WeaponStartEngL1;
std::vector<std::string> WeaponStartEngL2;
std::vector<std::string> WeaponStartOther;
bool IsDisableList = false;
bool IsDisableListReady = false;
int SvSKillMsgTotal = 0;
int VvSKillMsgTotal = 0;

bool Settings_ReportBuildingDamage = true;
bool Settings_ReportBuildingDeath = true;
bool Settings_BuildingDeathRewardPage = false;
float Settings_BuildingDamageInt = 30.0f;
bool Settings_AFKKick = false;
int Settings_AFKWait = 10;
char Settings_AFKPageMessage[200];
bool Settings_DropWeapons = true;
bool Settings_ShowPlayerPurchase = false;
bool Settings_ShowPlayerKillMessage = false;
bool Settings_Weather = true;
bool Settings_LogVehCreate = false;
bool Settings_LogVehDeath = false;
bool Settings_PlayVehDeathAnim = true;
bool Settings_EnableVehicleDamageAnim = true;
bool Settings_LogHarvesterDeath = true;
char Settings_OBGPageMessage[200];
bool Settings_OBGEnable = true;
bool Settings_OBAnim = true;
bool Settings_B2BEnable = true;
char Settings_B2BPageMessage[200];
//Settings added in Version 1.1
bool Settings_DestroyPlayerVeh = true;
bool Settings_IDDebug = false;
//Settings added in Version 1.2
bool Settings_DisableBaseDefenses = false;

/* ******************************************************************************************************** */

unsigned long GetPlayerData(GameObject *obj) {
	__asm {
	   mov edx, obj
	   mov eax, dword ptr[edx + 960h]
	};
} 
    
unsigned long GetName(unsigned long ptr_) { 
	__asm {
		mov edx, [ptr_]
		mov eax, dword ptr[edx + 758h]
	};
}

char *Read16BitString(unsigned long ptr){
	int size = 0;
	char chr;
	int x = 0;
	unsigned long offs;
	while (1){
 		offs = ptr + x;
 		x += 2;
 		chr = *reinterpret_cast<const char*>(offs);
 		size++;
 		if (chr == 0)
 			break;
	}
	char *temp = (char *)malloc(size + 1);
	for (int y = 0; y < size; y++){
 		temp[y] = *reinterpret_cast<const char*>(ptr + (y * 2));
	}
	return temp;
}

GameObject *SoldierGameObj(GameObject *obj) {
	_asm {
		mov ecx,obj
		mov eax,[ecx]
		call [eax+44]
	}
}

int Get_PID(GameObject *obj) {
	if (SoldierGameObj(obj) != 0) {
		_asm {
			mov eax, obj
			cmp eax, 0
			jz loc1
			mov eax, [eax + 0x960]
			loc1:
		}
	}
	else return 0;
}

GameObject *Get_Vehicle(GameObject *obj) {
	_asm {
		mov eax, obj
		mov eax, [eax+98Ch]
	}
}

void ConsoleCommand(char *msg) {
	typedef void (*ConsoleMsg)(char *);
	ConsoleMsg do_consolemsg;
	do_consolemsg = (ConsoleMsg)0x00428960;
	do_consolemsg(msg);
}

void FDSMessage(const char* Message) {
	renremdate.refreshdate();
	char FDSlogname[100];
	char FDSlogbegin[85];
	getProfileString("General","FDSLogRoot","renlog2",FDSlogbegin,85,"server2.ini");
	sprintf(FDSlogname, "%s_%s.txt",FDSlogbegin,renremdate.get_date_string());

	std::ofstream FDSLog (FDSlogname,ios::app);
	if (FDSLog.is_open()) {
		char messageprint[512];
		char hours[5];
		char mins[5];
		char secs[5];
		time_t rawtime;
		struct tm *timeinfo;
		time(&rawtime);
		timeinfo = localtime(&rawtime);

		int hour = timeinfo->tm_hour;
		int min = timeinfo->tm_min;
		int sec = timeinfo->tm_sec;
		if (hour < 10) sprintf(hours,"0%d",hour);
		else sprintf(hours,"%d",hour);
		if (min < 10) sprintf(mins,"0%d",min);
		else sprintf(mins,"%d",min);
		if (sec < 10) sprintf(secs,"0%d",sec);
		else sprintf(secs,"%d",sec);

		printf("%s\n",Message);
		sprintf(messageprint,"[%s:%s:%s] %s\n",hours,mins,secs,Message);
		FDSLog << messageprint;
		FDSLog.close();
	}
}

void RecognizeMap(int ID,bool IsLoad) {
	char IDKey[20], MapName[30];
	sprintf(IDKey,"%d",ID);
	getProfileString("Maps",IDKey,"NULL",MapName,30,"server2.ini");
	if (Settings_IDDebug) {
		char DebugMsg[100];
		sprintf(DebugMsg,"MapID_Debug: %d would work to identify this map in the server2.ini file.",ID);
		FDSMessage(DebugMsg);
	}
	if (strcmp(MapName,"NULL") != 0) {
		if (IsLoad == true) {
			rename("data\\objects.ddb","data\\bjects.ddb");
			strcpy(CurrMap,MapName);
			char mapname[100];
			sprintf(mapname,"-> Map \"%s\" detected, loading settings..",MapName);
			FDSMessage(mapname);
			bool ShowSetChangeMess = false;

			//Perform Load Coad Here
			bool PSet_RBDM = Settings_ReportBuildingDamage;
			if (getProfileInt("General","ReportBuildingDamage",0,"server2.ini") == 0) Settings_ReportBuildingDamage = false;
			else Settings_ReportBuildingDamage = true;
			if (PSet_RBDM != Settings_ReportBuildingDamage && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_RBDT = Settings_ReportBuildingDeath;
			if (getProfileInt("General","ReportBuildingDeath",0,"server2.ini") == 0) Settings_ReportBuildingDeath = false;
			else Settings_ReportBuildingDeath = true;
			if (PSet_RBDT != Settings_ReportBuildingDeath && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_BDRP = Settings_BuildingDeathRewardPage;
			if (getProfileInt("General","BuildingDeathRewardPage",0,"server2.ini") == 0) Settings_BuildingDeathRewardPage = false;
			else Settings_BuildingDeathRewardPage = true;
			if (PSet_BDRP != Settings_BuildingDeathRewardPage && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			float PSet_BDI = Settings_BuildingDamageInt;
			Settings_BuildingDamageInt = getProfileFloat("General","BuildingDamageInterval",30.0f,"server2.ini");
			if (PSet_BDI != Settings_BuildingDamageInt && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_AFKKick = Settings_AFKKick;
			if (getProfileInt("General","AFKKick",0,"server2.ini") == 0) Settings_AFKKick = false;
			else Settings_AFKKick = true;
			if (PSet_RBDT != Settings_ReportBuildingDeath && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			int PSet_AFKWait = Settings_AFKWait;
			Settings_AFKWait = getProfileInt("General","AFKWait",10,"server2.ini");
			if (Settings_AFKWait < 2) {
				FDSMessage("Error: AFKWait must be at least 2 minutes.  Defaulting to 10 minutes.");
				Settings_AFKWait = 2;
			}
			else if (PSet_AFKWait != Settings_AFKWait && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			char PSet_AFKPage[200];
			strcpy(PSet_AFKPage,Settings_AFKPageMessage);
			getProfileString("General","AFKPageMessage","Warning! You might be kicked for being AFK/Idle if you do not move!",Settings_AFKPageMessage,200,"server2.ini");
			if (strcmp(Settings_AFKPageMessage,PSet_AFKPage) != 0 && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_DW = Settings_DropWeapons;
			if (getProfileInt("General","EnableDropWeapons",0,"server2.ini") == 0) Settings_DropWeapons = false;
			else Settings_DropWeapons = true;
			if (PSet_DW != Settings_DropWeapons && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_SPP = Settings_ShowPlayerPurchase;
			if (getProfileInt("General","ShowPlayerPurchases",0,"server2.ini") == 0) Settings_ShowPlayerPurchase = false;
			else Settings_ShowPlayerPurchase = true;
			if (PSet_SPP != Settings_ShowPlayerPurchase && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_SPKM = Settings_ShowPlayerKillMessage;
			if (getProfileInt("General","ShowPlayerKillMessage",0,"server2.ini") == 0) Settings_ShowPlayerKillMessage = false;
			else Settings_ShowPlayerKillMessage = true;
			if (PSet_SPKM != Settings_ShowPlayerKillMessage && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_Weather = Settings_Weather;
			if (getProfileInt("General","EnableWeather",0,"server2.ini") == 0) Settings_Weather = false;
			else Settings_Weather = true;
			if (PSet_Weather != Settings_Weather && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_LVC = Settings_LogVehCreate;
			if (getProfileInt("General","LogVehicleCreate",0,"server2.ini") == 0) Settings_LogVehCreate = false;
			else Settings_LogVehCreate = true;
			if (PSet_LVC != Settings_LogVehCreate && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_LVD = Settings_LogVehDeath;
			if (getProfileInt("General","LogVehicleDeath",0,"server2.ini") == 0) Settings_LogVehDeath = false;
			else Settings_LogVehDeath = true;
			if (PSet_LVD != Settings_LogVehDeath && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_PVDA = Settings_PlayVehDeathAnim;
			if (getProfileInt("General","PlayVehicleDeathAnimations",0,"server2.ini") == 0) Settings_PlayVehDeathAnim = false;
			else Settings_PlayVehDeathAnim = true;
			if (PSet_PVDA != Settings_PlayVehDeathAnim && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_EVDA = Settings_EnableVehicleDamageAnim;
			if (getProfileInt("General","EnableVehicleDamageAnimations",0,"server2.ini") == 0) Settings_EnableVehicleDamageAnim = false;
			else Settings_EnableVehicleDamageAnim = true;
			if (PSet_EVDA != Settings_EnableVehicleDamageAnim && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_LHD = Settings_LogHarvesterDeath;
			if (getProfileInt("General","LogHarvesterDeath",0,"server2.ini") == 0) Settings_LogHarvesterDeath = false;
			else Settings_LogHarvesterDeath = true;
			if (PSet_LHD != Settings_LogHarvesterDeath && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_OBGE = Settings_OBGEnable;
			if (getProfileInt("General","EnableObGlitchProtect",0,"server2.ini") == 0) Settings_OBGEnable = false;
			else Settings_OBGEnable = true;
			if (PSet_OBGE != Settings_OBGEnable && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			char PSet_OBGPM[200];
			strcpy(PSet_OBGPM,Settings_OBGPageMessage);
			getProfileString("General","ObGlitchPageMessage","Warning! You might be kicked for glitching the Obelisk!",Settings_OBGPageMessage,200,"server2.ini");
			if (strcmp(Settings_OBGPageMessage,PSet_OBGPM) != 0 && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_OBAnim = Settings_OBAnim;
			if (getProfileInt("General","PlayObCharge",0,"server2.ini") == 0) Settings_OBAnim = false;
			else Settings_OBAnim = true;
			if (PSet_OBAnim != Settings_OBAnim && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_B2BE = Settings_B2BEnable;
			if (getProfileInt("General","EnableB2BProtect",0,"server2.ini") == 0) Settings_B2BEnable = false;
			else Settings_B2BEnable = true;
			if (PSet_B2BE != Settings_B2BEnable && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			char PSet_B2BPM[200];
			strcpy(PSet_OBGPM,Settings_B2BPageMessage);
			getProfileString("General","B2BPageMessage","Warning! You might be kicked for base to base attacking!",Settings_B2BPageMessage,200,"server2.ini");
			if (strcmp(Settings_B2BPageMessage,PSet_B2BPM) != 0 && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_DPV = Settings_DestroyPlayerVeh;
			if (getProfileInt("General","DestroyPlayerVeh",0,"server2.ini") == 0) Settings_DestroyPlayerVeh = false;
			else Settings_DestroyPlayerVeh = true;
			if (PSet_DPV != Settings_DestroyPlayerVeh && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			bool PSet_DD = Settings_IDDebug;
			if (getProfileInt("General","MapIDDebug",0,"server2.ini") == 0) Settings_IDDebug = false;
			else Settings_IDDebug = true;
			if (PSet_DD != Settings_IDDebug && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			int PSet_SvsT = SvSKillMsgTotal;
			SvSKillMsgTotal = 0;
			for (int a = 1; a <= getProfileInt("SvSKillMsg","Total",0,"server2.ini"); a++) {
				char key[5],value[256];
				sprintf(key,"Str%d",a);
				getProfileString("SvSKillMsg",key,"Error_BadKillMsg",value,256,"server2.ini");
				SvSKillMsg.push_back(value);
				SvSKillMsgTotal++;
			}
			if (PSet_SvsT != SvSKillMsgTotal && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			int PSet_VvsT = VvSKillMsgTotal;
			VvSKillMsgTotal = 0;
			for (int c = 1; c <= getProfileInt("VvSKillMsg","Total",0,"server2.ini"); c++) {
				char key[5],value[256];
				sprintf(key,"Str%d",c);
				getProfileString("VvSKillMsg",key,"Error_BadKillMsg",value,256,"server2.ini");
				VvSKillMsg.push_back(value);
				VvSKillMsgTotal++;
			}
			if (PSet_VvsT != VvSKillMsgTotal && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			char DisableListName[100];
			getProfileString(CurrMap,"DisableList","ERROR",DisableListName,100,"server2.ini");
			if (strcmp(DisableListName,"ERROR") != 0) {
				IsDisableList = true;
				for (int z = 1; z <= 999; z++) {
					char key[3], value[256];
					if (z < 10) sprintf(key,"0%d",z);
					else sprintf(key,"%d",z);
					getProfileString(DisableListName,key,"NULL",value,256,"server2.ini");
					if (strcmp(value,"NULL") == 0) z = 1000;
					else DisableList.push_back(value);
				}
				IsDisableListReady = true;
				FDSMessage("Disable List detected and loaded!");
			}

			bool PSet_DBD = Settings_DisableBaseDefenses;
			if (getProfileInt("General","DisableBaseDefenses",0,"server2.ini") == 0) Settings_DisableBaseDefenses = false;
			else Settings_DisableBaseDefenses = true;
			if (PSet_DBD != Settings_DisableBaseDefenses && !ShowSetChangeMess) {
				ShowSetChangeMess = true;
				FDSMessage("New settings detected and loaded!");
			}

			char WSL1[100], WSL2[100], WSO[100];
			getProfileString(CurrMap,"WeaponStartEngL1","ERROR",WSL1,100,"server2.ini");
			if (strcmp(WSL1,"ERROR") != 0) {
				for (int z = 1; z <= 999; z++) {
					char key[3], value[256];
					if (z < 10) sprintf(key,"0%d",z);
					else sprintf(key,"%d",z);
					getProfileString(WSL1,key,"NULL",value,256,"server2.ini");
					if (strcmp(value,"NULL") == 0) z = 1000;
					else WeaponStartEngL1.push_back(value);
				}
			}
			getProfileString(CurrMap,"WeaponStartEngL2","ERROR",WSL2,100,"server2.ini");
			if (strcmp(WSL2,"ERROR") != 0) {
				for (int z = 1; z <= 999; z++) {
					char key[3], value[256];
					if (z < 10) sprintf(key,"0%d",z);
					else sprintf(key,"%d",z);
					getProfileString(WSL2,key,"NULL",value,256,"server2.ini");
					if (strcmp(value,"NULL") == 0) z = 1000;
					else WeaponStartEngL2.push_back(value);
				}
			}
			getProfileString(CurrMap,"WeaponStartOther","ERROR",WSO,100,"server2.ini");
			if (strcmp(WSO,"ERROR") != 0) {
				for (int z = 1; z <= 999; z++) {
					char key[3], value[256];
					if (z < 10) sprintf(key,"0%d",z);
					else sprintf(key,"%d",z);
					getProfileString(WSO,key,"NULL",value,256,"server2.ini");
					if (strcmp(value,"NULL") == 0) z = 1000;
					else WeaponStartOther.push_back(value);
				}
			}



			if (FirstGame) {
				FirstGame = false;
				FDSMessage("First map loaded, auto gameovering now..");
				ConsoleCommand("gameover");
			}
			if (Settings_Weather) {
				char params[20];
				sprintf(params,"%d",ID);
				Vector3 loc; loc.X = 0.0f; loc.Y = 0.0f; loc.Z = 0.0f;
				GameObject *temp = Commands->Create_Object("Invisible_Object",loc);
				Commands->Attach_Script(temp,"KAK_Random_Weather",params);
			}
		}
		else {
			rename("data\\bjects.ddb","data\\objects.ddb");
			SvSKillMsg.erase(SvSKillMsg.begin(),SvSKillMsg.end());
			VvSKillMsg.erase(VvSKillMsg.begin(),VvSKillMsg.end());
			DisableList.erase(DisableList.begin(),DisableList.end());
			WeaponStartEngL1.erase(WeaponStartEngL1.begin(),WeaponStartEngL1.end());
			WeaponStartEngL2.erase(WeaponStartEngL2.begin(),WeaponStartEngL2.end());
			WeaponStartOther.erase(WeaponStartOther.begin(),WeaponStartOther.end());
			IsDisableList = false;
			IsDisableListReady = false;
			//Perform Cleanup Code Here
		}
	}
}

char *Translate_Preset(GameObject *obj) {
	const char *preset = Commands->Get_Preset_Name(obj);
	char *TransName = (char *)malloc(256);
	getProfileString("Translated_Preset",preset,preset,TransName,256,"server2.ini");
	return TransName;
}

char *PlayerName(GameObject *obj) { 
	if (Get_PID(obj) != 0) return Read16BitString(GetName(GetPlayerData(obj)));
	else return "ERROR_NotPlayer";
}

GameObject *IsPlayerVehicle(GameObject *obj) {
	if (Get_Vehicle(obj) != 0) return Get_Vehicle(obj);
	else return obj;
}

GameObject *GVDA(int Type, int Size, GameObject *obj) {
	GameObject *retString;
	int Random;
	
	if (Type == 1) {
		if (Size == 1) {
			Random = Commands->Get_Random_Int(1,2);
			if (Random == 1) retString = Commands->Create_Object("SFX.Arrow_Troops_Concrete",Commands->Get_Position(obj));
			else if (Random == 2) retString = Commands->Create_Object("SFX.Arrow_Troops_Generic",Commands->Get_Position(obj));
			else retString = Commands->Create_Object("SFX.Arrow_Troops_Concrete",Commands->Get_Position(obj));
		}
		else if (Size == 2) {
			Random = Commands->Get_Random_Int(1,2);
			if (Random == 1) retString = Commands->Create_Object("SFX.Arrow_Troops_Metal",Commands->Get_Position(obj));
			else if (Random == 2) retString = Commands->Create_Object("SFX.Arrow_Troops_Snow",Commands->Get_Position(obj));
			else retString = Commands->Create_Object("SFX.Arrow_Troops_Metal",Commands->Get_Position(obj));

		}
	}
	else if (Type == 2) {
		retString = Commands->Create_Object("SFX.Arrow_Troops_Stone",Commands->Get_Position(obj));
	}
	else if (Type == 4) {
		retString = Commands->Create_Object("SFX.Arrow_Troops_Wood",Commands->Get_Position(obj));
	}

	return retString;
}

/* ******************************************************************************************************** */

void KAK_DisableList_Refresh::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,1.0f,1);
}

void KAK_DisableList_Refresh::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		if (IsDisableListReady) {
			if (IsDisableList) {
				if (IsDisableListReady) {
					std::vector<std::string>::iterator it;
					for (it = DisableList.begin(); it != DisableList.end(); ++it) {
						if (strcmp((*it).c_str(),Commands->Get_Preset_Name(obj)) == 0) {
							Commands->Apply_Damage(obj,99999,"Death",obj);;
							if (obj != 0) Commands->Destroy_Object(obj);
							char pagemsg[256];
							sprintf(pagemsg,"page %s You have purchased a disabled unit. (%s)  The server has killed you.",PlayerName(obj),Translate_Preset(obj));
							ConsoleCommand(pagemsg);
							break;
						}
					}
				}
				else Commands->Attach_Script(obj,"KAK_DisableList_Refresh","");
			}
		}
		else Commands->Start_Timer(obj,this,1.0f,1);
	}
}

/* ******************************************************************************************************** */

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Created(GameObject *obj) {
	RecognizeMap(Commands->Get_ID(obj),true);
	ReportDamage = true;
	B2BCount = 0;
	LastID = 0;
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Destroyed(GameObject *obj) {
	RecognizeMap(Commands->Get_ID(obj),false);
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (Settings_ReportBuildingDamage && ReportDamage && damage > 0.0f) {
		ReportDamage = false;
		char DamageMsg[512];
		sprintf(DamageMsg,"%s under attack by %s (%s)",Translate_Preset(obj),PlayerName(damager),Translate_Preset(IsPlayerVehicle(damager)));
		FDSMessage(DamageMsg);
		Commands->Start_Timer(obj,this,Settings_BuildingDamageInt,1);
	}

	if (Settings_B2BEnable && strcmp(CurrMap,"C&C_Islands.mix") == 0 && damage > 1.0f) {
		if (Commands->Get_Player_Type(obj) == 0 && Commands->Get_Player_Type(obj) != Commands->Get_Player_Type(damager)) {		//Nod
			if (Commands->Get_Position(damager).Y >= -38.0f) {
				if (LastID == Commands->Get_ID(damager)) {
					B2BCount++;
					if (B2BCount >= 6) {
						char message[50], message2[50], FDSM[100];
						sprintf(message,"kick %s",PlayerName(damager));
						sprintf(message2,"allow %s",PlayerName(damager));
						sprintf(FDSM,"Player %s has been kicked for base to base attacking",PlayerName(damager));
						ConsoleCommand(message);
						ConsoleCommand(message2);
						FDSMessage(FDSM);
					}
					else if (B2BCount >= 4) {
						char message[256], FDSM[100];
						sprintf(message,"page %s %s",PlayerName(damager),Settings_B2BPageMessage);
						sprintf(FDSM,"Player %s has been warned for base to base attacking",PlayerName(damager));
						ConsoleCommand(message);
						FDSMessage(FDSM);
					}
				}
				else {
					LastID = Commands->Get_ID(damager);
					B2BCount = 0;
				}				
			}
		}
		else if (Commands->Get_Player_Type(obj) == 1 && Commands->Get_Player_Type(obj) != Commands->Get_Player_Type(damager)) {	//GDI
			if (Commands->Get_Position(damager).Y <= -80.0f) {
				if (LastID == Commands->Get_ID(damager)) {
					B2BCount++;
					if (B2BCount >= 6) {
						char message[50], message2[50], FDSM[100];
						sprintf(message,"kick %s",PlayerName(damager));
						sprintf(message2,"allow %s",PlayerName(damager));
						sprintf(FDSM,"Player %s has been kicked for base to base attacking",PlayerName(damager));
						ConsoleCommand(message);
						ConsoleCommand(message2);
						FDSMessage(FDSM);
					}
					else if (B2BCount >= 4) {
						char message[256], FDSM[100];
						sprintf(message,"page %s %s",PlayerName(damager),Settings_B2BPageMessage);
						sprintf(FDSM,"Player %s has been warned for base to base attacking",PlayerName(damager));
						ConsoleCommand(message);
						FDSMessage(FDSM);
					}
				}
				else {
					LastID = Commands->Get_ID(damager);
					B2BCount = 0;
				}	
			}
		}
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) ReportDamage = true;
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Killed(GameObject *obj, GameObject *shooter) {
	if (Settings_ReportBuildingDeath) {
		char KillMsg[512];
		sprintf(KillMsg,"%s destroyed thanks to %s (%s)",Translate_Preset(obj),PlayerName(shooter),Translate_Preset(IsPlayerVehicle(shooter)));
		FDSMessage(KillMsg);
	}
	if (Settings_BuildingDeathRewardPage) {
		char RewardPage[100];
		sprintf(RewardPage,"page %s The %s has been destroyed thanks to you!",PlayerName(shooter),Translate_Preset(obj));
		ConsoleCommand(RewardPage);
	}
}

/* ******************************************************************************************************** */

void M00_Disable_Transition::Created(GameObject *obj) {
	if (strstr(Commands->Get_Preset_Name(obj),"Nod_Turret_MP") || strstr(Commands->Get_Preset_Name(obj),"GDI_Guard_Tower")) {
		Commands->Start_Timer(obj,this,5.0f,1);
	}
}

void M00_Disable_Transition::Killed(GameObject *obj, GameObject *shooter) {
	if (strstr(Commands->Get_Preset_Name(obj),"Nod_Turret_MP")) {
		GameObject *DestroyedTurret = Commands->Create_Object("Nod_Turret_Destroyed",Commands->Get_Position(obj));
		Commands->Set_Facing(DestroyedTurret,Commands->Get_Facing(obj));
	}
}

void M00_Disable_Transition::Timer_Expired(GameObject *obj, int number) {
	if (Settings_DisableBaseDefenses && number == 1) {
		Commands->Apply_Damage(obj,99999,"Death",false);
	}
}

/* ******************************************************************************************************** */

void M00_GrantPowerup_Created::Created(GameObject *obj) {
	//Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),false);
	if (strcmp(Get_Parameter("WeaponDef"),"POW_Pistol_Player") == 0) {
		if (IsDisableList) {
			if (IsDisableListReady) {
				std::vector<std::string>::iterator it;
				for (it = DisableList.begin(); it != DisableList.end(); ++it) {
					if (strcmp((*it).c_str(),Commands->Get_Preset_Name(obj)) == 0) {
						Commands->Apply_Damage(obj,99999,"Death",obj);
						if (obj != 0) Commands->Destroy_Object(obj);
						char pagemsg[256];
						sprintf(pagemsg,"page %s You have purchased a disabled unit. (%s)  The server has killed you.",PlayerName(obj),Translate_Preset(obj));
						ConsoleCommand(pagemsg);
						break;
					}
				}
			}
			else Commands->Attach_Script(obj,"KAK_DisableList_Refresh","");
		}

		if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Engineer_0") == 0 || strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Engineer_0") == 0) {
			std::vector<std::string>::iterator it;
			for (it = WeaponStartEngL1.begin(); it != WeaponStartEngL1.end(); ++it) {
				Commands->Give_Powerup(obj,(*it).c_str(),true);
			}
		}
		else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Engineer_2SF") == 0 || strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Technician_0") == 0) {
			std::vector<std::string>::iterator it;
			for (it = WeaponStartEngL2.begin(); it != WeaponStartEngL2.end(); ++it) {
				Commands->Give_Powerup(obj,(*it).c_str(),true);
			}
		}
		else {
			std::vector<std::string>::iterator it;
			for (it = WeaponStartOther.begin(); it != WeaponStartOther.end(); ++it) {
				Commands->Give_Powerup(obj,(*it).c_str(),true);
			}
		}

		FullDeath = false;
		TotalHealth = (Commands->Get_Max_Health(obj) + Commands->Get_Max_Shield_Strength(obj));
		SpawnPos = Commands->Get_Position(obj);
		AfkDetect = 0;
		Commands->Start_Timer(obj,this,60,8);

		if (Settings_ShowPlayerPurchase) {
			char PurchaseMsg[512];
			sprintf(PurchaseMsg,"%s purchased a %s",PlayerName(obj),Translate_Preset(IsPlayerVehicle(obj)));
			FDSMessage(PurchaseMsg);
		}
	}
}

void M00_GrantPowerup_Created::Destroyed(GameObject *obj) {
	if (Settings_DestroyPlayerVeh && Get_Vehicle(obj) != 0) Commands->Apply_Damage(Get_Vehicle(obj),99999,"BlamoKiller",false);
	Commands->Clear_Weapons(obj);
}

void M00_GrantPowerup_Created::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (damage == TotalHealth) FullDeath = true;
}

void M00_GrantPowerup_Created::Killed(GameObject *obj, GameObject *shooter) {
	if (strcmp(Get_Parameter("WeaponDef"),"POW_Pistol_Player") == 0) {
		DeathPlace = Commands->Get_Position(obj);

		if (Settings_ShowPlayerKillMessage) {
			if (Commands->Get_ID(shooter) == 0) {
				std::string killer(PlayerName(obj)),
							killerpreset(Translate_Preset(IsPlayerVehicle(obj)));
				char KillMsg[512];
				sprintf(KillMsg,"%s was killed (%s)",killer.c_str(),killerpreset.c_str());
				FDSMessage(KillMsg);
				if (Settings_DropWeapons) {
					BackpackObject = Commands->Create_Object("Invisible_Object",DeathPlace);
					Commands->Attach_Script(BackpackObject,"KAK_Backpack_Object",Commands->Get_Preset_Name(obj));
				}
			}
			else if (Commands->Get_ID(obj) == Commands->Get_ID(shooter)) {
				std::string killer(PlayerName(obj)),
							killerpreset(Translate_Preset(IsPlayerVehicle(obj)));
				char KillMsg[512];
				sprintf(KillMsg,"%s killed himself (%s)",killer.c_str(),killerpreset.c_str());
				FDSMessage(KillMsg);
			}
			else {
				std::string killer(PlayerName(shooter)),
							killed(PlayerName(obj)),
							killerpreset(Translate_Preset(IsPlayerVehicle(shooter))),
							killedpreset(Translate_Preset(IsPlayerVehicle(obj)));
				if (Settings_DropWeapons) {
					BackpackObject = Commands->Create_Object("Invisible_Object",DeathPlace);
					Commands->Attach_Script(BackpackObject,"KAK_Backpack_Object",Commands->Get_Preset_Name(obj));
				}
				if (Get_Vehicle(shooter) != 0) {
					std::string KillMsg(VvSKillMsg[Commands->Get_Random_Int(0,VvSKillMsgTotal)]);
					int n;
					while((n = KillMsg.find("<killer>")) != std::string::npos) KillMsg.replace(n,8,killer);
					while((n = KillMsg.find("<killed>")) != std::string::npos) KillMsg.replace(n,8,killed);
					while((n = KillMsg.find("<killerpreset>")) != std::string::npos) KillMsg.replace(n,14,killerpreset);
					while((n = KillMsg.find("<killedpreset>")) != std::string::npos) KillMsg.replace(n,14,killedpreset);
					FDSMessage(KillMsg.c_str());
				}
				else if (strcmp(killer.c_str(),"ERROR_NotPlayer") == 0) {
					char KillMsg[512];
					sprintf(KillMsg,"The %s killed %s (%s)",Translate_Preset(shooter),killed.c_str(),killedpreset.c_str());
					FDSMessage(KillMsg);
				}
				else {
					std::string KillMsg(SvSKillMsg[Commands->Get_Random_Int(0,SvSKillMsgTotal)]);
					int n;
					while((n = KillMsg.find("<killer>")) != std::string::npos) KillMsg.replace(n,8,killer);
					while((n = KillMsg.find("<killed>")) != std::string::npos) KillMsg.replace(n,8,killed);
					while((n = KillMsg.find("<killerpreset>")) != std::string::npos) KillMsg.replace(n,14,killerpreset);
					while((n = KillMsg.find("<killedpreset>")) != std::string::npos) KillMsg.replace(n,14,killedpreset);
					FDSMessage(KillMsg.c_str());
				}
			}
		}
	}
}

void M00_GrantPowerup_Created::Timer_Expired(GameObject *obj, int number) {
	if (number == 8) {
		DidEvent = false;
		if (SpawnPos.X >= (Commands->Get_Position(obj).X - 5.0f) && SpawnPos.X <= (Commands->Get_Position(obj).X + 5.0f) &&
				SpawnPos.Y >= (Commands->Get_Position(obj).Y - 5.0f) && SpawnPos.Y <= (Commands->Get_Position(obj).Y + 5.0f) &&
				SpawnPos.Z >= (Commands->Get_Position(obj).Z - 5.0f) && SpawnPos.Z <= (Commands->Get_Position(obj).Z + 5.0f) && 
				DidEvent == false) {
			AfkDetect++;
			if (AfkDetect >= Settings_AFKWait) {
				char message[50], message2[50], FDSM[100];
				sprintf(message,"kick %s",PlayerName(obj));
				sprintf(message2,"allow %s",PlayerName(obj));
				sprintf(FDSM,"Player %s has been kicked for being AFK",PlayerName(obj));
				ConsoleCommand(message);
				ConsoleCommand(message2);
				FDSMessage(FDSM);
			}
			else if (AfkDetect >= (Settings_AFKWait - 1)) {
				char message[256], FDSM[100];
				sprintf(message,"page %s %s",PlayerName(obj),Settings_AFKPageMessage);
				sprintf(FDSM,"Player %s has been warned for being AFK",PlayerName(obj));
				ConsoleCommand(message);
				FDSMessage(FDSM);
			}
			DidEvent = false;
		}
		else DidEvent = true;

		if (DidEvent == true) AfkDetect = 0;
		SpawnPos = Commands->Get_Position(obj);
		Commands->Start_Timer(obj,this,60,8);
	}
}

/* ******************************************************************************************************** */

void KAK_Backpack_Object::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,5,1);
}

void KAK_Backpack_Object::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		DeathPlace = Commands->Get_Position(obj);

		int RandomNum = Commands->Get_Random_Int(1,4);

		if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player_Nod",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_ChemSprayer_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_0")) {
			BackpackScript = Commands->Create_Object("POW_Flamethrower_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Grenadier_0")) {
			BackpackScript = Commands->Create_Object("POW_GrenadeLauncher_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserChaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Technician_0")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney_PowerSuit")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_PersonalIonCannon_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_Railgun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("CnC_POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_TiberiumAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Grenadier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_TiberiumFlechetteGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Ignatio_Mobius")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_VoltAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("CnC_POW_VoltAutoRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else {
			BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		Commands->Send_Custom_Event(obj,BackpackScript,6000,Commands->Get_ID(obj),0);
	}
}

/* ************************************************************************************************************* */

void KAK_Beacon_Log::Created(GameObject *obj) {
	IsDisarmed = false;
	char params[256];
	sprintf(params,"%s,%d",Commands->Get_Preset_Name(obj),Commands->Get_ID(obj));
	InvisObjCont = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
	Commands->Attach_Script(InvisObjCont,"KAK_Beacon_Log_CreateControl",params);
}

void KAK_Beacon_Log::Destroyed(GameObject *obj) {
	if (Commands->Get_ID(InvisObjCont) != 0) Commands->Destroy_Object(InvisObjCont);
}

void KAK_Beacon_Log::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (damage < 0.0f) {
		Commands->Apply_Damage(obj,(damage * -1),"Shrapnel",false);
	}

	if (Commands->Get_Player_Type(damager) != Commands->Get_Player_Type(obj) && Commands->Get_Player_Type(obj) < 2) {
		if (damage < 0.0f && damage >= -4.0f) {
			Commands->Send_Custom_Event(obj,damager,1555,(int)(damage * -1.0f),0);
		}
		else {
			Commands->Send_Custom_Event(obj,damager,1550,(int)Commands->Get_Points(damager),0);
		}
	}
}

void KAK_Beacon_Log::Killed(GameObject *obj, GameObject *shooter) {
	if (IsDisarmed == false) {
		IsDisarmed = true;
		if (strstr(Commands->Get_Preset_Name(obj),"CnC_Beacon_IonCannon")) {
			char message[100];
			sprintf(message,"Ion Cannon Beacon disarmed thanks to %s (%s)",PlayerName(shooter),Translate_Preset(IsPlayerVehicle(shooter)));
			FDSMessage(message);
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Beacon_NukeStrike")) {
			char message[100];
			sprintf(message,"Nuclear Strike Beacon disarmed thanks to %s (%s)",PlayerName(shooter),Translate_Preset(IsPlayerVehicle(shooter)));
			FDSMessage(message);
		}
	}
	if (Commands->Get_Player_Type(shooter) != Commands->Get_Player_Type(obj) && Commands->Get_Player_Type(obj) < 2) Commands->Send_Custom_Event(obj,shooter,1552,3,0);
}

void KAK_Beacon_Log_CreateControl::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,5,3);
	Commands->Start_Timer(obj,this,55,5);
}

void KAK_Beacon_Log_CreateControl::Timer_Expired(GameObject *obj, int number) {
	if (number == 3) {
		if (strstr(Get_Parameter("Beacon"),"CnC_Beacon_IonCannon")) {
			FDSMessage("Ion Cannon Beacon deployed");
			Commands->Start_Timer(obj,this,5,4);
		}
		else if (strstr(Get_Parameter("Beacon"),"CnC_Beacon_NukeStrike")) {
			FDSMessage("Nuclear Strike Beacon deployed");
			Commands->Start_Timer(obj,this,5,4);
		}
	}
	else if (number == 4) {
		if (strstr(Get_Parameter("Beacon"),"CnC_Beacon_IonCannon")) FDSMessage("Warning - Ion Cannon Satellite approaching");
		else if (strstr(Get_Parameter("Beacon"),"CnC_Beacon_NukeStrike")) FDSMessage("Warning - Nuclear Strike approaching");
	}
	else if (number == 5) {
		if (strstr(Get_Parameter("Beacon"),"CnC_Beacon_IonCannon")) FDSMessage("Ion Cannon Beacon has detonated");
		else if (strstr(Get_Parameter("Beacon"),"CnC_Beacon_NukeStrike")) FDSMessage("Nuclear Strike Beacon has detonated");
	}
}

void KAK_Beacon_Animation_Log::Created(GameObject *obj) {
	if (strstr(Commands->Get_Preset_Name(obj),"Beacon_Ion_Cannon_Anim_Pre")) FDSMessage("Ion Cannon Strike initiated");
	else if (strstr(Commands->Get_Preset_Name(obj),"Beacon_Nuke_Strike_Anim_Pre")) FDSMessage("Nuclear Strike initiated");
}

/* ************************************************************************************************************* */

void KAK_Random_Weather::Created(GameObject *obj) {
	getProfileString(CurrMap,"WeatherType","Rain",WeatherType,256,"server2.ini");

	Range = Commands->Get_Random(0,1);
	CurrentClouds = Commands->Get_Random(0,1);
	Commands->Set_Clouds(CurrentClouds,CurrentClouds,true);
	Commands->Start_Timer(obj,this,0.5f,0);
	CurrentWind = 0.0f;
}

void KAK_Random_Weather::Timer_Expired(GameObject *obj, int number) {
	if (number == 0) {
		if (CurrentClouds < Range) {
			if ((CurrentClouds + 0.001f) >= Range) CurrentClouds = Range;
			else CurrentClouds += 0.001f;
		}
		else if (CurrentClouds > Range) {
			if ((CurrentClouds - 0.001f) <= Range) CurrentClouds = Range;
			else CurrentClouds -= 0.001f;
		}

		//Start Making Weather
		Commands->Set_Clouds(CurrentClouds,CurrentClouds,true);

		CurrentWind = 10 * CurrentClouds;
		Commands->Set_Wind(0.0f,CurrentWind,1.0f,true);

		if (strcmp(WeatherType,"Snow") == 0) {
			if (CurrentClouds >= 0.625f) {
				CurrentSnow = (((16 * CurrentClouds) - 10) / 3);
				Commands->Set_Snow(CurrentSnow,CurrentSnow,true);
			}
			else Commands->Set_Snow(0.0f,0.0f,true);
		}
		else if (strcmp(WeatherType,"Ash") == 0) {
			if (CurrentClouds >= 0.625f) {
				CurrentAsh = (((16 * CurrentClouds) - 10) / 3);
				Commands->Set_Ash(CurrentAsh,CurrentAsh,true);
			}
			else Commands->Set_Ash(0.0f,0.0f,true);
		}
		else {
			if (CurrentClouds >= 0.625f) {
				CurrentRain = (((56 * CurrentClouds) - 35) / 6);
				Commands->Set_Rain(CurrentRain,CurrentRain,true);
			}
			else Commands->Set_Rain(0.0f,0.0f,true);

			if (CurrentClouds >= 0.875f) {
				CurrentLightning = (8 * (CurrentClouds + 0.125f)) - 8;
				Commands->Set_Lightning(CurrentLightning,0.0f,1.0f,0.0f,1.0f,true);
			}
			else Commands->Set_Lightning(0.0f,0.0f,1.0f,0.0f,1.0f,true);
		}
		//Stop Making Weather

		if (CurrentClouds == Range) {
			Range = Commands->Get_Random(0,1);
			Commands->Start_Timer(obj,this,0.5f,0);
		}
		else Commands->Start_Timer(obj,this,0.5f,0);
	}
}

/* ************************************************************************************************************* */

void KAK_Vehicle_Log::Created(GameObject *obj) {
	if (Settings_LogVehCreate) {
		char CreateMsg[512];
		sprintf(CreateMsg,"%s created",Translate_Preset(obj));
		FDSMessage(CreateMsg);
	}

	if (IsDisableList) {
		if (IsDisableListReady) {
			std::vector<std::string>::iterator it;
			for (it = DisableList.begin(); it != DisableList.end(); ++it) {
				if (strcmp((*it).c_str(),Commands->Get_Preset_Name(obj)) == 0) {
					Commands->Attach_Script(obj,"KAK_Destroy_Tank","");
					break;
				}
			}
		}
		else Commands->Attach_Script(obj,"KAK_DisableList_Refresh","");
	}

	if (Settings_EnableVehicleDamageAnim) Commands->Attach_Script(obj,"KAK_Vehicle_Damage","");
}

void KAK_Vehicle_Log::Killed(GameObject *obj, GameObject *shooter) {
	DeadPlace = Commands->Get_Position(obj);
	Facing = Commands->Get_Facing(obj);
	GameObject *DestroyedTank;

	if (Settings_LogHarvesterDeath && strstr(Commands->Get_Preset_Name(obj),"Harvester")) {
		char HarvMsg[512];
		if (Commands->Get_ID(shooter) == 0) sprintf(HarvMsg,"%s was destroyed",Translate_Preset(obj));
		else if (strcmp(PlayerName(shooter),"ERROR_NotPlayer") != 0) sprintf(HarvMsg,"%s destroyed thanks to %s (%s)",Translate_Preset(obj),PlayerName(shooter),Translate_Preset(IsPlayerVehicle(shooter)));
		else sprintf(HarvMsg,"%s destroyed thanks to the %s",Translate_Preset(obj),Translate_Preset(shooter));
		FDSMessage(HarvMsg);
	}
	else if (Settings_LogVehDeath) {
		char DeathMsg[512];
		if (Commands->Get_ID(shooter) == 0) sprintf(DeathMsg,"%s was destroyed",Translate_Preset(obj));
		else if (strcmp(PlayerName(shooter),"ERROR_NotPlayer") != 0) sprintf(DeathMsg,"%s destroyed thanks to %s (%s)",Translate_Preset(obj),PlayerName(shooter),Translate_Preset(IsPlayerVehicle(shooter)));
		else sprintf(DeathMsg,"%s destroyed thanks to the %s",Translate_Preset(obj),Translate_Preset(shooter));
		FDSMessage(DeathMsg);
	}

	if (Settings_PlayVehDeathAnim) {
		if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Humm-vee")) {
			DestroyedTank = Commands->Create_Object("GDI_Humm-vee",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_APC")) {
			DestroyedTank = Commands->Create_Object("GDI_APC",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Medium_Tank")) {
			DestroyedTank = Commands->Create_Object("GDI_Medium_Tank",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Buggy")) {
			DestroyedTank = Commands->Create_Object("Nod_Buggy",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Light_Tank")) {
			DeadPlace.Z -= (float)1;
			DestroyedTank = Commands->Create_Object("Nod_Light_Tank",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_MRLS")) {
			DestroyedTank = Commands->Create_Object("GDI_MRLS",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Mammoth_Tank")) {
			DestroyedTank = Commands->Create_Object("GDI_Mammoth_Tank",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Transport")) {
			DestroyedTank = Commands->Create_Object("GDI_Transport",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Orca")) {
			DestroyedTank = Commands->Create_Object("GDI_Orca",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester")) {
			DestroyedTank = Commands->Create_Object("GDI_Harvester",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_APC")) {
			DestroyedTank = Commands->Create_Object("Nod_APC",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Mobile_Artillery")) {
			DestroyedTank = Commands->Create_Object("Nod_Mobile_Artillery",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Flame_Tank")) {
			DestroyedTank = Commands->Create_Object("Nod_Flame_Tank",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Stealth_Tank")) {
			DestroyedTank = Commands->Create_Object("Nod_Stealth_Tank",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Transport")) {
			DestroyedTank = Commands->Create_Object("Nod_Transport",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Apache")) {
			DestroyedTank = Commands->Create_Object("Nod_Apache",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester")) {
			DestroyedTank = Commands->Create_Object("Nod_Harvester",DeadPlace);
			Commands->Set_Facing(DestroyedTank,Facing);
			Commands->Attach_Script(DestroyedTank,"KAK_Destroy_Tank","");	
		}
	}
}

void KAK_Destroy_Tank::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,0.001f,1);
}

void KAK_Destroy_Tank::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		Commands->Apply_Damage(obj,99999,"Death",false);
		Commands->Start_Timer(obj,this,0.001f,1);
	}
}

/* ************************************************************************************************************* */

void KAK_Vehicle_Damage::Created(GameObject *obj) {
	IsAlive = true;
	IsFirstShow = IsSecondShow = false;
	TotalHealth = Commands->Get_Max_Health(obj) + Commands->Get_Max_Shield_Strength(obj);
	CurrentHealth = TotalHealth;
	Fire1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
	Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
	Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
	Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
	Explosion1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
	Explosion2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
	if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Mammoth_Tank") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire2,obj,"muzzleb1");
		Commands->Attach_To_Object_Bone(Fire3,obj,"seat");
		Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"seat");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
		Size = 2;
		FireCount = 4;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Medium_Tank") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
		Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire3,obj,"turret");
		Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"damage");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
		Size = 2;
		FireCount = 3;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Humm-vee") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
		Size = 1;
		FireCount = 1;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_APC") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
		Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone4");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
		Size = 2;
		FireCount = 2;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Buggy") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"headlight01");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight01");
		Size = 1;
		FireCount = 1;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Light_Tank") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
		Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire3,obj,"wheelc03r");
		Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
		Size = 2;
		FireCount = 3;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MRLS") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire2,obj,"muzzlea1");
		Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"muzzlea1");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
		Size = 2;
		FireCount = 2;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Transport") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"rotor00");
		Commands->Attach_To_Object_Bone(Fire2,obj,"seat0");
		Commands->Attach_To_Object_Bone(Fire3,obj,"rotor00");
		Commands->Attach_To_Object_Bone(Fire4,obj,"rotor00");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp01");
		Size = 1;
		FireCount = 2;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Orca") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
		Commands->Attach_To_Object_Bone(Fire2,obj,"AddedBone1");
		Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea0");
		Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"engineflame01");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
		Size = 1;
		FireCount = 2;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"wheelp04r");
		Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire3,obj,"clawbone03");
		Commands->Attach_To_Object_Bone(Fire4,obj,"wheelp04r");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp04r");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
		Size = 2;
		FireCount = 3;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_APC") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
		Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
		Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
		Size = 2;
		FireCount = 2;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Mobile_Artillery") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
		Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
		Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp06e");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
		Size = 2;
		FireCount = 2;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Flame_Tank") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
		Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea1");
		Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
		Size = 2;
		FireCount = 3;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Stealth_Tank") == 0) {
		Commands->Destroy_Object(Fire1);
		Commands->Destroy_Object(Fire2);
		Commands->Destroy_Object(Fire3);
		Commands->Destroy_Object(Fire4);
		Fire1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
		Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
		Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
		Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
		Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp02l");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"muzzlea1");
		Size = 2;
		FireCount = 0;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Transport") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"rotor01");
		Commands->Attach_To_Object_Bone(Fire2,obj,"seat1");
		Commands->Attach_To_Object_Bone(Fire3,obj,"rotor01");
		Commands->Attach_To_Object_Bone(Fire4,obj,"rotor01");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor00");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp02");
		Size = 1;
		FireCount = 2;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Apache") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire2,obj,"rotor01");
		Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"engineangle00");
		Size = 1;
		FireCount = 2;
	}
	else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester") == 0) {
		Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
		Commands->Attach_To_Object_Bone(Fire2,obj,"taillight.01");
		Commands->Attach_To_Object_Bone(Fire3,obj,"seat0");
		Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone3");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight.01");
		Size = 2;
		FireCount = 3;
	}
	else {
		Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
		Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
		Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
		Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
		Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
		Commands->Attach_To_Object_Bone(Explosion2,obj,"barrel");
		Size = 1;
		FireCount = 1;
	}
	Commands->Start_Timer(obj,this,0.25f,1);
}

//Timer ffff
void KAK_Vehicle_Damage::Timer_Expired(GameObject *obj, int number) {
	CurrentHealth = Commands->Get_Health(obj) + Commands->Get_Shield_Strength(obj);
	if (number == 1 && IsAlive) {
		if (CurrentHealth < (TotalHealth * 0.3)) {
			IsSecondShow = true;
			IsFirstShow = true;

			Commands->Destroy_Object(Fire1);
			Commands->Destroy_Object(Fire2);
			Commands->Destroy_Object(Fire3);
			Commands->Destroy_Object(Fire4);
			Commands->Destroy_Object(Explosion1);
			Commands->Destroy_Object(Explosion2);
			if (strstr(Commands->Get_Preset_Name(obj),"Harvester")) {
				Fire1 = GVDA(4,0,obj);
				Fire2 = GVDA(4,0,obj);
				Fire3 = GVDA(4,0,obj);
				Fire4 = GVDA(4,0,obj);
			}
			else {
				Fire1 = GVDA(2,0,obj);
				Fire2 = GVDA(2,0,obj);
				Fire3 = GVDA(2,0,obj);
				Fire4 = GVDA(2,0,obj);
			}
			Explosion1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			Explosion2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Mammoth_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzleb1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"seat");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 4;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Medium_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"turret");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Humm-vee") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone4");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Buggy") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"headlight01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight01");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Light_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"wheelc03r");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MRLS") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp01");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Orca") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"AddedBone1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"engineflame01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"clawbone03");
				Commands->Attach_To_Object_Bone(Fire4,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Mobile_Artillery") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp06e");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Flame_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Stealth_Tank") == 0) {
				Commands->Destroy_Object(Fire1);
				Commands->Destroy_Object(Fire2);
				Commands->Destroy_Object(Fire3);
				Commands->Destroy_Object(Fire4);
				Fire1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp02l");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"muzzlea1");
				Size = 2;
				FireCount = 0;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp02");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Apache") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"engineangle00");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"taillight.01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone3");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight.01");
				Size = 2;
				FireCount = 3;
			}
			else {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"barrel");
				Size = 1;
				FireCount = 1;
			}
		}
		else if (CurrentHealth < (TotalHealth * 0.6)) {
			IsFirstShow = true;

			Commands->Destroy_Object(Fire1);
			Commands->Destroy_Object(Fire2);
			Commands->Destroy_Object(Fire3);
			Commands->Destroy_Object(Fire4);
			Commands->Destroy_Object(Explosion1);
			Commands->Destroy_Object(Explosion2);		
			if (strstr(Commands->Get_Preset_Name(obj),"Harvester")) {
				Fire1 = GVDA(4,0,obj);
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			}
			else {
				Fire1 = GVDA(2,0,obj);
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			}
			Explosion1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			Explosion2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Mammoth_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzleb1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"seat");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 4;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Medium_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"turret");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Humm-vee") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone4");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Buggy") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"headlight01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight01");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Light_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"wheelc03r");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MRLS") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp01");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Orca") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"AddedBone1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"engineflame01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"clawbone03");
				Commands->Attach_To_Object_Bone(Fire4,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Mobile_Artillery") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp06e");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Flame_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Stealth_Tank") == 0) {
				Commands->Destroy_Object(Fire1);
				Commands->Destroy_Object(Fire2);
				Commands->Destroy_Object(Fire3);
				Commands->Destroy_Object(Fire4);
				Fire1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Size = 2;
				FireCount = 0;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp02");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Apache") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"engineangle00");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"taillight.01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone3");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight.01");
				Size = 2;
				FireCount = 3;
			}
			else {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"barrel");
				Size = 1;
				FireCount = 1;
			}
		}
		Commands->Start_Timer(obj,this,0.1f,2);
	}
	else if (number == 2) {
		//Reset Second Show aaaa
		if (CurrentHealth >= (TotalHealth * 0.3) && IsSecondShow == true) {
			IsSecondShow = false;

			Commands->Destroy_Object(Fire1);
			Commands->Destroy_Object(Fire2);
			Commands->Destroy_Object(Fire3);
			Commands->Destroy_Object(Fire4);
			Commands->Destroy_Object(Explosion1);
			Commands->Destroy_Object(Explosion2);		
			if (strstr(Commands->Get_Preset_Name(obj),"Harvester")) {
				Fire1 = GVDA(4,0,obj);
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			}
			else {
				Fire1 = GVDA(2,0,obj);
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			}
			Explosion1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			Explosion2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Mammoth_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzleb1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"seat");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 4;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Medium_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"turret");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Humm-vee") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone4");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Buggy") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"headlight01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight01");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Light_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"wheelc03r");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MRLS") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp01");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Orca") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"AddedBone1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"engineflame01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"clawbone03");
				Commands->Attach_To_Object_Bone(Fire4,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Mobile_Artillery") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp06e");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Flame_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Stealth_Tank") == 0) {
				Commands->Destroy_Object(Fire1);
				Commands->Destroy_Object(Fire2);
				Commands->Destroy_Object(Fire3);
				Commands->Destroy_Object(Fire4);
				Fire1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp02l");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"muzzlea1");
				Size = 2;
				FireCount = 0;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp02");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Apache") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"engineangle00");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"taillight.01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone3");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight.01");
				Size = 2;
				FireCount = 3;
			}
			else {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"barrel");
				Size = 1;
				FireCount = 1;
			}
		}
		//Reset First Show bbbb
		else if (CurrentHealth >= (TotalHealth * 0.6) && IsFirstShow == true) {
			IsFirstShow = false;

			Commands->Destroy_Object(Fire1);
			Commands->Destroy_Object(Fire2);
			Commands->Destroy_Object(Fire3);
			Commands->Destroy_Object(Fire4);
			Commands->Destroy_Object(Explosion1);
			Commands->Destroy_Object(Explosion2);		
			Fire1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			Explosion1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			Explosion2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Mammoth_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzleb1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"seat");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 4;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Medium_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"turret");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Humm-vee") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone4");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Buggy") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"headlight01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight01");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Light_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"wheelc03r");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MRLS") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp01");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Orca") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"AddedBone1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"engineflame01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"clawbone03");
				Commands->Attach_To_Object_Bone(Fire4,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Mobile_Artillery") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp06e");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Flame_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Stealth_Tank") == 0) {
				Commands->Destroy_Object(Fire1);
				Commands->Destroy_Object(Fire2);
				Commands->Destroy_Object(Fire3);
				Commands->Destroy_Object(Fire4);
				Fire1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp02l");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"muzzlea1");
				Size = 2;
				FireCount = 0;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp02");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Apache") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"engineangle00");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"taillight.01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone3");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight.01");
				Size = 2;
				FireCount = 3;
			}
			else {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"barrel");
				Size = 1;
				FireCount = 1;
			}
		}
		//Fix Regen Bug eeee
		else if (CurrentHealth == TotalHealth) {
			IsSecondShow = false;
			IsFirstShow = false;
		}
		//Set Second Show cccc
		else if (CurrentHealth < (TotalHealth * 0.3) && IsSecondShow == false) {
			IsSecondShow = true;

			Commands->Destroy_Object(Fire1);
			Commands->Destroy_Object(Fire2);
			Commands->Destroy_Object(Fire3);
			Commands->Destroy_Object(Fire4);
			Commands->Destroy_Object(Explosion1);
			Commands->Destroy_Object(Explosion2);	
			if (strstr(Commands->Get_Preset_Name(obj),"Harvester")) {
				Fire1 = GVDA(4,0,obj);
				Fire2 = GVDA(4,0,obj);
				Fire3 = GVDA(4,0,obj);
				Fire4 = GVDA(4,0,obj);
			}
			else {
				Fire1 = GVDA(2,0,obj);
				Fire2 = GVDA(2,0,obj);
				Fire3 = GVDA(2,0,obj);
				Fire4 = GVDA(2,0,obj);
			}
			Explosion1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			Explosion2 = GVDA(1,Size,obj);
			if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Mammoth_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzleb1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"seat");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 4;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Medium_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"turret");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Humm-vee") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone4");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Buggy") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"headlight01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight01");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Light_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"wheelc03r");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MRLS") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp01");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Orca") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"AddedBone1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"engineflame01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"clawbone03");
				Commands->Attach_To_Object_Bone(Fire4,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Mobile_Artillery") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp06e");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Flame_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Stealth_Tank") == 0) {
				Commands->Destroy_Object(Fire1);
				Commands->Destroy_Object(Fire2);
				Commands->Destroy_Object(Fire3);
				Commands->Destroy_Object(Fire4);
				Fire1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp02l");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"muzzlea1");
				Size = 2;
				FireCount = 0;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp02");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Apache") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"engineangle00");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"taillight.01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone3");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight.01");
				Size = 2;
				FireCount = 3;
			}
			else {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"barrel");
				Size = 1;
				FireCount = 1;
			}
		}
		//Set First Show dddd
		else if (CurrentHealth < (TotalHealth * 0.6) && IsFirstShow == false) {
			IsFirstShow = true;

			Commands->Destroy_Object(Fire1);
			Commands->Destroy_Object(Fire2);
			Commands->Destroy_Object(Fire3);
			Commands->Destroy_Object(Fire4);
			Commands->Destroy_Object(Explosion1);
			Commands->Destroy_Object(Explosion2);		
			if (strstr(Commands->Get_Preset_Name(obj),"Harvester")) {
				Fire1 = GVDA(4,0,obj);
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			}
			else {
				Fire1 = GVDA(2,0,obj);
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			}
			Explosion1 = GVDA(1,Size,obj);
			Explosion2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
			if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Mammoth_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzleb1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"seat");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 4;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Medium_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"turret");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Humm-vee") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat1");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone4");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Buggy") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"headlight01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight01");
				Size = 1;
				FireCount = 1;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Light_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"wheelc03r");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelc03r");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_MRLS") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp01");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Orca") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"AddedBone1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"engineflame01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"clawbone03");
				Commands->Attach_To_Object_Bone(Fire4,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp04r");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_APC") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"turret");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"seat0");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Mobile_Artillery") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp06e");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"damage");
				Size = 2;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Flame_Tank") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Fire2,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire3,obj,"muzzlea1");
				Commands->Attach_To_Object_Bone(Fire4,obj,"muzzlea0");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"turret");
				Size = 2;
				FireCount = 3;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Stealth_Tank") == 0) {
				Commands->Destroy_Object(Fire1);
				Commands->Destroy_Object(Fire2);
				Commands->Destroy_Object(Fire3);
				Commands->Destroy_Object(Fire4);
				Fire1 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire2 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire3 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Fire4 = Commands->Create_Object("NULL",Commands->Get_Position(obj));
				Commands->Attach_To_Object_Bone(Explosion1,obj,"wheelp02l");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"muzzlea1");
				Size = 2;
				FireCount = 0;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Transport") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire2,obj,"seat1");
				Commands->Attach_To_Object_Bone(Fire3,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire4,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor00");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"wheelp02");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Apache") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"rotor01");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"engineangle00");
				Size = 1;
				FireCount = 2;
			}
			else if (strcmp(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester") == 0) {
				Commands->Attach_To_Object_Bone(Fire1,obj,"damage");
				Commands->Attach_To_Object_Bone(Fire2,obj,"taillight.01");
				Commands->Attach_To_Object_Bone(Fire3,obj,"seat0");
				Commands->Attach_To_Object_Bone(Fire4,obj,"damage");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"AddedBone3");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"taillight.01");
				Size = 2;
				FireCount = 3;
			}
			else {
				Commands->Attach_To_Object_Bone(Fire1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire2,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire3,obj,"barrel");
				Commands->Attach_To_Object_Bone(Fire4,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion1,obj,"barrel");
				Commands->Attach_To_Object_Bone(Explosion2,obj,"barrel");
				Size = 1;
				FireCount = 1;
			}
		}
		Sleep(0);
		Commands->Start_Timer(obj,this,0.1f,2);
	}
}

void KAK_Vehicle_Damage::Killed(GameObject *obj, GameObject *shooter) {
	IsAlive = false;
	Commands->Destroy_Object(Fire1);
	Commands->Destroy_Object(Fire2);
	Commands->Destroy_Object(Fire3);
	Commands->Destroy_Object(Fire4);
	Commands->Destroy_Object(Explosion1);
	Commands->Destroy_Object(Explosion2);
}

void KAK_Vehicle_Damage::Destroyed(GameObject *obj) {
	IsAlive = false;
	Commands->Destroy_Object(Fire1);
	Commands->Destroy_Object(Fire2);
	Commands->Destroy_Object(Fire3);
	Commands->Destroy_Object(Fire4);
	Commands->Destroy_Object(Explosion1);
	Commands->Destroy_Object(Explosion2);
}

/* ************************************************************************************************************* */

void KAK_Obelisk_Powerup::Created(GameObject *obj) {
	IsPowerup = false;
	ObGlitchCount = 0;
	LastID = 0;
}

void KAK_Obelisk_Powerup::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 2 && IsPowerup == false && Settings_OBAnim) {
		IsPowerup = true;
		Powerup = Commands->Create_Object("Obelisk Effect",Commands->Get_Position(obj));
		Commands->Start_Timer(obj,this,3.0f,1);
		if (strstr(Commands->Get_Preset_Name(Commands->Find_Object(param)),"estroyed")) {
			Commands->Apply_Damage(Commands->Find_Object(param),99999,"Death",false);
		}

		if (Settings_OBGEnable) {
			if (LastID == param) {
				ObGlitchCount++;
				if (ObGlitchCount >= 10) {
					char message[50], message2[50], FDSM[100];
					sprintf(message,"kick %s",PlayerName(Commands->Find_Object(param)));
					sprintf(message2,"allow %s",PlayerName(Commands->Find_Object(param)));
					sprintf(FDSM,"Player %s has been kicked for glitching the Obelisk",PlayerName(Commands->Find_Object(param)));
					ConsoleCommand(message);
					ConsoleCommand(message2);
					FDSMessage(FDSM);
				}
				else if (ObGlitchCount >= 8) {
					char message[256], FDSM[100];
					sprintf(message,"page %s %s",PlayerName(Commands->Find_Object(param)),Settings_OBGPageMessage);
					sprintf(FDSM,"Player %s has been warned for glitching the Obelisk",PlayerName(Commands->Find_Object(param)));
					ConsoleCommand(message);
					FDSMessage(FDSM);
				}
			}
			else {
				LastID = param;
				ObGlitchCount = 0;
			}
		}
	}
}

void KAK_Obelisk_Powerup::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		if (Commands->Get_ID(Powerup) != 0) Commands->Destroy_Object(Powerup);
		IsPowerup = false;
	}
}

/* ************************************************************************************************************* */

void KAK_Disable_Base_Defense_Preset::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,5.0f,1);
}

void KAK_Disable_Base_Defense_Preset::Timer_Expired(GameObject *obj, int number) {
	if (Settings_DisableBaseDefenses && number == 1) {
		Commands->Apply_Damage(obj,99999,"Death",false);
		Commands->Destroy_Object(obj);
	}
}

/* ************************************************************************************************************* */

ScriptRegistrant<M00_BUILDING_EXPLODE_NO_DAMAGE_DAK> M00_BUILDING_EXPLODE_NO_DAMAGE_DAK_Registrant("M00_BUILDING_EXPLODE_NO_DAMAGE_DAK","");
ScriptRegistrant<M00_Disable_Transition> M00_Disable_Transition_Registrant("M00_Disable_Transition","");
ScriptRegistrant<M00_GrantPowerup_Created> M00_GrantPowerup_Created_Registrant("M00_GrantPowerup_Created","WeaponDef:string");
ScriptRegistrant<KAK_Backpack_Object> KAK_Backpack_Object_Registrant("KAK_Backpack_Object","CharacterType:string");
ScriptRegistrant<KAK_Beacon_Log> KAK_Beacon_Log_Registrant("KAK_Beacon_Log","");
ScriptRegistrant<KAK_Beacon_Log_CreateControl> KAK_Beacon_Log_CreateControl_Registrant("KAK_Beacon_Log_CreateControl","Beacon:string,ID:int");
ScriptRegistrant<KAK_Beacon_Animation_Log> KAK_Beacon_Animation_Log_Registrant("KAK_Beacon_Animation_Log","");
ScriptRegistrant<KAK_Random_Weather> KAK_Random_Weather_Registrant("KAK_Random_Weather","BarrID:int");
ScriptRegistrant<KAK_Vehicle_Log> KAK_Vehicle_Log_Registrant("KAK_Vehicle_Log","");
ScriptRegistrant<KAK_Destroy_Tank> KAK_Destroy_Tank_Registrant("KAK_Destroy_Tank","");
ScriptRegistrant<KAK_Vehicle_Damage> KAK_Vehicle_Damage_Registrant("KAK_Vehicle_Damage","");
ScriptRegistrant<KAK_Obelisk_Powerup> KAK_Obelisk_Powerup_Registrant("KAK_Obelisk_Powerup","");
ScriptRegistrant<KAK_DisableList_Refresh> KAK_DisableList_Refresh_Registrant("KAK_DisableList_Refresh","");
ScriptRegistrant<KAK_Disable_Base_Defense_Preset> KAK_Disable_Base_Defense_Preset_Registrant("KAK_Disable_Base_Defense_Preset","");
