//************************************************************************************************
//Ra2.cpp
//Fait par: Francois-Gabriel Auclair aka TheKGBspy
//section pour les scripts principalement utiliss par le mod Ra2:vengeance
//derniere modification: 5 avril 2004
//e-mail: Boris_the_invincible@hotmail.com
//e-mail2: TheKGBspy@timeofwar.com
//************************************************************************************************

#include "scripts.h"
#include "Ra2.h"
#include <math.h>

//************************************************************************************************
//Script pour le mirage tank
//************************************************************************************************
void Ra2Ven_MirageTank::Created(GameObject * obj)
{
	pilotID = 0;
	xpos = 0;
	ypos = 0;
	zpos = 0;
	IsHided = false;
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNumber"));

}

//**********************
void Ra2Ven_MirageTank::Killed(GameObject * obj,GameObject * shooter)
{
	Vector3 TreeExplo;
	TreeExplo = Commands->Get_Bone_Position(obj,"origin");
	Commands->Create_Explosion(Get_Parameter("Explosion_Preset"),TreeExplo,0);
}

//**********************
void Ra2Ven_MirageTank::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&pilotID);
	Auto_Save_Variable(2,4,&xpos);
	Auto_Save_Variable(3,4,&ypos);
	Auto_Save_Variable(4,4,&zpos);
	Auto_Save_Variable(5,1,&IsHided);
}

//**********************
void Ra2Ven_MirageTank::Timer_Expired(GameObject * obj,int number)
{

	const char* preset;
	int rand;
	GameObject *tree;
	Vector3 TreePos;
	Vector3 TreeExplo;
	
	Vector3 position = Commands->Get_Position(obj);
	if ((xpos == 0) && (ypos == 0) && (zpos == 0))
	{
		xpos = position.X;
		ypos = position.Y;
		zpos = position.Z;
	}
	
	if (pilotID != 0)
	{
		if ((fabs(position.X-xpos) <= .5) && (fabs(position.Y-ypos) <= .5) && (fabs(position.Z-zpos) <= .5))
		{
		  if (IsHided == false)
		  {
			
			//random pis attach dun abre
			
			preset = "none";

			while (stricmp(preset, "none") == 0)
			{
				rand = Commands->Get_Random_Int(1,4);
				switch(rand)
				{
					case 1:         preset = Get_Parameter("Tree1_Preset");
									break;
					case 2:         preset = Get_Parameter("Tree2_Preset");
									break;
					case 3:         preset = Get_Parameter("Tree3_Preset");
									break;
					case 4:         preset = Get_Parameter("Tree4_Preset");
									break;
				}
			}

			TreePos.X = 0;
			TreePos.Y = 0;
			TreePos.Z = 0;
			tree = Commands->Create_Object(preset,TreePos);
			//Commands->Disable_Physical_Collisions(tree);
			Commands->Attach_To_Object_Bone(tree,obj,"origin");

			Commands->Set_Is_Rendered(obj,false);
			IsHided = true;

		  }
		}
		else
		{
			xpos = position.X;
			ypos = position.Y;
			zpos = position.Z;
			if (IsHided == true)
			{
				Commands->Set_Is_Rendered(obj,true);
				IsHided = false;
				TreeExplo = Commands->Get_Bone_Position(obj,"origin");
				Commands->Create_Explosion(Get_Parameter("Explosion_Preset"),TreeExplo,0);
			}
		}
		
	}
	else
	{
		if (IsHided == true)
		{
			Commands->Set_Is_Rendered(obj,true);
			IsHided = false;
			TreeExplo = Commands->Get_Bone_Position(obj,"origin");
			Commands->Create_Explosion(Get_Parameter("Explosion_Preset"),TreeExplo,0);
		}

	}

	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNumber"));
}

//**********************
void Ra2Ven_MirageTank::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	if (message == 1000000028) {
		pilotID = Commands->Get_ID(sender);
	}
	if (message == 1000000029) {
		pilotID = 0;
	}

}


//************************************************************************************************
//Script de dommage par rapport au temp tomber.
//************************************************************************************************
void Ra2Ven_VehicleFalling::Created(GameObject * obj)
{
	IsFalling = false;
	xpos = 0;
	ypos = 0;
	zpos = 0;
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNumber"));
}

//**********************
void Ra2Ven_VehicleFalling::Timer_Expired(GameObject *obj, int number)
{
	Vector3 position = Commands->Get_Position(obj);
	const char* warh;
	double calcul;
	int convert;
	float dom;

	if ((xpos == 0) && (ypos == 0) && (zpos == 0))
	{
		xpos = position.X;
		ypos = position.Y;
		zpos = position.Z;
	}

	if ((position.Z-zpos) > Get_Int_Parameter("ZValueBeforeStartFallingMode"))
	{
		IsFalling = true;
	}
	else //pas entrain de tomber...
	{
		if (IsFalling == true)
		{
			Vector3 ExplosionSound;
			calcul = (fabs(zpos-position.Z)/2.5)*Get_Int_Parameter("DommageMultiplier");//calcul
			convert = (int)calcul;
			dom = (float)convert;
			warh = Get_Parameter("Warhead");
			ExplosionSound = Commands->Get_Bone_Position(obj,"origin");
			Commands->Create_Explosion(Get_Parameter("ImpactExplosion_Preset"),ExplosionSound,0);
			Commands->Apply_Damage(obj,dom,warh,0);
			IsFalling = false;
		}

		zpos = position.Z;

	}
	
	
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNumber"));
}

//**********************
void Ra2Ven_VehicleFalling::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&IsFalling);
	Auto_Save_Variable(2,4,&xpos);
	Auto_Save_Variable(3,4,&ypos);
	Auto_Save_Variable(4,4,&zpos);
}

//************************************************************************************************
//Script pour demo truck contre le bug du friendly fire pis le double nuke
//************************************************************************************************

void Ra2Ven_DemoTruck::Created(GameObject *obj)
{
	pilotID = 0;
	CanExplode = true;
}

//**********************
void Ra2Ven_DemoTruck::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	if (message == 1000000028) {
		pilotID = Commands->Get_ID(sender);
	}
	if (message == 1000000029) {
		pilotID = 0;
	}

}

//**********************
void Ra2Ven_DemoTruck::Damaged(GameObject * obj,GameObject * damager,float damage)
{
	if ((damager == Commands->Find_Object(pilotID)) && (damager != NULL))
	{
		CanExplode = false;
		Commands->Apply_Damage(obj,Get_Float_Parameter("FFFDommage"),Get_Parameter("FFFWh"),0);
	}
}

//**********************
void Ra2Ven_DemoTruck::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&pilotID);
	Auto_Save_Variable(2,1,&CanExplode);
}

//**********************
void Ra2Ven_DemoTruck::Killed(GameObject * obj,GameObject * shooter)
{
	if (CanExplode == true)
	{
		Vector3 DemoCharge;
		DemoCharge = Commands->Get_Bone_Position(obj,"origin");
		Commands->Create_Explosion(Get_Parameter("Demo_Explosion"),DemoCharge,0);
	}
}

//************************************************************************************************
//Deployable vehicles
//************************************************************************************************
void Ra2Ven_Deployable_Vehicle::Created(GameObject * obj)
{
	pilotID = 0;
	CanDestroyAnim = true;
}

//**********************
void Ra2Ven_Deployable_Vehicle::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	if (message == 1000000028) {
		pilotID = Commands->Get_ID(sender);
	}
	if (message == 1000000029) {
		pilotID = 0;
	}
}

//**********************
void Ra2Ven_Deployable_Vehicle::Damaged(GameObject * obj,GameObject * damager,float damage)
{
	GameObject * Animation;
	Vector3 position;
	int TempCalcul;


	if ((damager == Commands->Find_Object(pilotID)) && (damager != NULL))
	{
		position.X = 0;
		position.Y = 0;
		position.Z = 0;
		Animation = Commands->Create_Object(Get_Parameter("Animation_Preset"),position);

		TempCalcul = (int)(Commands->Get_Max_Health(Animation) * (Commands->Get_Health(obj)/Commands->Get_Max_Health(obj)));
		Commands->Set_Health(Animation,(float)TempCalcul);
			
		TempCalcul = (int)(Commands->Get_Max_Shield_Strength(Animation) * (Commands->Get_Shield_Strength(obj)/Commands->Get_Max_Shield_Strength(obj)));
		Commands->Set_Shield_Strength(Animation,(float)TempCalcul);
	

		Commands->Attach_To_Object_Bone(Animation,obj,"origin");

		CanDestroyAnim = false;
		Commands->Apply_Damage(obj,Get_Float_Parameter("oldTnk_Dommage"),Get_Parameter("oldTnk_Wh"),0);//kill the old tank

	}
}

//**********************
void Ra2Ven_Deployable_Vehicle::Killed(GameObject * obj,GameObject * shooter)
{
	Vector3 position; //= Commands->Get_Position(obj);

	if (CanDestroyAnim == true)
	{
		position = Commands->Get_Bone_Position(obj,"origin");
		Commands->Create_Explosion(Get_Parameter("Explosion_preset"),position,0);

	}
}

//**********************
void Ra2Ven_Deployable_Vehicle::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&pilotID);
	Auto_Save_Variable(2,4,&pilotID);

}

//************************************************************************************************
//Deploy animation
//************************************************************************************************
void Ra2Ven_Deploy_Animation::Created(GameObject * obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Animation_Time"),Get_Int_Parameter("TimerNumber"));
}

//**********************
void Ra2Ven_Deploy_Animation::Timer_Expired(GameObject * obj,int number)
{
	GameObject * DeployedTnk;
	Vector3 position;
	int TempCalcul;

	position.X = 0;
	position.Y = 0;
	position.Z = 0;
	DeployedTnk = Commands->Create_Object(Get_Parameter("Deployed_Tank_Preset"),position);

	TempCalcul = (int)(Commands->Get_Max_Health(DeployedTnk) * (Commands->Get_Health(obj)/Commands->Get_Max_Health(obj)));
	Commands->Set_Health(DeployedTnk,(float)TempCalcul);
			
	TempCalcul = (int)(Commands->Get_Max_Shield_Strength(DeployedTnk) * (Commands->Get_Shield_Strength(obj)/Commands->Get_Max_Shield_Strength(obj)));
	Commands->Set_Shield_Strength(DeployedTnk,(float)TempCalcul);

	Commands->Attach_To_Object_Bone(DeployedTnk,obj,"origin");
	Commands->Apply_Damage(obj,Get_Float_Parameter("oldTnk_Dommage"),Get_Parameter("oldTnk_Wh"),0);//kill the old tank
}

//************************************************************************************************
//Registrant des scripts
//************************************************************************************************
ScriptRegistrant<Ra2Ven_MirageTank> Ra2Ven_MirageTank_Registrant ("Ra2Ven_MirageTank","Tree1_Preset:string,Tree2_Preset=none:string,Tree3_Preset=none:string,Tree4_Preset=none:string,Explosion_Preset:string,Time=1:float,TimerNumber:int"); 
ScriptRegistrant<Ra2Ven_VehicleFalling> Ra2Ven_VehicleFalling_Registrant ("Ra2Ven_VehicleFalling","ZValueBeforeStartFallingMode:int=3,ImpactExplosion_Preset:string,Warhead:string,DommageMultiplier=10:int,Time=1:float,TimerNumber:int"); 
ScriptRegistrant<Ra2Ven_DemoTruck> Ra2Ven_DemoTruck_Registrant ("Ra2Ven_DemoTruck","FFFDommage:float,FFFWh:string,Demo_Explosion:string");
ScriptRegistrant<Ra2Ven_Deployable_Vehicle> Ra2Ven_Deployable_Vehicle_Registrant ("Ra2Ven_Deployable_Vehicle","Animation_Preset:string,oldTnk_Wh:string,oldTnk_Dommage:float,Explosion_preset:string");
ScriptRegistrant<Ra2Ven_Deploy_Animation> Ra2Ven_Deploy_Animation_Registrant ("Ra2Ven_Deploy_Animation","Deployed_Tank_Preset:string,oldTnk_Wh:string,oldTnk_Dommage:float,Animation_Time:float,TimerNumber:int");
//***********************
