#include "scripts.h"
#include "SCUD.h"
#include <iosfwd>
#include <fstream>
//Script for Turret Spawns
void SCUD_Turret_Spawn::Created(GameObject * obj)
{
	Vector3 sp;
	GameObject *object;
	sp.X = 0;
	sp.Y = 0;
	sp.Z = 0;
	object = Commands->Create_Object(Get_Parameter("Turret_Preset"),sp);
	Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("Bone_Name"));
	turID = Commands->Get_ID(object);
}
void SCUD_Turret_Spawn::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&turID);
}
void SCUD_Turret_Spawn::Killed(GameObject * obj,GameObject * shooter)
{
	Vector3 tmb;
	tmb = Commands->Get_Bone_Position(obj,Get_Parameter("Bone_Name"));
	Commands->Create_Explosion(Get_Parameter("Explosion_Preset"),tmb,0);
}
//Script for the RefineryZone
void SCUD_Harvester_Zone::Entered(GameObject * obj,GameObject *enter)
{
	if ((enabled != false ) && (Get_Int_Parameter("Harvester_Preset_ID") == Commands->Get_Preset_ID(enter)))
	{
		enabled = false;
		Commands->Give_Money(enter,Get_Float_Parameter("Credits"),true);
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Next_Harvester_Time"),1);
	}
	if ((enabled != false ) && (Get_Int_Parameter("LvlHarvester_Preset_ID") == Commands->Get_Preset_ID(enter)))
	{
		enabled = false;
		Commands->Give_Money(enter,Get_Float_Parameter("Credits"),true);
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Next_Harvester_Time"),1);
	}
	if ((enabled != false ) && (Get_Int_Parameter("Thief_Preset_ID") == Commands->Get_Preset_ID(enter)))
	{
		enabled = false;
		Commands->Give_Money(enter,Get_Float_Parameter("Thief_Credits"),true);
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Thief_Time"),1);
	}
}
void SCUD_Harvester_Zone::Timer_Expired(GameObject * obj,int number)
{
	enabled = true;
}
void SCUD_Harvester_Zone::Created(GameObject * obj)
{
	enabled = true;
}
void SCUD_Harvester_Zone::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&enabled);
}

void SCUD_Custom_Follow_Waypath::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	int msg;
	int waypathid;
	float speed;
	waypathid = Get_Int_Parameter("WaypathID");
	speed = Get_Float_Parameter("Speed");
	msg = Get_Int_Parameter("Message");	
	if (msg == message) {
		ActionParamsStruct params;
		params.Set_Move_Arrive_Distance(100);
		params.Set_Basic(this,100,777,-1);
		params.Set_Goto(0,speed,10);
		params.Set_Goto_Waypath(waypathid,true,false,false);
		Commands->Action_Goto(obj,params);
	}
}

void SCUD_Custom_Follow_Waypath::Action_Complete(GameObject * obj,int action,ActionCompleteReason reason)
{
	int waypathid;
	float speed;
	waypathid = Get_Int_Parameter("WaypathID");
	speed = Get_Float_Parameter("Speed");
	ActionParamsStruct params;
	params.Set_Move_Arrive_Distance(100);
	params.Set_Basic(this,100,777,-1);
	params.Set_Goto(0,speed,10);
	params.Set_Goto_Waypath(waypathid,true,false,false);
	Commands->Action_Goto(obj,params);
}

void SCUD_Follow_Waypath_Until_Custom::Created(GameObject * obj)
{
	int waypathid;
	float speed;
	waypathid = Get_Int_Parameter("WaypathID");
	speed = Get_Float_Parameter("Speed");
	ActionParamsStruct params;
	params.Set_Move_Arrive_Distance(100);
	params.Set_Basic(this,100,777,-1);
	params.Set_Goto(0,speed,10);
	params.Set_Goto_Waypath(waypathid,true,false,false);
	Commands->Action_Goto(obj,params);
	disable = false;
}
void SCUD_Follow_Waypath_Until_Custom::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	int msg;
	msg = Get_Int_Parameter("Message");	
	if (msg == message) {
		disable = true;
	}
}
void SCUD_Follow_Waypath_Until_Custom::Action_Complete(GameObject * obj,int action,ActionCompleteReason reason)
{
	if (disable == false)
	{
		int waypathid;
		float speed;
		waypathid = Get_Int_Parameter("WaypathID");
		speed = Get_Float_Parameter("Speed");
		ActionParamsStruct params;
		params.Set_Move_Arrive_Distance(100);
		params.Set_Basic(this,100,777,-1);
		params.Set_Goto(0,speed,10);
		params.Set_Goto_Waypath(waypathid,true,false,false);
		Commands->Action_Goto(obj,params);
	}
}
void SCUD_Follow_Waypath_Until_Custom::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&disable);
}
//Script for Single Preset Buy Terminals
void SCUD_Poke_Preset_Buy::Created(GameObject * obj)
{
	active = 1;
	Commands->Enable_HUD_Pokable_Indicator(obj,1);
}
void SCUD_Poke_Preset_Buy::Custom(GameObject * obj,GameObject * sender)
{
	active = 1;
	Commands->Enable_HUD_Pokable_Indicator(obj,1);
	
}
void SCUD_Poke_Preset_Buy::Poked(GameObject * obj,GameObject * poker)
{
	//dec
	const char *preset;
	int x;
	int cost;
	Vector3 spawn_position;
	//def
	x = Get_Int_Parameter("Player_Type");
	if (CheckPlayerType(poker,x) != 0) {
		return;
	}
	preset = Get_Parameter("Preset_Name");
	cost = Get_Int_Parameter("Cost");
	//func
	if (cost <= Commands->Get_Money(poker)) {
		cost = -cost;
		spawn_position = Get_Vector3_Parameter("location");
		Commands->Give_Money(poker,(float)cost,0);
		Commands->Create_Object(preset, spawn_position);
	}
}
void SCUD_Poke_Preset_Buy::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&active);
}


//Script for Single Preset Buy Terminals (Vehicle way)
void SCUD_Preset_Buy::Created(GameObject * obj)
{
	active = 1;
	Commands->Enable_HUD_Pokable_Indicator(obj,1);
}

void SCUD_Preset_Buy::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
   
	//dec
	const char *preset;
	GameObject * npre;
	int x;
	int cost;
	float facing;
	Vector3 spawn_position;
	//def
	x = Get_Int_Parameter("Player_Type");
	if (CheckPlayerType(sender,x) != 0) {
		return;
	}
	cost = Get_Int_Parameter("Cost");
	//func
	if (message == 1000000028) {
    	if (cost <= Commands->Get_Money(sender)) {
			cost = -cost;
			preset = Get_Parameter("Preset_Name");
			spawn_position = Get_Vector3_Parameter("location");
			Commands->Give_Money(sender,(float)cost,0);
			npre = Commands->Create_Object(preset,spawn_position);
			facing = Get_Float_Parameter("Rotation");
			Commands->Set_Facing(npre,facing);
		}
	}
	
	


}
void SCUD_Preset_Buy::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&active);
}

/* dont work yet!
//Script for Single Preset Buy Terminals + Destroy Object (Vehicle way)
void SCUD_Preset_Buy_Destroy_Object::Created(GameObject * obj)
{
	active = 1;
	Commands->Enable_HUD_Pokable_Indicator(obj,1);
}

void SCUD_Preset_Buy_Destroy_Object::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
   
	//dec
	const char *c;
	int unknown;
	Vector3 v;
	const char *preset;
	GameObject * npre; 
	int x;
	int cost;
	float facing;
	Vector3 spawn_position;
	//def
	x = Get_Int_Parameter("Player_Type");
	GameObject * sendobj;
	if (CheckPlayerType(sender,x) != 0) {
		return;
	}
	cost = Get_Int_Parameter("Cost");
	//func
	if (message == 1000000028) {
    	if (cost <= Commands->Get_Money(sender)) {
			cost = -cost;
			preset = Get_Parameter("Preset_Name");
			spawn_position = Get_Vector3_Parameter("location");
			Commands->Give_Money(sender,(float)cost,0);
			npre = Commands->Create_Object(preset,spawn_position);
			facing = Get_Float_Parameter("Rotation");
			Commands->Set_Facing(npre,facing);
		}
	
	}
	c = Get_Parameter("Explosion");
	v = Commands->Get_Position(obj);
	Commands->Create_Explosion(c,v,0);
	//Commands->Destroy_Object(obj);


}
void SCUD_Preset_Buy_Destroy_Object::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&active);
}


*/

/*dont work yet!
//Script for Single Preset Buy Terminals + Send Custom(Vehicle way)
void SCUD_Preset_Buy_Send_Custom::Created(GameObject * obj)
{
	active = 1;
	Commands->Enable_HUD_Pokable_Indicator(obj,1);
}

void SCUD_Preset_Buy_Send_Custom::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
   
	//dec
	const char *c;
	int unknown;
	Vector3 v;
	const char *preset;
	GameObject * npre;
	int x;
	int cost;
	float facing;
	Vector3 spawn_position;
	//def
	x = Get_Int_Parameter("Player_Type");
	GameObject * sendobj;
	if (CheckPlayerType(sender,x) != 0) {
		return;
	}
	cost = Get_Int_Parameter("Cost");
	//func
	if (message == 1000000028) {
    	if (cost <= Commands->Get_Money(sender)) {
			cost = -cost;
			preset = Get_Parameter("Preset_Name");
			spawn_position = Get_Vector3_Parameter("location");
			Commands->Give_Money(sender,(float)cost,0);
			npre = Commands->Create_Object(preset,spawn_position);
			facing = Get_Float_Parameter("Rotation");
			Commands->Set_Facing(npre,facing);
		}
		Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("SendID")),Get_Int_Parameter("SendMessage"),Get_Int_Parameter("SendParam"),0);
	}
	
	


}
void SCUD_Preset_Buy_Send_Custom::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&active);
}
*/
//Script for Deployable Vehicle
void SCUD_Deployable_Vehicle::Created(GameObject * obj)
{
	pilotID = 0;
}
void SCUD_Deployable_Vehicle::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
   if (message == 1000000028) {
      pilotID = Commands->Get_ID(sender);
   }
   if (message == 1000000029) {
      pilotID = 0;
   }
}
void SCUD_Deployable_Vehicle::Damaged(GameObject * obj,GameObject * damager,float damage)
{
	const char* preset;
	GameObject * npre;
	Vector3 pos;
	float health;
	float facing;
	if ((damager == Commands->Find_Object(pilotID)) && (damager != NULL))
	{
		preset = Get_Parameter("Animated_Preset");
		pos = Commands->Get_Position(obj);
		health = Commands->Get_Health(obj);
		npre = Commands->Create_Object(preset,pos);
		Commands->Set_Health(npre,health);
		health = Commands->Get_Shield_Strength(obj);
		Commands->Set_Shield_Strength(npre,health);
		facing = Commands->Get_Facing(obj);
		Commands->Set_Facing(npre,facing);
 		preset = Get_Parameter("Explosion_Preset");
		Commands->Create_Explosion(preset,pos,0);
	}
}
void SCUD_Deployable_Vehicle::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&pilotID);
}

//Script for Deployable Vehicle Animation
void SCUD_Deploy_Animation::Created(GameObject * obj)
{
	Commands->Start_Timer(obj, this,Get_Float_Parameter("Time_Till_Death") , 1);
}
void SCUD_Deploy_Animation::Timer_Expired(GameObject * obj,int number)
{
	const char* preset;
	GameObject * npre;
	Vector3 pos;
	float health;
	float facing;
	preset = Get_Parameter("Deployed_Tank_Preset");
	pos = Commands->Get_Position(obj);
	health = Commands->Get_Health(obj);
	npre = Commands->Create_Object(preset,pos);
	Commands->Set_Health(npre,health);
	health = Commands->Get_Shield_Strength(obj);
	Commands->Set_Shield_Strength(npre,health);
	facing = Commands->Get_Facing(obj);
	Commands->Set_Facing(npre,facing);
 	preset = Get_Parameter("Explosion_Preset");
	Commands->Create_Explosion(preset,pos,0);
}






ScriptRegistrant<SCUD_Turret_Spawn> SCUD_Turret_Spawn_Registrant ("SCUD_Turret_Spawn","Turret_Preset:string,Bone_Name=BoneName:string,Explosion_Preset:string");
ScriptRegistrant<SCUD_Harvester_Zone> SCUD_Harvester_Zone_Registrant("SCUD_Harvester_Zone","Credits=1000.00:float,Next_Harvester_Time=5.00:float,Harvester_Preset_ID:int,LvlHarvester_Preset_ID:int,Thief_Credits=500.00:float,Thief_Time=5.00:float,Thief_Preset_ID:int");
ScriptRegistrant<SCUD_Custom_Follow_Waypath> SCUD_Custom_Follow_Waypath_Registrant("SCUD_Custom_Follow_Waypath","WaypathID:int,Speed:float,Message:int");
ScriptRegistrant<SCUD_Follow_Waypath_Until_Custom> SCUD_Follow_Waypath_Until_Custom_Registrant("SCUD_Follow_Waypath_Until_Custom","WaypathID:int,Speed:float,Message:int");
ScriptRegistrant<SCUD_Poke_Preset_Buy> SCUD_Poke_Preset_Buy_Registrant("SCUD_Poke_Preset_Buy","Unknown:float,Preset_Name:string,Cost:int,location:Vector3,Player_Type:int");
ScriptRegistrant<SCUD_Preset_Buy> SCUD_Preset_Buy_Registrant("SCUD_Preset_Buy","Unknown:float,Preset_Name:string,Cost:int,location:Vector3,Player_Type:int,Rotation:float");
//ScriptRegistrant<SCUD_Preset_Buy_Destroy_Object> SCUD_Preset_Buy_Destroy_Object_Registrant("SCUD_Preset_Buy_Destroy_Object","Unknown:float,Preset_Name:string,Cost:int,location:Vector3,Player_Type:int,Rotation:float,Explosion:string");
//ScriptRegistrant<SCUD_Preset_Buy_Send_Custom> SCUD_Preset_Buy_Send_Custom_Registrant("SCUD_Preset_Buy_Send_Custom","Unknown:float,Preset_Name:string,Cost:int,location:Vector3,Player_Type:int,Rotation:float,SendID:int,SendMessage:int,SendParam:int");
ScriptRegistrant<SCUD_Deployable_Vehicle> SCUD_Deployable_Vehicle_Registrant ("SCUD_Deployable_Vehicle","Animated_Preset:string,Explosion_Preset:string");
ScriptRegistrant<SCUD_Deploy_Animation> SCUD_Deploy_Animation_Registrant ("SCUD_Deploy_Animation","Time_Till_Death:float,Deployed_Tank_Preset:string,Explosion_Preset:string");
