#include "scripts.h"
#include "jfwws.h"
void JFW_Building_Explode_No_Damage::Killed(GameObject * obj,GameObject * shooter)
{
	Vector3 pos = Commands->Get_Position(obj);
	Commands->Shake_Camera(pos,(float)25.0,(float)0.1,(float)4.0);
}
void JFW_Viceroid_Innate::Created(GameObject * obj)
{
	Commands->Set_Loiters_Allowed(obj,false);
	Commands->Set_Animation(obj,"C_Visceroid.C_Visceroid",true,0,0,-1.0,false);
}
void JFW_Viceroid_Innate::Killed(GameObject * obj,GameObject * shooter)
{
	Commands->Set_Animation(obj,"C_Visceroid.C_Visceroid_Die",false,0,0,-1.0,false);
}
void JFW_No_Innate::Created(GameObject * obj)
{
	Commands->Innate_Disable(obj);
}
void JFW_Credit_Trickle::Created(GameObject * obj)
{
	float delay;
	delay = Get_Float_Parameter("Delay");
	Commands->Start_Timer(obj,this,delay,667);
}
void JFW_Credit_Trickle::Timer_Expired(GameObject * obj,int number)
{
	if(number == 667)
	{
		Commands->Give_Money(obj,(float)Get_Int_Parameter("Credits"),true);
		float delay;
		delay = Get_Float_Parameter("Delay");
		Commands->Start_Timer(obj,this,delay,667);
	}
}
void JFW_PCT_Pokable::Created(GameObject * obj)
{
	Commands->Enable_HUD_Pokable_Indicator(obj,true);
	Commands->Display_Health_Bar(obj,false);
}
void JFW_Vehicle_Regen::Created(GameObject * obj)
{
	Commands->Send_Custom_Event(obj,obj,0,0,0);
}
void JFW_Vehicle_Regen::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	if (message == 0)
	{
		float health = Commands->Get_Health(obj);
		float maxhealth = Commands->Get_Max_Health(obj);
		if (health < maxhealth)
		{
			Commands->Apply_Damage(obj,-2.0,"RegenHealth",0);
		}
		Commands->Send_Custom_Event(obj,obj,0,0,1.0);
	}
}
void JFW_Disable_Transition::Created(GameObject * obj)
{
	Commands->Enable_Vehicle_Transitions(obj,false);
}
void JFW_Permanent_No_Falling_Damage::Created(GameObject * obj)
{
	health = Commands->Get_Health(obj);
}
void JFW_Permanent_No_Falling_Damage::Damaged(GameObject * obj,GameObject * damager,float damage)
{
	if (damage == 0)
	{
		Commands->Set_Health(obj,health);
	}
}
void JFW_Permanent_No_Falling_Damage::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	if (message == 1000000035)
	{
		health = Commands->Get_Health(obj);
	}
}
void JFW_Permanent_No_Falling_Damage::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&health);
}
void JFW_Death_Powerup::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	if ((message == 1000000025) && (sender != 0))
	{
		Commands->Apply_Damage(sender,10000,"Death",0);
	}
}
void JFW_GrantPowerup_Created::Created(GameObject * obj)
{
	Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),false);
}
void JFW_CnC_Crate::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	if ((message == 1000000025) && (sender != 0))
	{
		Commands->Give_Money(sender,100,false);
	}
}
void JFW_Tiberium_Refinery::Created(GameObject * obj)
{
	Commands->Start_Timer(obj,this,(float)Get_Int_Parameter("TimerLength"),1);
}
void JFW_Tiberium_Refinery::Timer_Expired(GameObject * obj,int number)
{
	if (number == 1)
	{
		if (Commands->Get_Health(obj) != 0)
		{
			Commands->Give_Money(obj,(float)Get_Int_Parameter("MoneyAmount"),true);
			Commands->Start_Timer(obj,this,(float)Get_Int_Parameter("TimerLength"),1);
		}
	}
}
void JFW_GrantMoney_Powerup::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	float scoreamount = Get_Float_Parameter("ScoreAmount");
	int entireteam = Get_Int_Parameter("Entire_Team");
	int randomizer = Get_Int_Parameter("Randomizer");
	if (randomizer = 0)
	{
		randomizer = 1;
	}
	randomizer++;
	int random = Commands->Get_Random_Int(1,randomizer);
	float amount = scoreamount * random;
	Commands->Give_Money(obj,amount,entireteam);
}
void JFW_GrantScore_Powerup::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	float scoreamount = Get_Float_Parameter("ScoreAmount");
	int entireteam = Get_Int_Parameter("Entire_Team");
	int randomizer = Get_Int_Parameter("Randomizer");
	if (randomizer = 0)
	{
		randomizer = 1;
	}
	randomizer++;
	int random = Commands->Get_Random_Int(1,randomizer);
	float amount = scoreamount * random;
	Commands->Give_Points(obj,amount,entireteam);
}
void JFW_Disable_Physical_Collision::Created(GameObject * obj)
{
	Commands->Disable_Physical_Collisions(obj);
}
void JFW_Enable_Physical_Collision::Created(GameObject * obj)
{
	Commands->Enable_Collisions(obj);
}
void JFW_DestroyedStateObject::Destroyed(GameObject * obj)
{
	GameObject *object = Commands->Create_Object(Get_Parameter("DestroyedModelPreset"),Commands->Get_Position(obj));
	Commands->Set_Facing(object,Get_Float_Parameter("OriginalModelFacing"));
}
void JFW_Play_Sound::Created(GameObject * obj)
{
	if (Get_Int_Parameter("Frequency_Min") == -1)
	{
		Timer_Expired(obj,0);
	}
	else
	{
		float random = Commands->Get_Random(Get_Float_Parameter("Frequency_Min"),Get_Float_Parameter("Frequency_Max"));
		Commands->Start_Timer(obj,this,random,0);
	}
}
void JFW_Play_Sound::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	if ((Get_Int_Parameter("Frequency_Min") != -1) && (message == 1000000001))
	{
		float random = Commands->Get_Random(Get_Float_Parameter("Frequency_Min"),Get_Float_Parameter("Frequency_Max"));
		Commands->Start_Timer(obj,this,random,0);
	}
}
void JFW_Play_Sound::Timer_Expired(GameObject * obj,int number)
{
	const char *soundpreset = Get_Parameter("Sound_Preset");
	bool is3d = Get_Int_Parameter("Is_3D");
	int sound;
	Vector3 position = Commands->Get_Position(obj);
	Vector3 position2 = Get_Vector3_Parameter("Offset");
	position.X += position2.X;
	position.Y += position2.Y;
	position.Z += position2.Z;
	Vector3 random = Get_Vector3_Parameter("Offset_Randomness");
	position.X += Commands->Get_Random(-random.X,random.X);
	position.Y += Commands->Get_Random(-random.Y,random.Y);
	position.Z += Commands->Get_Random(-random.Z,random.Z);
	if (is3d == true)
	{
		sound = Commands->Create_Sound(soundpreset,position,obj);
	}
	else
	{
		sound = Commands->Create_2D_Sound(soundpreset);
	}
	Commands->Monitor_Sound(obj,sound);
}
void JFW_Engine_Sound::Created(GameObject * obj)
{
	sound = Commands->Create_3D_Sound_At_Bone(Get_Parameter("Preset"),obj,Get_Parameter("Bone"));
}
void JFW_Engine_Sound::Destroyed(GameObject * obj)
{
	Commands->Stop_Sound(sound,true);
}
void JFW_Engine_Sound::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&sound);
}
ScriptRegistrant<JFW_Building_Explode_No_Damage> JFW_Building_Explode_No_Damage_Registrant("JFW_Building_Explode_No_Damage","");
ScriptRegistrant<JFW_Viceroid_Innate> JFW_Viceroid_Innate_Registrant("JFW_Viceroid_Innate","");
ScriptRegistrant<JFW_No_Innate> JFW_No_Innate_Registrant("JFW_No_Innate","");
ScriptRegistrant<JFW_Credit_Trickle> JFW_Credit_Trickle_Registrant("JFW_Credit_Trickle","Credits=1:int,Delay=2.0:float");
ScriptRegistrant<JFW_PCT_Pokable> JFW_PCT_Pokable_Registrant("JFW_PCT_Pokable","");
ScriptRegistrant<JFW_Vehicle_Regen> JFW_Vechicle_Regen_Registrant("JFW_Vechicle_Regen","");
ScriptRegistrant<JFW_Disable_Transition> JFW_Disable_Transition_Registrant("JFW_Disable_Transition","");
ScriptRegistrant<JFW_Permanent_No_Falling_Damage> JFW_Permanent_No_Falling_Damage_Registrant("JFW_Permanent_No_Falling_Damage","");
ScriptRegistrant<JFW_Death_Powerup> JFW_Death_Powerup_Registrant("JFW_Death_Powerup","");
ScriptRegistrant<JFW_GrantPowerup_Created> JFW_GrantPowerup_Created_Registrant("JFW_GrantPowerup_Created","WeaponDef:string");
ScriptRegistrant<JFW_CnC_Crate> JFW_CnC_Crate_Registrant("JFW_CnC_Crate","");
ScriptRegistrant<JFW_Tiberium_Refinery> JFW_Tiberium_Refinery_Registrant("JFW_Tiberium_Refinery","MoneyAmount:int,TimerLength:int");
ScriptRegistrant<JFW_GrantMoney_Powerup> JFW_GrantMoney_Powerup_Registrant("JFW_GrantMoney_Powerup","ScoreAmount:float,Entire_Team=0:int,Randomizer=1:int");
ScriptRegistrant<JFW_GrantScore_Powerup> JFW_GrantScore_Powerup_Registrant("JFW_GrantScore_Powerup","ScoreAmount:float,Entire_Team=0:int,Randomizer=1:int");
ScriptRegistrant<JFW_Disable_Physical_Collision> JFW_Disable_Physical_Collision_Registrant("JFW_Disable_Physical_Collision","");
ScriptRegistrant<JFW_Enable_Physical_Collision> JFW_Enable_Physical_Collision_Registrant("JFW_Disable_Physical_Collision","");
ScriptRegistrant<JFW_DestroyedStateObject> JFW_DestroyedStateObject_Registrant("JFW_DestroyedStateObject","OriginalModelFacing:float,DestroyedModelPreset:string");
ScriptRegistrant<JFW_Play_Sound> JFW_Play_Sound_Registrant("JFW_Play_Sound","Sound_Preset:string, Is_3D=1:int, Offset:vector3, Offset_Randomness:vector3, Frequency_Min=-1:float, Frequency_Max:float");
ScriptRegistrant<JFW_Engine_Sound> JFW_Engine_Sound_Registrant("JFW_Engine_Sound","Preset:string, Bone:string");
