/* This file is part of the Server Side AOW Library.

  The Server Side AOW Library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  The Server Side AOW Library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along with
  the Server Side AOW Library; if not, write to the Free Software Foundation,
  Inc.,  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/

class M00_BUILDING_EXPLODE_NO_DAMAGE_DAK : public ScriptImpClass {
	void Created(GameObject *obj);
	void Destroyed(GameObject *obj);
	void Killed(GameObject *obj, GameObject *shooter);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Timer_Expired(GameObject *obj, int number);
	bool ReportDamage;
	int LastID, B2BCount;
	bool PlayHealth, OkHealth, PlayRepair;
	bool IsAlive;
};

class M00_Disable_Transition : public ScriptImpClass {
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Killed(GameObject *obj, GameObject *shooter);
	void Timer_Expired(GameObject *obj, int number);
	bool PlayDamage;
};

class M00_GrantPowerup_Created : public ScriptImpClass {
	void Created(GameObject *obj);
	void Destroyed(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Killed(GameObject *obj, GameObject *shooter);
	void Timer_Expired(GameObject *obj, int number);
	GameObject *BackpackObject;
	GameObject *BackpackScript;
	Vector3 DeathPlace;
	Vector3 SpawnPos;
	int AfkDetect;
	bool DidEvent, FullDeath;
	float TotalHealth;
};

class KAK_Backpack_Object : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	GameObject *BackpackScript;
	Vector3 DeathPlace;
};

class KAK_Beacon_Log : public ScriptImpClass {
	void Created(GameObject *obj);
	void Destroyed(GameObject *obj);
	void Killed(GameObject *obj, GameObject *shooter);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	bool IsDisarmed;
	GameObject *InvisObjCont;
};

class KAK_Beacon_Animation_Log : public ScriptImpClass {
	void Created(GameObject *obj);
};

class KAK_Beacon_Log_CreateControl : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Random_Weather : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	float Range, CurrentClouds, CurrentRain, CurrentLightning, CurrentSnow, CurrentAsh, CurrentWind, FogEnd;
	char MapName[256], WeatherType[256], IDNum[10];
};

class KAK_Vehicle_Log : public ScriptImpClass {
	void Created(GameObject *obj);
	void Killed(GameObject *obj, GameObject *shooter);

	Vector3 DeadPlace;
	float Facing;
};

class KAK_Destroy_Tank : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Vehicle_Damage : public ScriptImpClass {
	void Created(GameObject *obj);
	void Destroyed(GameObject *obj);
	void Killed(GameObject *obj, GameObject *shooter);
	void Timer_Expired(GameObject *obj, int number);
	bool IsFirstShow, IsSecondShow;
	float TotalHealth, CurrentHealth;
	GameObject *Fire1, *Fire2, *Fire3, *Fire4, *Explosion1, *Explosion2;
	int Size, FireCount;
	bool IsAlive;
};

class KAK_Vehicle_Damage_Clear : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Obelisk_Powerup : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Timer_Expired(GameObject *obj, int number);
	GameObject *Powerup;
	bool IsPowerup;
	int LastID, ObGlitchCount;
};

class M00_PCT_Pokable_DAK : public ScriptImpClass {
   void Damaged(GameObject *obj, GameObject *damager, float damage);
   void Killed(GameObject *obj, GameObject *shooter);
   void Poked(GameObject *obj,GameObject * poker);
};

class KAK_CargoPlane_Sounds : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
};

class KAK_Disable_List : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};