#include "stdafx.h"
#include "scripts.h"
#include "CTF.h"

/* ************************************************************************************************************* */

//Handles all CTF messages
void CTF_Message (int message) {
	currdate.refreshdate();
	char FDSlogname[100], messageprint[512], hours[5], mins[5], secs[5], readline[250], msgline[256];
	sprintf(FDSlogname, "renlog_%s.txt",currdate.get_date_string());
	time_t rawtime;
	struct tm *timeinfo;
	time(&rawtime);
	timeinfo = localtime(&rawtime);
	int hour = timeinfo->tm_hour;
	int min = timeinfo->tm_min;
	int sec = timeinfo->tm_sec;
	if (hour < 10) sprintf(hours,"0%d",hour);
	else sprintf(hours,"%d",hour);
	if (min < 10) sprintf(mins,"0%d",min);
	else sprintf(mins,"%d",min);
	if (sec < 10) sprintf(secs,"0%d",sec);
	else sprintf(secs,"%d",sec);

	if (message == 1) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag Stolen\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFGDISTOLEN","GDI's flag has been stolen.",readline,250,"CTF_Settings.ini");
		sprintf(msgline,"msg %s",readline);
		ConsoleCommand(msgline);
	}
	else if (message == 2) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag Stolen\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFNODSTOLEN","Nod's flag has been stolen.",readline,250,"CTF_Settings.ini");
		sprintf(msgline,"msg %s",readline);
		ConsoleCommand(msgline);
	}

	else if (message == 3) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag Dropped\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFGDIDROP","GDI's flag has been dropped.",readline,250,"CTF_Settings.ini");
		sprintf(msgline,"msg %s",readline);
		ConsoleCommand(msgline);
	}
	else if (message == 4) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag Dropped\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFNODDROP","Nod's flag has been dropped.",readline,250,"CTF_Settings.ini");
		sprintf(msgline,"msg %s",readline);
		ConsoleCommand(msgline);
	}

	else if (message == 5) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag PickedUp\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFGDIPICKUP","GDI's flag has been picked up.",readline,250,"CTF_Settings.ini");
		sprintf(msgline,"msg %s",readline);
		ConsoleCommand(msgline);
	}
	else if (message == 6) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag PickedUp\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFNODPICKUP","Nod's flag has been picked up.",readline,250,"CTF_Settings.ini");
		sprintf(msgline,"msg %s",readline);
		ConsoleCommand(msgline);
	}

	else if (message == 7) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag Returned\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFGDIRETURN","GDI's flag has been returned.",readline,250,"CTF_Settings.ini");
		sprintf(msgline,"msg %s",readline);
		ConsoleCommand(msgline);
	}
	else if (message == 8) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag Returned\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFNODRETURN","Nod's flag has been returned.",readline,250,"CTF_Settings.ini");
		sprintf(msgline,"msg %s",readline);
		ConsoleCommand(msgline);
	}

	else if (message == 9) {
		if (EnableCapLimit == 1) {
			std::ofstream FDSLog (FDSlogname,ios::app);
			if (FDSLog.is_open()) {
				sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag Captured %dCapLeft\n",hours,mins,secs,(TotalCaptures - NodCaps));
				FDSLog << messageprint;
				FDSLog.close();
			}
			getProfileString("StringTable","CTFGDICAPTURE","GDI's flag has been captured.",readline,250,"CTF_Settings.ini");
			sprintf(msgline,"msg %s\nNod needs to capture GDI's flag %d more time(s) to win.",readline,(TotalCaptures - NodCaps));
			ConsoleCommand(msgline);
		}
		else if (EnableCapLimit == 0) {
			std::ofstream FDSLog (FDSlogname,ios::app);
			if (FDSLog.is_open()) {
				sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag Captured\n",hours,mins,secs);
				FDSLog << messageprint;
				FDSLog.close();
			}
			getProfileString("StringTable","CTFGDICAPTURE","GDI's flag has been captured.",readline,250,"CTF_Settings.ini");
			sprintf(msgline,"msg %s",readline);
			ConsoleCommand(msgline);
		}
	}
	else if (message == 10) {
		if (EnableCapLimit == 1) {
			std::ofstream FDSLog (FDSlogname,ios::app);
			if (FDSLog.is_open()) {
				sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag Captured %dCapLeft\n",hours,mins,secs,(TotalCaptures - GDICaps));
				FDSLog << messageprint;
				FDSLog.close();
			}
			getProfileString("StringTable","CTFNODCAPTURE","Nod's flag has been captured.",readline,250,"CTF_Settings.ini");
			sprintf(msgline,"msg %s\nGDI needs to capture Nod's flag %d more time(s) to win.",readline,(TotalCaptures - GDICaps));
			ConsoleCommand(msgline);
		}
		else if (EnableCapLimit == 0) {
			std::ofstream FDSLog (FDSlogname,ios::app);
			if (FDSLog.is_open()) {
				sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag Captured\n",hours,mins,secs);
				FDSLog << messageprint;
				FDSLog.close();
			}
			getProfileString("StringTable","CTFNODCAPTURE","Nod's flag has been captured.",readline,250,"CTF_Settings.ini");
			sprintf(msgline,"msg %s",readline);
			ConsoleCommand(msgline);
		}
	}

	else if (message == 11) {
		printf("GDI has captured the flag enough times to win.\n");
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: GDI Wins\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
	}
	else if (message == 12) {
		printf("Nod has captured the flag enough times to win.\n");
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: Nod Wins\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
	}
}

//Creates the flag at the Ped's location
GameObject *Create_CTF_Flag (int Team, Vector3 PedPosition) {
	Vector3 FlagLoc;
	GameObject *Flag;
	char scriptPar[256];

	FlagLoc = PedPosition;
	FlagLoc.X -= getProfileFloat("Flag","Flag_X",500.000,"Data\\CTF.dat");
	FlagLoc.Y -= getProfileFloat("Flag","Flag_Y",500.000,"Data\\CTF.dat");
	FlagLoc.Z -= getProfileFloat("Flag","Flag_Z",-500.000,"Data\\CTF.dat");
	Flag = Commands->Create_Object(FlagPreset,FlagLoc);
	Commands->Set_Player_Type(Flag,Team);

	sprintf(scriptPar,"%d,%d",Team,Commands->Get_ID(Flag));
	Commands->Attach_Script(Flag,"KAK_CTF_Flag",scriptPar);

	if (Team == 0) {
		NodFlagHolder = 0;
		NodFlagAttached = 0;
	}
	else if (Team == 1) {
		GDIFlagHolder = 0;
		GDIFlagAttached = 0;
	}

	return Flag;
}

//Creates the flag at position X, used for dead flag holder
GameObject *Create_CTF_DropFlag (int Team, Vector3 Position) {
	Vector3 FlagLoc;
	GameObject *Flag;
	char scriptPar[256];

	FlagLoc = Position;
	FlagLoc.X -= getProfileFloat("Flag","Flag_X",500.000,"Data\\CTF.dat");
	FlagLoc.Y -= getProfileFloat("Flag","Flag_Y",500.000,"Data\\CTF.dat");
	FlagLoc.Z -= getProfileFloat("Flag","Flag_Z",-500.000,"Data\\CTF.dat");
	Flag = Commands->Create_Object(FlagPreset,FlagLoc);
	Commands->Set_Player_Type(Flag,Team);

	sprintf(scriptPar,"%d,%d",Team,Commands->Get_ID(Flag));
	Commands->Attach_Script(Flag,"KAK_CTF_DropFlag",scriptPar);

	if (Team == 0) {
		NodFlagHolder = 0;
		NodFlagAttached = Commands->Get_ID(Flag);
	}
	else if (Team == 1) {
		GDIFlagHolder = 0;
		GDIFlagAttached = Commands->Get_ID(Flag);
	}

	return Flag;
}

//Creates the flag at Team's Ped
GameObject *Create_CTF_PedFlag (int Team) {
	Vector3 FlagLoc, PedPosition;
	GameObject *Flag;
	char scriptPar[256], map[256], IDs[100];
	sprintf(IDs,"%d",MapID);
	getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");

	if (Team == 0) {
		PedPosition.X = getProfileFloat(map,"NodFlag_X",500.000,"Data\\CTF.dat");
		PedPosition.Y = getProfileFloat(map,"NodFlag_Y",500.000,"Data\\CTF.dat");
		PedPosition.Z = getProfileFloat(map,"NodFlag_Z",-500.000,"Data\\CTF.dat");
	}
	else if (Team == 1) {
		PedPosition.X = getProfileFloat(map,"GDIFlag_X",500.000,"Data\\CTF.dat");
		PedPosition.Y = getProfileFloat(map,"GDIFlag_Y",500.000,"Data\\CTF.dat");
		PedPosition.Z = getProfileFloat(map,"GDIFlag_Z",-500.000,"Data\\CTF.dat");
	}

	FlagLoc = PedPosition;
	FlagLoc.X -= getProfileFloat("Flag","Flag_X",500.000,"Data\\CTF.dat");
	FlagLoc.Y -= getProfileFloat("Flag","Flag_Y",500.000,"Data\\CTF.dat");
	FlagLoc.Z -= getProfileFloat("Flag","Flag_Z",-500.000,"Data\\CTF.dat");
	Flag = Commands->Create_Object(FlagPreset,FlagLoc);
	Commands->Set_Player_Type(Flag,Team);

	sprintf(scriptPar,"%d,%d",Team,Commands->Get_ID(Flag));
	Commands->Attach_Script(Flag,"KAK_CTF_Flag",scriptPar);

	if (Team == 0) {
		NodFlagHolder = 0;
		NodFlagAttached = 0;
	}
	else if (Team == 1) {
		GDIFlagHolder = 0;
		GDIFlagAttached = 0;
	}

	return Flag;
}

//Creates Team's CTF Ped
void Create_CTF_Pedestal (int Team, int ID) {
	Vector3 PedLoc;
	GameObject *Ped, *Flag;
    char map[256], IDs[100];
	sprintf(IDs,"%d",ID);
	getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");

	if (Team == 0) {
		PedLoc.X = getProfileFloat(map,"NodFlag_X",500.000,"Data\\CTF.dat");
		PedLoc.Y = getProfileFloat(map,"NodFlag_Y",500.000,"Data\\CTF.dat");
		PedLoc.Z = getProfileFloat(map,"NodFlag_Z",-500.000,"Data\\CTF.dat");
		Ped = Commands->Create_Object(NodPedPreset,PedLoc);
	}
	else if (Team == 1) {
		PedLoc.X = getProfileFloat(map,"GDIFlag_X",500.000,"Data\\CTF.dat");
		PedLoc.Y = getProfileFloat(map,"GDIFlag_Y",500.000,"Data\\CTF.dat");
		PedLoc.Z = getProfileFloat(map,"GDIFlag_Z",-500.000,"Data\\CTF.dat");
		Ped = Commands->Create_Object(GDIPedPreset,PedLoc);
	}

	Flag = Create_CTF_Flag(Team,PedLoc);
}

/* ************************************************************************************************************* */

//Core of CTF, controls the flag that rests on the Ped
void KAK_CTF_Flag::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == CUSTOM_EVENT_POWERUP && Get_Int_Parameter("Team") != Commands->Get_Player_Type(sender)) {		//Enemy picked up the flag
		//Destroy flag on Ped
		Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("FlagID")));

		//Put flag on person
		GameObject *AttachedFlag = Commands->Create_Object_At_Bone(sender,FlagBackPreset,"bone for bag");
		Commands->Attach_To_Object_Bone(AttachedFlag, sender, "bone for bag");
		Commands->Disable_All_Collisions(AttachedFlag);
		Commands->Set_Player_Type(AttachedFlag,Get_Int_Parameter("Team"));
		
		if (WeaponForHolder == 0) {
			Commands->Give_Powerup(sender,"POW_Uplink",true);
			Commands->Attach_Script(sender,"KAK_Select_Flag","");
		}
		if (RegenForHolder == 1) {
			Commands->Attach_Script(sender,"KAK_FlagHolder_Regen","");
		}
		Commands->Attach_Script(sender,"KAK_FlagHolder_Appear","");

		if (SpoilsofWar == 1) {
			//Spoils of War for picking up flag
			Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","StealPointsTeam",0.0f,"CTF_Settings.ini"),true);
			Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","StealPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","StealPointsInd",0.0f,"CTF_Settings.ini"),false);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","StealPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","StealPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","StealCreditsTeam",0.0f,"CTF_Settings.ini"),true);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","StealCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","StealCreditsInd",0.0f,"CTF_Settings.ini"),false);
		}

		//Set information for later use
		if (Get_Int_Parameter("Team") == 0) {
			NodFlagHolder = Commands->Get_ID(sender);
			NodFlagAttached = Commands->Get_ID(AttachedFlag);
			CTF_Message(2);
			NodFlagLoc = 2;
		}
		else if (Get_Int_Parameter("Team") == 1) {
			GDIFlagHolder = Commands->Get_ID(sender);
			GDIFlagAttached = Commands->Get_ID(AttachedFlag);
			CTF_Message(1);
			GDIFlagLoc = 2;
		}
	}
	else if (message == CUSTOM_EVENT_POWERUP && Get_Int_Parameter("Team") == Commands->Get_Player_Type(sender)) {	//Friendly picked up the flag (Maybe capture, maybe idiot)
		if (Get_Int_Parameter("Team") == 0 && GDIFlagHolder == Commands->Get_ID(sender)) {		//If Nod captured GDI's Flag
			GDIFlagLoc = 1;
			//Destroy flag on person
			Commands->Destroy_Object(Commands->Find_Object(GDIFlagAttached));
			Commands->Attach_Script(sender,"KAK_Capture_Animation","");
			Commands->Send_Custom_Event(obj,sender,24156,0,0);

			if (SpoilsofWar == 1) {
				//Spoils of War for capturing flag
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","CapturePointsInd",0.0f,"CTF_Settings.ini"),false);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CapturePointsInd",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","CaptureCreditsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CaptureCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","CaptureCreditsInd",0.0f,"CTF_Settings.ini"),false);
			}
			
			//Recreate flag on ped, update information
			GDIFlagHolder = 0;
			GDIFlagAttached = 0;
			NodCaps++;

			if (NodCaps >= TotalCaptures && EnableCapLimit == 1) {	//If Nod reached the cap limit, end game
				CTF_Message(11);
				AllowKillBuilding = true;
				char map[256], IDs[100];
				sprintf(IDs,"%d",MapID);
				getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");
				int BuildingAmount = getProfileInt(map,"GDIBuildings",0,"Data\\CTF.dat");
				int i = 1;
				while (i <= BuildingAmount) {
					char BuildingIDTxt[256];
					sprintf(BuildingIDTxt,"GDIBuilding%d",i);
					Commands->Apply_Damage(Commands->Find_Object(getProfileInt(map,BuildingIDTxt,0,"Data\\CTF.dat")),99999,"Explosive",false);
					i++;
				}
			}
			else {
				CTF_Message(9);
				Create_CTF_PedFlag(0);
				Create_CTF_PedFlag(1);
			}
		}
		else if (Get_Int_Parameter("Team") == 1 && NodFlagHolder == Commands->Get_ID(sender)) {		//Else If Nod captured GDI's Flag
			NodFlagLoc = 1;
			//Destroy flag on person
			Commands->Destroy_Object(Commands->Find_Object(NodFlagAttached));
			Commands->Attach_Script(sender,"KAK_Capture_Animation","");
			Commands->Send_Custom_Event(obj,sender,24156,0,0);
			
			if (SpoilsofWar == 1) {
				//Spoils of War for capturing flag
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","CapturePointsInd",0.0f,"CTF_Settings.ini"),false);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CapturePointsInd",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","CaptureCreditsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CaptureCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","CaptureCreditsInd",0.0f,"CTF_Settings.ini"),false);
			}
			
			//Recreate flag on Ped
			NodFlagHolder = 0;
			NodFlagAttached = 0;
			GDICaps++;

			if (GDICaps >= TotalCaptures  && EnableCapLimit == 1) {			//If GDI reached the cap limit, end game
				CTF_Message(12);
				AllowKillBuilding = true;
				char map[256], IDs[100];
				sprintf(IDs,"%d",MapID);
				getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");
				int BuildingAmount = getProfileInt(map,"NodBuildings",0,"Data\\CTF.dat");
				int i = 1;
				while (i <= BuildingAmount) {
					char BuildingIDTxt[256];
					sprintf(BuildingIDTxt,"NodBuilding%d",i);
					Commands->Apply_Damage(Commands->Find_Object(getProfileInt(map,BuildingIDTxt,0,"Data\\CTF.dat")),99999,"Explosive",false);
					i++;
				}
			}
			else {
				CTF_Message(10);
				Create_CTF_PedFlag(0);
				Create_CTF_PedFlag(1);
			}
		}
		else Create_CTF_PedFlag(Commands->Get_Player_Type(obj));
	}
}

/* ************************************************************************************************************* */

//Controls the flag that drops from the dead flag holder
void KAK_CTF_DropFlag::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == CUSTOM_EVENT_POWERUP && Get_Int_Parameter("Team") != Commands->Get_Player_Type(sender)) {		//Enemy picked up the friendly's fallen flag
		//Put flag on new holder
		GameObject *AttachedFlag = Commands->Create_Object_At_Bone(sender,FlagBackPreset,"bone for bag");
		Commands->Attach_To_Object_Bone(AttachedFlag, sender, "bone for bag");
		Commands->Disable_All_Collisions(AttachedFlag);
		Commands->Set_Player_Type(AttachedFlag,Get_Int_Parameter("Team"));
		
		if (WeaponForHolder == 0) {
			Commands->Give_Powerup(sender,"POW_Uplink",true);
			Commands->Attach_Script(sender,"KAK_Select_Flag","");
		}
		if (RegenForHolder == 1) {
			Commands->Attach_Script(sender,"KAK_FlagHolder_Regen","");
		}
		Commands->Attach_Script(sender,"KAK_FlagHolder_Appear","");

		if (SpoilsofWar == 1) {
			//Spoils of War for picking up fallen flag
			Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","PickupPointsTeam",0.0f,"CTF_Settings.ini"),true);
			Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","PickupPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","PickupPointsInd",0.0f,"CTF_Settings.ini"),false);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","PickupPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","PickupPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","PickupCreditsTeam",0.0f,"CTF_Settings.ini"),true);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","PickupCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","PickupCreditsInd",0.0f,"CTF_Settings.ini"),false);
		}

		//Setup new information
		if (Get_Int_Parameter("Team") == 0) {
			Commands->Destroy_Object(Commands->Find_Object(NodFlagAttached));
			NodFlagHolder = Commands->Get_ID(sender);
			NodFlagAttached = Commands->Get_ID(AttachedFlag);
			CTF_Message(6);
			NodFlagLoc = 2;
		}
		else if (Get_Int_Parameter("Team") == 1) {
			Commands->Destroy_Object(Commands->Find_Object(GDIFlagAttached));
			GDIFlagHolder = Commands->Get_ID(sender);
			GDIFlagAttached = Commands->Get_ID(AttachedFlag);
			CTF_Message(5);
			GDIFlagLoc = 2;
		}
	}
	else if (message == CUSTOM_EVENT_POWERUP && Get_Int_Parameter("Team") == Commands->Get_Player_Type(sender)) {		//Friendly picked up the friendly's fallen flag
		if (Get_Int_Parameter("Team") == 0) {		//If Player is on Nod
			//Reput flag on Nod Ped
			Create_CTF_PedFlag(0);
			Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("FlagID")));

			if (SpoilsofWar == 1) {
				//Spoils of War for returning flag
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","ReturnPointsInd",0.0f,"CTF_Settings.ini"),false);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","ReturnCreditsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","ReturnCreditsInd",0.0f,"CTF_Settings.ini"),false);
			}

			CTF_Message(8);
			NodFlagLoc = 1;
		}
		else if (Get_Int_Parameter("Team") == 1) {	//Else if Player is on GDI
			//Reput flag on GDI Ped
			Create_CTF_PedFlag(1);
			Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("FlagID")));

			if (SpoilsofWar == 1) {
				//Spoils of War for returning flag
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","ReturnPointsInd",0.0f,"CTF_Settings.ini"),false);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","ReturnCreditsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","ReturnCreditsInd",0.0f,"CTF_Settings.ini"),false);
			}

			CTF_Message(7);
			GDIFlagLoc = 1;
		}
	}
}

void KAK_CTF_DropFlag::Created(GameObject *obj) {
	if (getProfileFloat("Settings","ReturnDropFlagTimer",0.0f,"CTF_Settings.ini") > 0.0f) Commands->Start_Timer(obj,this,getProfileFloat("Settings","ReturnDropFlagTimer",0.0f,"CTF_Settings.ini"),1);
}

void KAK_CTF_DropFlag::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		if (Get_Int_Parameter("Team") == 0) {
			Create_CTF_PedFlag(0);
			Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("FlagID")));
			CTF_Message(8);
			NodFlagLoc = 1;
		}
		else if (Get_Int_Parameter("Team") == 1) {
			Create_CTF_PedFlag(1);
			Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("FlagID")));
			CTF_Message(7);
			GDIFlagLoc = 1;
		}
	}
}

/* ************************************************************************************************************* */

//Loop fake gun so Player with Flag can not pull out weapon
void KAK_Select_Flag::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,0.1f,1);
}

void KAK_Select_Flag::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		Commands->Select_Weapon(obj,"Weapon_MineTimed_Player");
		Commands->Start_Timer(obj,this,0.1f,1);
	}
}

void KAK_Select_Flag::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 24156) {
		Destroy_Script();
	}
}

/* ************************************************************************************************************* */

//Loop regen health for flag holder
void KAK_FlagHolder_Regen::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,1.0f,1);
	IsAlive = true;
}

void KAK_FlagHolder_Regen::Timer_Expired(GameObject *obj, int number) {
	if (number == 1 && IsAlive) {
		if (Commands->Get_Health(obj) == Commands->Get_Max_Health(obj)) {
			if (Commands->Get_Shield_Strength(obj) != Commands->Get_Max_Shield_Strength(obj)) {
				Commands->Set_Shield_Strength(obj,(Commands->Get_Shield_Strength(obj) + RegenAmount));
			}
		}
		else {
			Commands->Set_Health(obj,(Commands->Get_Health(obj) + RegenAmount));
		}
		Commands->Start_Timer(obj,this,1.0f,1);
	}
}

void KAK_FlagHolder_Regen::Killed(GameObject *obj, GameObject *shooter) {
	IsAlive = false;
}

void KAK_FlagHolder_Regen::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 24156) {
		Destroy_Script();
	}
}

/* ************************************************************************************************************* */

//Loop to make flag holder appear (SBH Fix)
void KAK_FlagHolder_Appear::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,0.01f,1);
}

void KAK_FlagHolder_Appear::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		Commands->Apply_Damage(obj,0,"Harmless",false);
		Commands->Start_Timer(obj,this,0.01f,1);
	}
}

void KAK_FlagHolder_Appear::Killed(GameObject *obj, GameObject *shooter) {
	Destroy_Script();
}

void KAK_FlagHolder_Appear::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 24156) {
		Destroy_Script();
	}
}

/* ************************************************************************************************************* */

void KAK_Limit_Announcement::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,30.0f,1);
}

void KAK_Limit_Announcement::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		char msgline[256];
		ConsoleCommand("msg Running in CTF mode, created by Vloktboky and the people at Black-Cell.net.");
		if (EnableCapLimit == 1) {
			sprintf(msgline,"msg This round's capture limit is %d.",TotalCaptures);
			ConsoleCommand(msgline);
			Commands->Start_Timer(obj,this,180.0f,2);
		}
	}
	else if (number == 2) {
		char msgline[256];
		sprintf(msgline,"msg GDI needs to capture Nod's flag %d more time(s) to win.  Nod needs to capture GDI's flag %d more time(s) to win.",(TotalCaptures - GDICaps),(TotalCaptures - NodCaps));
		ConsoleCommand(msgline);
		Commands->Start_Timer(obj,this,180.0f,2);
	}
}

/* ************************************************************************************************************* */

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Created(GameObject *obj) {
	if (EnableCTF == 1) {
		if (ShowStartMessage == false) {
			ShowStartMessage = true;
		}
		if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks")) {
			rename("Data\\objects.ddb","Data\\bjects.ddb");
			AllowKillBuilding = false;
			MapID = Commands->Get_ID(obj);

			char map[256], IDs[256];
			sprintf(IDs,"%d",MapID);
			getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");
			if (EnableCapLimit == 1) TotalCaptures = getProfileInt("CapLimit",map,5,"CTF_Settings.ini");

			Create_CTF_Pedestal(0,MapID);
			Create_CTF_Pedestal(1,MapID);
			GDIFlagLoc = 1;
			NodFlagLoc = 1;
			Commands->Attach_Script(obj,"KAK_Flag_Icon","0");
			Commands->Attach_Script(obj,"KAK_Flag_Icon","1");

			if (FirstGame == true) {
				FirstGame = false;
				ConsoleCommand("gameover");
			}
			else if (ShowAnnouncement == true) {
				ShowAnnouncement = false;
				if (EnableCTF == 1) {
					printf("Running in CTF Mode.\n");
					if (WeaponForHolder == 1) printf("Flag holder may use a weapon.\n");
					else if (WeaponForHolder == 0) printf("Flag holder may NOT use a weapon.\n");
					if (getProfileFloat("Settings","RegenAmount",2.0f,"CTF_Settings.ini") > 0.0f && getProfileFloat("Settings","RegenAmount",2.0f,"CTF_Settings.ini") <= 5.0f) RegenAmount = getProfileFloat("Settings","RegenAmount",2.0f,"CTF_Settings.ini");
					else RegenAmount = 2.0f;
					if (RegenForHolder == 1) printf("Flag holder will have %f health regenerated every second.\n",RegenAmount);
					else if (RegenForHolder == 0) printf("Flag holder will not have health regenerated.\n");
					if (DropWeapons == 1) printf("Weapons will drop from fallen soldiers.\n");
					else if (DropWeapons == 0) printf("The greedy dead people will keep their guns.\n");
					if (SpoilsofWar == 1) printf("Spoils of War are turned on.\n");
					else if (SpoilsofWar == 0) printf("Spoils of War are turned off.\n");
					if (EnableCapLimit == 1) printf("Following Cap Limit rules.  This round's limit is %d.\n",TotalCaptures);
					else if (EnableCapLimit == 0) printf("Unlimited captures allowed.\n");

					GameObject *AnnouncementThing = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
					Commands->Attach_Script(AnnouncementThing,"KAK_Limit_Announcement","");
				}
			}
		}
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (EnableCTF == 1 && AllowKillBuilding == false) {
		if (Commands->Get_Player_Type(damager) == 1 && strstr(Commands->Get_Preset_Name(obj),"GDI")) {
			Commands->Give_Points(damager,damage,false);
			Commands->Give_Money(damager,(damage * (float)-1),false);
		}
		else if (Commands->Get_Player_Type(damager) == 1 && !strstr(Commands->Get_Preset_Name(obj),"GDI")) {
			Commands->Give_Points(damager,(damage * (float)-1),false);
			Commands->Give_Money(damager,(damage * (float)-1),false);
		}
		else if (Commands->Get_Player_Type(damager) == 0 && strstr(Commands->Get_Preset_Name(obj),"Nod")) {
			Commands->Give_Points(damager,damage,false);
			Commands->Give_Money(damager,(damage * (float)-1),false);
		}
		else if (Commands->Get_Player_Type(damager) == 0 && !strstr(Commands->Get_Preset_Name(obj),"Nod")) {
			Commands->Give_Points(damager,(damage * (float)-1),false);
			Commands->Give_Money(damager,(damage * (float)-1),false);
		}


		if (damage >= 500) {
			if (Commands->Get_Player_Type(damager) == 1 && strstr(Commands->Get_Preset_Name(obj),"GDI")) {
				Commands->Give_Points(damager,(float)250,false);
				Commands->Give_Money(damager,(float)-250,false);
			}
			else if (Commands->Get_Player_Type(damager) == 1 && !strstr(Commands->Get_Preset_Name(obj),"GDI")) {
				Commands->Give_Points(damager,(float)-250,false);
				Commands->Give_Money(damager,(float)-250,false);
			}
			else if (Commands->Get_Player_Type(damager) == 0 && strstr(Commands->Get_Preset_Name(obj),"Nod")) {
				Commands->Give_Points(damager,(float)250,false);
				Commands->Give_Money(damager,(float)-250,false);
			}
			else if (Commands->Get_Player_Type(damager) == 0 && !strstr(Commands->Get_Preset_Name(obj),"Nod")) {
				Commands->Give_Points(damager,(float)-250,false);
				Commands->Give_Money(damager,(float)-250,false);
			}
		}

		Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Destroyed(GameObject *obj) {
	if (EnableCTF == 1) {
		if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks")) {
			rename("Data\\bjects.ddb","Data\\objects.ddb");
			GDIFlagHolder = 0;
			NodFlagHolder = 0;
			GDIFlagAttached = 0;
			NodFlagAttached = 0;
			MapID = 0;
			GDICaps = 0;
			NodCaps = 0;
			AllowKillBuilding = false;

			ShowAnnouncement = true;
			EnableCTF = getProfileInt("Settings","EnableCTFMode",1,"CTF_Settings.ini");
			WeaponForHolder= getProfileInt("Settings","AllowWeaponForHolder",0,"CTF_Settings.ini");
			DropWeapons = getProfileInt("Settings","AllowDropWeapons",1,"CTF_Settings.ini");
			SpoilsofWar = getProfileInt("Settings","AllowSpoilsofWar",1,"CTF_Settings.ini");
			EnableCapLimit = getProfileInt("Settings","AllowCapLimit",1,"CTF_Settings.ini");
			RegenForHolder = getProfileInt("Settings","AllowRegenForHolder",0,"CTF_Settings.ini");
			getProfileString("Settings","FlagPresetName","POW_Data_Disc",FlagPreset,100,"CTF_Settings.ini");
			getProfileString("Settings","GDIPedPresetName","CtfPedestalGold",GDIPedPreset,100,"CTF_Settings.ini");
			getProfileString("Settings","NodPedPresetName","CtfPedestalRed",NodPedPreset,100,"CTF_Settings.ini");
			getProfileString("Settings","FlagBackPresetName","CtfFlag",FlagBackPreset,100,"CTF_Settings.ini");
		}
	}
}

/* ************************************************************************************************************* */

void M00_Disable_Transition::Created(GameObject *obj) {
	if (EnableCTF == 1) {
		if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester")) { }
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester")) { }
		else Commands->Destroy_Object(obj);
	}
}

void M00_Disable_Transition::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (EnableCTF == 1) {
		if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester") || strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester")) {
			Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
			Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj));
		}
	}
}

/* ************************************************************************************************************* */

void M00_GrantPowerup_Created::Created(GameObject *obj) {
	if (EnableCTF == 1) {
		Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
		Commands->Set_Is_Visible(obj,false);

		if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
			IsDestroyed = false;
			char IDFile[50];
			sprintf(IDFile,"PL\\PL%d",Commands->Get_ID(obj));
			int TotalWeapons = getProfileInt("Guns","Total",0,IDFile);

			if (TotalWeapons == 0) {
				writeProfileString("Guns","Total","0",IDFile);
			}
			else {
				int TotalWeapons = getProfileInt("Guns","Total",0,IDFile);
				int CurrWeapon = 1;
				while (CurrWeapon <= TotalWeapons) {
					char WeaponToGive[100], WeaponString[25];
					sprintf(WeaponString,"Weapon%d",CurrWeapon);
					getProfileString("Guns",WeaponString,"null",WeaponToGive,100,IDFile);
					Commands->Give_Powerup(obj,WeaponToGive,true);
					CurrWeapon++;
				}
			}
		}
	}
	else Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
}

void M00_GrantPowerup_Created::Timer_Expired(GameObject *obj, int number) {
	if (EnableCTF == 1) {
		if (number == 5) {
			//Commands->Give_Money(obj,1,false);
			Commands->Start_Timer(obj,this,1,5);
		}
	}
}

void M00_GrantPowerup_Created::Destroyed(GameObject *obj) {
	if (EnableCTF == 1) {
		if (IsDestroyed == false) {
			IsDestroyed = true;
			Vector3 DeathPlace = Commands->Get_Position(obj);

			if (Commands->Get_Player_Type(obj) == 0 && Commands->Get_ID(obj) == GDIFlagHolder) {
				if (Commands->Find_Object(GDIFlagAttached) != 0) Commands->Destroy_Object(Commands->Find_Object(GDIFlagAttached));
				Create_CTF_DropFlag(1,DeathPlace);
				CTF_Message(3);
				GDIFlagLoc = 3;
			}
			else if (Commands->Get_Player_Type(obj) == 1 && Commands->Get_ID(obj) == NodFlagHolder) {
				if (Commands->Find_Object(NodFlagAttached) != 0) Commands->Destroy_Object(Commands->Find_Object(NodFlagAttached));
				Create_CTF_DropFlag(0,DeathPlace);
				CTF_Message(4);
				NodFlagLoc = 3;
			}
		}

		if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
			char IDFile[100];
			sprintf(IDFile,"del PL\\PL%d",Commands->Get_ID(obj));
			system(IDFile);
		}
	}
}

void M00_GrantPowerup_Created::Killed(GameObject *obj, GameObject *shooter) {
	if (EnableCTF == 1) {
		if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
			if (DropWeapons == 1) {
				Vector3 DeathPlace = Commands->Get_Position(obj);
				GameObject *BackpackObject = Commands->Create_Object("Invisible_Object",DeathPlace);
				Commands->Attach_Script(BackpackObject,"KAK_Backpack_Object",Commands->Get_Preset_Name(obj));
			}

			if (SpoilsofWar == 1) {
				//Spoils of War for killing holder
				if (Commands->Get_Player_Type(obj) == 0 && Commands->Get_ID(obj) == GDIFlagHolder) {
					Commands->Give_Points(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini"),true);
					Commands->Give_Points(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
					Commands->Give_Points(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderPointsInd",0.0f,"CTF_Settings.ini"),false);
					Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
					Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
					Commands->Give_Money(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsTeam",0.0f,"CTF_Settings.ini"),true);
					Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
					Commands->Give_Money(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsInd",0.0f,"CTF_Settings.ini"),false);
				}
				else if (Commands->Get_Player_Type(obj) == 1 && Commands->Get_ID(obj) == NodFlagHolder) {
					Commands->Give_Points(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini"),true);
					Commands->Give_Points(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
					Commands->Give_Points(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderPointsInd",0.0f,"CTF_Settings.ini"),false);
					Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
					Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
					Commands->Give_Money(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsTeam",0.0f,"CTF_Settings.ini"),true);
					Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
					Commands->Give_Money(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsInd",0.0f,"CTF_Settings.ini"),false);
				}
			}
		}
	}
}

void M00_GrantPowerup_Created::Register_Auto_Save_Variables() {
	if (EnableCTF == 1) Auto_Save_Variable(1,1,&IsDestroyed);
}

/* ************************************************************************************************************* */

void KAK_Backpack_Object::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,5,1);
}

void KAK_Backpack_Object::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		Vector3 DeathPlace = Commands->Get_Position(obj);
		GameObject *BackpackScript;

		int RandomNum = Commands->Get_Random_Int(1,4);

		if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player_Nod",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_ChemSprayer_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_0")) {
			BackpackScript = Commands->Create_Object("POW_Flamethrower_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Grenadier_0")) {
			BackpackScript = Commands->Create_Object("POW_GrenadeLauncher_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserChaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Technician_0")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineTimed_Player_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineTimed_Player_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineTimed_Player_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineTimed_Player_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney_PowerSuit")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_PersonalIonCannon_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_Railgun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("CnC_POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_TiberiumAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Grenadier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_TiberiumFlechetteGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Ignatio_Mobius")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_VoltAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("CnC_POW_VoltAutoRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else {
			BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		Commands->Send_Custom_Event(obj,BackpackScript,6000,Commands->Get_ID(obj),0);
	}
}

void KAK_Backpack::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 6000) {
		SpawnedByID = param;
	}
	else if (message == CUSTOM_EVENT_POWERUP) {
		if (SpawnedByID != Commands->Get_ID(sender)) {
			char IDFile[50], Weapons[10], WeaponString[25];
			sprintf(IDFile,"PL\\PL%d",Commands->Get_ID(sender));
			int TotalWeapons = getProfileInt("Guns","Total",0,IDFile);
			TotalWeapons++;
			sprintf(Weapons,"%d",TotalWeapons);
			sprintf(WeaponString,"Weapon%d",TotalWeapons);
			writeProfileString("Guns","Total",Weapons,IDFile);
			writeProfileString("Guns",WeaponString,Commands->Get_Preset_Name(obj),IDFile);
		}
	}
}

void KAK_Backpack::Register_Auto_Save_Variables() {
	Auto_Save_Variable(1,4,&SpawnedByID);
}

/* ************************************************************************************************************* */

void KAK_Flag_Icon::Created(GameObject *obj) {
	if (FirstGame == false) {
		char map[512], IDs[200];
		sprintf(IDs,"%d",MapID);
		getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");
		int Team = Get_Int_Parameter("Team");
		Vector3 PedPosition;
		if (Team == 0) {
			PedPosition.X = getProfileFloat(map,"NodFlag_X",500.000,"Data\\CTF.dat");
			PedPosition.Y = getProfileFloat(map,"NodFlag_Y",500.000,"Data\\CTF.dat");
			PedPosition.Z = getProfileFloat(map,"NodFlag_Z",-500.000,"Data\\CTF.dat");
		}
		else if (Team == 1) {
			PedPosition.X = getProfileFloat(map,"GDIFlag_X",500.000,"Data\\CTF.dat");
			PedPosition.Y = getProfileFloat(map,"GDIFlag_Y",500.000,"Data\\CTF.dat");
			PedPosition.Z = getProfileFloat(map,"GDIFlag_Z",-500.000,"Data\\CTF.dat");
		}
		IconPos = PedPosition;
		IconPos.X -= getProfileFloat("Flag","Flag_X",500.000,"Data\\CTF.dat");
		IconPos.Y -= getProfileFloat("Flag","Flag_Y",500.000,"Data\\CTF.dat");
		IconPos.Z -= getProfileFloat("Flag","Flag_Z",-500.000,"Data\\CTF.dat");
		IconPos.Z += 1.25f;
		Icon = Commands->Create_Object("Invisible_Object",IconPos);
		Commands->Start_Timer(obj,this,0.1f,Get_Int_Parameter("Team"));
	}
}

void KAK_Flag_Icon::Timer_Expired(GameObject *obj, int number) {
	if (number == 0) {
		if (NodFlagLoc == 1 && LastLoc != 1) {
			if (Icon != 0) Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("Artillery_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_CHEVRON.O_EM_CHEVRON",true,0,0.0f,-1.0f,false);
			LastLoc = 1;
		}
		else if (NodFlagLoc == 2 && LastLoc != 2) {
			if (Icon != 0) Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("Stealth_Tank_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_REDARR.O_EM_REDARR",true,0,0.0f,-1.0f,false);
			LastLoc = 2;
		}
		else if (NodFlagLoc == 3 && LastLoc != 3) {
			if (Icon != 0) Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("M06_Servant_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_GRNARR.O_EM_GRNARR",true,0,0.0f,-1.0f,false);
			LastLoc = 3;
		}
		Commands->Start_Timer(obj,this,0.1f,0);
	}
	else if (number == 1) {
		if (GDIFlagLoc == 1 && LastLoc != 1) {
			Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("Artillery_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_CHEVRON.O_EM_CHEVRON",true,0,0.0f,-1.0f,false);
			LastLoc = 1;
		}
		else if (GDIFlagLoc == 2 && LastLoc != 2) {
			Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("Stealth_Tank_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_REDARR.O_EM_REDARR",true,0,0.0f,-1.0f,false);
			LastLoc = 2;
		}
		else if (GDIFlagLoc == 3 && LastLoc != 3) {
			Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("M06_Servant_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_GRNARR.O_EM_GRNARR",true,0,0.0f,-1.0f,false);
			LastLoc = 3;
		}
		Commands->Start_Timer(obj,this,0.1f,1);
	}
}

/* ************************************************************************************************************* */

void KAK_Capture_Animation::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,1.0f,1);
}

void KAK_Capture_Animation::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		int Animation2Play = Commands->Get_Random_Int(1,13);
		if (Animation2Play == 1) Commands->Set_Animation(obj,"H_A_SIDEKICK",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 2) Commands->Set_Animation(obj,"H_A_PUNCHCOMBO",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 3) Commands->Set_Animation(obj,"H_A_A0A0_L02",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 4) Commands->Set_Animation(obj,"H_A_J22C",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 5) Commands->Set_Animation(obj,"H_A_A0A0_L23",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 6) Commands->Set_Animation(obj,"H_A_A0A0_L58",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 7) Commands->Set_Animation(obj,"H_A_B0A0_L05",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 8) Commands->Set_Animation(obj,"H_A_A0A0_L12",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 9) Commands->Set_Animation(obj,"H_A_J14C",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 10) Commands->Set_Animation(obj,"H_A_X33C",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 11) Commands->Set_Animation(obj,"H_A_A0A0_L22",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 12) Commands->Set_Animation(obj,"H_A_A0A0_L24",false,0,0.0f,-1.0f,false);
	}
}

void KAK_Capture_Animation::Animation_Complete(GameObject *obj, const char *anim) {
	Destroy_Script();
}

/* ************************************************************************************************************* */

ScriptRegistrant<M00_BUILDING_EXPLODE_NO_DAMAGE_DAK> M00_BUILDING_EXPLODE_NO_DAMAGE_DAK_Registrant("M00_BUILDING_EXPLODE_NO_DAMAGE_DAK","");
ScriptRegistrant<M00_Disable_Transition> M00_Disable_Transition_Registrant("M00_Disable_Transition","");
ScriptRegistrant<M00_GrantPowerup_Created> M00_GrantPowerup_Created_Registrant("M00_GrantPowerup_Created","WeaponDef:string");
ScriptRegistrant<KAK_Backpack> KAK_Backpack_Registrant("KAK_Backpack","");
ScriptRegistrant<KAK_Backpack_Object> KAK_Backpack_Object_Registrant("KAK_Backpack_Object","CharacterType:string");
ScriptRegistrant<KAK_CTF_Flag> KAK_CTF_Flag_Registrant("KAK_CTF_Flag","Team:int,FlagID:int");
ScriptRegistrant<KAK_CTF_DropFlag> KAK_CTF_DropFlag_Registrant("KAK_CTF_DropFlag","Team:int,FlagID:int");
ScriptRegistrant<KAK_Select_Flag> KAK_Select_Flag_Registrant("KAK_Select_Flag","");
ScriptRegistrant<KAK_Limit_Announcement> KAK_Limit_Announcement_Registrant("KAK_Limit_Announcement","");
ScriptRegistrant<KAK_FlagHolder_Regen> KAK_FlagHolder_Regen_Registrant("KAK_FlagHolder_Regen","");
ScriptRegistrant<KAK_FlagHolder_Appear> KAK_FlagHolder_Appear_Registrant("KAK_FlagHolder_Appear","");
ScriptRegistrant<KAK_Capture_Animation> KAK_Capture_Animation_Registrant("KAK_Capture_Animation","");
ScriptRegistrant<KAK_Flag_Icon> KAK_Flag_Icon_Registrant("KAK_Flag_Icon","Team:int");
