#include "stdafx.h"
#include "scripts.h"
#include "jfw3.h"

void JFW_Apply_Damage_On_Enter_Timer::Entered(GameObject * obj,GameObject * enter)
{
	int Player_Type = Get_Int_Parameter("Player_Type");
	if (CheckPlayerType(enter,Player_Type) != 0) {
		return;
	}
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Commands->Get_ID(enter));
}
void JFW_Apply_Damage_On_Enter_Timer::Timer_Expired(GameObject * obj,int number)
{
	float f;
	const char *w;
	float distance;
	Vector3 pos1;
	Vector3 pos2;
	pos1 = Commands->Get_Position(obj);
	pos2 = Commands->Get_Position(Commands->Find_Object(number));
	distance = Commands->Get_Distance(pos1,pos2);
	if (distance <= Get_Float_Parameter("Distance"))
	{
		w = Get_Parameter("Warhead");
		f = Get_Float_Parameter("Damage");
		Commands->Apply_Damage(Commands->Find_Object(number),f,w,false);
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),number);
	}
}
void JFW_Apply_Damage_On_Enter_Timer::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&ID);
}
void JFW_Zone_Send_Custom_Not_Preset::Entered(GameObject * obj,GameObject * enter)
{
	GameObject * object;
	int message;
	int ID;
	int param;
	const char *preset;
	const char *c;
	int pltype;
	pltype = Get_Int_Parameter("Player_Type");
	if (CheckPlayerType(enter,pltype) != 0) {
		return;
	}
	ID = Get_Int_Parameter("ID");
	message = Get_Int_Parameter("EnterMessage");
	param = Get_Int_Parameter("EnterParam");
	object = Commands->Find_Object(ID);
	c = Get_Parameter("Preset_Name");
	preset = Commands->Get_Preset_Name(enter);
	if (strcmp(preset,c) != 0) {
		if (message != 0) {
			if (param == 0) {
				param = Commands->Get_ID(enter);
			}
			Commands->Send_Custom_Event(obj,object,message,param,0);
		}
	}
}
void JFW_Zone_Send_Custom_Not_Preset::Exited(GameObject * obj, GameObject * exit)
{
	GameObject * object;
	int message;
	int ID;
	int param;
	const char *preset;
	const char *c;
	int pltype;
	pltype = Get_Int_Parameter("Player_Type");
	if (CheckPlayerType(exit,pltype) != 0) {
		return;
	}
	ID = Get_Int_Parameter("ID");
	message = Get_Int_Parameter("ExitMessage");
	param = Get_Int_Parameter("ExitParam");
	object = Commands->Find_Object(ID);
	c = Get_Parameter("Preset_Name");
	preset = Commands->Get_Preset_Name(exit);
	if (strcmp(preset,c) != 0) {
		if (message != 0) {
			if (param == 0) {
				param = Commands->Get_ID(exit);
			}
			Commands->Send_Custom_Event(obj,object,message,param,0);
		}
	}
}
void JFW_Zone_Send_Custom_Keycard::Entered(GameObject * obj,GameObject * enter)
{
	GameObject * object;
	int message;
	int ID;
	int param;
	int pltype;
	int key;
	pltype = Get_Int_Parameter("Player_Type");
	if (CheckPlayerType(enter,pltype) != 0) {
		return;
	}
	ID = Get_Int_Parameter("ID");
	message = Get_Int_Parameter("EnterMessage");
	param = Get_Int_Parameter("EnterParam");
	object = Commands->Find_Object(ID);
	key = Get_Int_Parameter("Keycard_Number");
	if (Commands->Has_Key(enter,key) == true) {
		if (message != 0) {
			if (param == 0) {
				param = Commands->Get_ID(enter);
			}
			Commands->Send_Custom_Event(obj,object,message,param,0);
		}
	}
}
void JFW_Zone_Send_Custom_Keycard::Exited(GameObject * obj, GameObject * exit)
{
	GameObject * object;
	int message;
	int ID;
	int param;
	int pltype;
	int key;
	pltype = Get_Int_Parameter("Player_Type");
	if (CheckPlayerType(exit,pltype) != 0) {
		return;
	}
	ID = Get_Int_Parameter("ID");
	message = Get_Int_Parameter("ExitMessage");
	param = Get_Int_Parameter("ExitParam");
	object = Commands->Find_Object(ID);
	key = Get_Int_Parameter("Keycard_Number");
	if (Commands->Has_Key(exit,key) == true) {
		if (message != 0) {
			if (param == 0) {
				param = Commands->Get_ID(exit);
			}
			Commands->Send_Custom_Event(obj,object,message,param,0);
		}
	}
}
void JFW_Give_Points_On_Death::Killed(GameObject * obj,GameObject * shooter)
{
	int pltype;
	pltype = Get_Int_Parameter("Player_Type");
	if (CheckPlayerType(shooter,pltype) != 0) {
		return;
	}
	Commands->Give_Points(shooter,Get_Float_Parameter("Points"),Get_Int_Parameter("Whole_Team"));
}
void JFW_Turret_Spawn_2::Created(GameObject * obj)
{
	Vector3 sp;
	GameObject *object;
	sp.X = 0;
	sp.Y = 0;
	sp.Z = 0;
	object = Commands->Create_Object(Get_Parameter("Turret_Preset"),sp);
	Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("Bone_Name"));
	turID = Commands->Get_ID(object);
}
void JFW_Turret_Spawn_2::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&turID);
}
void JFW_Turret_Spawn_2::Killed(GameObject * obj,GameObject * shooter)
{
	Vector3 tmb;
	tmb = Commands->Get_Bone_Position(obj,Get_Parameter("Explosion_Bone"));
	Commands->Create_Explosion(Get_Parameter("Explosion_Preset"),tmb,0);
}
void JFW_Teleport_Custom::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	int msg = Get_Int_Parameter("Message");
	if (message == msg) 
	{
		Vector3 spawn_position;
		spawn_position = Get_Vector3_Parameter("Location");
		int x = Get_Int_Parameter("Object_ID");
		if (x != 0)
		{
			GameObject * gotoObject = Commands->Find_Object(x);
			Vector3 gotoLocation = Commands->Get_Position(gotoObject);
			Commands->Set_Position(Commands->Find_Object(param),gotoLocation);
		}
		else
			Commands->Set_Position(Commands->Find_Object(param),spawn_position);
	}
}
void JFW_Teleport_Custom_Random::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	int msg = Get_Int_Parameter("Message");
	Vector3 spawn_position;
	int x;
	if (message == msg) 
	{
		int rand = Commands->Get_Random_Int(1,5);
		if (rand == 1) {
			spawn_position = Get_Vector3_Parameter("Location1");
			x = Get_Int_Parameter("Object_ID1");
		}
		if (rand == 2) {
			spawn_position = Get_Vector3_Parameter("Location2");
			x = Get_Int_Parameter("Object_ID2");
		}
		if (rand == 3) {
			spawn_position = Get_Vector3_Parameter("Location3");
			x = Get_Int_Parameter("Object_ID3");
		}
		if (rand == 4) {
			spawn_position = Get_Vector3_Parameter("Location4");
			x = Get_Int_Parameter("Object_ID4");
		}
		if (rand == 5) {
			spawn_position = Get_Vector3_Parameter("Location5");
			x = Get_Int_Parameter("Object_ID5");
		}
		if (x != 0)
		{
			GameObject * gotoObject = Commands->Find_Object(x);
			Vector3 gotoLocation = Commands->Get_Position(gotoObject);
			Commands->Set_Position(Commands->Find_Object(param),gotoLocation);
		}
		else
			Commands->Set_Position(Commands->Find_Object(param),spawn_position);
	}
}
void JFW_Teleport_Custom_Timer::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	int msg = Get_Int_Parameter("Message");
	if ((message == msg) && (enabled == true))
	{
		Vector3 spawn_position;
		spawn_position = Get_Vector3_Parameter("Location");
		int x = Get_Int_Parameter("Object_ID");
		if (x != 0)
		{
			GameObject * gotoObject = Commands->Find_Object(x);
			Vector3 gotoLocation = Commands->Get_Position(gotoObject);
			Commands->Set_Position(Commands->Find_Object(param),gotoLocation);
		}
		else
		{
			Commands->Set_Position(Commands->Find_Object(param),spawn_position);
		}
		enabled = false;
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNumber"));
	}
}
void JFW_Teleport_Custom_Timer::Timer_Expired(GameObject * obj,int number)
{
	enabled = true;
}
void JFW_Teleport_Custom_Timer::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&enabled);
}
void JFW_Teleport_Custom_Timer::Created(GameObject * obj)
{
	enabled = true;
}
void JFW_Armour_Regen::Created(GameObject * obj)
{
	float timertime;
	int timernumber;
	timertime = Get_Float_Parameter("Time");
	timernumber = Get_Int_Parameter("TimerNum");
	Commands->Start_Timer(obj,this,timertime,timernumber);
};
void JFW_Armour_Regen::Timer_Expired(GameObject * obj,int number)
{
	int timernumber;
	float timertime;
	float armour;
	timertime = Get_Float_Parameter("Time");
	timernumber = Get_Int_Parameter("TimerNum");
	if (number == timernumber) {
		armour = Commands->Get_Shield_Strength(obj);
		armour += Get_Float_Parameter("Points");
		if (armour > Commands->Get_Max_Shield_Strength(obj))
		{
			armour = Commands->Get_Max_Shield_Strength(obj);
		}
		Commands->Set_Shield_Strength(obj,armour);
		Commands->Start_Timer(obj,this,timertime,timernumber);
	}
}
void JFW_Health_Regen::Created(GameObject * obj)
{
	float timertime;
	int timernumber;
	timertime = Get_Float_Parameter("Time");
	timernumber = Get_Int_Parameter("TimerNum");
	Commands->Start_Timer(obj,this,timertime,timernumber);
};
void JFW_Health_Regen::Timer_Expired(GameObject * obj,int number)
{
	int timernumber;
	float timertime;
	float armour;
	timertime = Get_Float_Parameter("Time");
	timernumber = Get_Int_Parameter("TimerNum");
	if (number == timernumber) {
		armour = Commands->Get_Health(obj);
		armour += Get_Float_Parameter("Points");
		if (armour > Commands->Get_Max_Health(obj))
		{
			armour = Commands->Get_Max_Health(obj);
		}
		Commands->Set_Health(obj,armour);
		Commands->Start_Timer(obj,this,timertime,timernumber);
	}
}
void JFW_Blow_Up_Location_On_Custom::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	const char *c;
	int msg;
	Vector3 v;
	msg = Get_Int_Parameter("Message");
	if (message == msg)
	{
		c = Get_Parameter("Explosion");
		v = Get_Vector3_Parameter("Location");
		Commands->Create_Explosion(c,v,0);
	}
}
void JFW_Customs_Play_Cinematic::Created(GameObject * obj)
{
	if (Get_Int_Parameter("Message1") == 0)
	{
		custom1 = true;
	}
	else
	{
		custom1 = false;
	}
	if (Get_Int_Parameter("Message2") == 0)
	{
		custom2 = true;
	}
	else
	{
		custom2 = false;
	}
	if (Get_Int_Parameter("Message3") == 0)
	{
		custom3 = true;
	}
	else
	{
		custom3 = false;
	}
	if (Get_Int_Parameter("Message4") == 0)
	{
		custom4 = true;
	}
	else
	{
		custom4 = false;
	}
	if (Get_Int_Parameter("Message5") == 0)
	{
		custom5 = true;
	}
	else
	{
		custom5 = false;
	}
	if (Get_Int_Parameter("Message6") == 0)
	{
		custom6 = true;
	}
	else
	{
		custom6 = false;
	}
	if (Get_Int_Parameter("Message7") == 0)
	{
		custom7 = true;
	}
	else
	{
		custom7 = false;
	}
	if (Get_Int_Parameter("Message8") == 0)
	{
		custom8 = true;
	}
	else
	{
		custom8 = false;
	}
	trigger = false;
}
void JFW_Customs_Play_Cinematic::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	int msg;
	const char *scriptname;
	Vector3 position;
	GameObject * object;
	float facing;
	msg = Get_Int_Parameter("Message1");
	if (message == msg) {
		custom1 = true;
	}
	msg = Get_Int_Parameter("Message2");
	if (message == msg) {
		custom2 = true;
	}
	msg = Get_Int_Parameter("Message3");
	if (message == msg) {
		custom3 = true;
	}
	msg = Get_Int_Parameter("Message4");
	if (message == msg) {
		custom4 = true;
	}
	msg = Get_Int_Parameter("Message5");
	if (message == msg) {
		custom5 = true;
	}
	msg = Get_Int_Parameter("Message6");
	if (message == msg) {
		custom6 = true;
	}
	msg = Get_Int_Parameter("Message7");
	if (message == msg) {
		custom7 = true;
	}
	msg = Get_Int_Parameter("Message8");
	if (message == msg) {
		custom8 = true;
	}
	if (trigger == false) {
		if ((custom1 == true) && (custom2 == true) && (custom3 == true) && (custom4 == true) && (custom5 == true) && (custom6 == true) && (custom7 == true) && (custom8 == true)) {
			trigger = true;
			scriptname = Get_Parameter("Script_Name");
			position = Get_Vector3_Parameter("Location");
			facing = Get_Float_Parameter("Facing");
			object = Commands->Create_Object("Invisible_Object",position);
			Commands->Set_Facing(object,facing);
			Commands->Attach_Script(object,"Test_Cinematic",scriptname);
		}
	}
};
void JFW_Customs_Play_Cinematic::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,1,&custom1);
	Auto_Save_Variable(2,1,&custom2);
	Auto_Save_Variable(3,1,&custom3);
	Auto_Save_Variable(4,1,&custom4);
	Auto_Save_Variable(5,1,&custom5);
	Auto_Save_Variable(6,1,&custom6);
	Auto_Save_Variable(7,1,&custom7);
	Auto_Save_Variable(8,1,&custom8);
	Auto_Save_Variable(9,1,&trigger);
}
void JFW_Domination_Zone::Created(GameObject * obj)
{
	enabled = true;
	GameObject *object;
	float facing;
	object = Commands->Create_Object("Generic_Cinematic",Commands->Get_Position(obj));
	Commands->Enable_Hibernation(object,false);
	Commands->Add_To_Dirty_Cull_List(object);
	Commands->Set_Model(object,Get_Parameter("Neutral_Model"));
	facing = Commands->Get_Facing(obj);
	Commands->Set_Facing(object,facing);
	currentmodelid = Commands->Get_ID(object);
	owner = 2;
}
void JFW_Domination_Zone::Entered(GameObject * obj,GameObject * enter)
{
	float timertime;
	int timernumber;
	GameObject *object;
	float facing;
	int message;
	if (enabled == false)
	{
		return;
	}
	if (Commands->Get_Player_Type(enter) == owner)
	{
		return;
	}
	if (owner == 2) {
		message = Get_Int_Parameter("NeutralMessage");
	} else {
		message = Get_Int_Parameter("OwnedMessage");
	}
	Commands->Destroy_Object(Commands->Find_Object(currentmodelid));
	object = Commands->Create_Object("Generic_Cinematic",Commands->Get_Position(obj));
	Commands->Enable_Hibernation(object,false);
	Commands->Add_To_Dirty_Cull_List(object);
	if (Commands->Get_Player_Type(enter) == 0)
	{
		Commands->Set_Model(object,Get_Parameter("Nod_Model"));
		owner = 0;
	}
	if (Commands->Get_Player_Type(enter) == 1)
	{
		Commands->Set_Model(object,Get_Parameter("GDI_Model"));
		owner = 1;
	}
	facing = Commands->Get_Facing(obj);
	Commands->Set_Facing(object,facing);
	currentmodelid = Commands->Get_ID(object);
	object = Commands->Find_Object(Get_Int_Parameter("Controler_ID"));
	Commands->Send_Custom_Event(obj,object,message,owner,0);
	enabled = false;
	timertime = Get_Float_Parameter("Capture_Delay_Time");
	timernumber = Get_Int_Parameter("TimerNumber");
	if (timertime != 0) {
		Commands->Start_Timer(obj,this,timertime,timernumber);
	}
	else
	{
		enabled = true;
	}
}
void JFW_Domination_Zone::Timer_Expired(GameObject * obj,int number)
{
	enabled = true;
}
void JFW_Domination_Zone::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&currentmodelid);
	Auto_Save_Variable(2,1,&enabled);
	Auto_Save_Variable(3,4,&owner);
}
void JFW_Domination_Controler::Created(GameObject * obj)
{
	float timertime;
	int timernumber;
	gdizonecount = 0;
	nodzonecount = 0;
	timertime = Get_Float_Parameter("Time");
	timernumber = Get_Int_Parameter("TimerNumber");
	Commands->Start_Timer(obj,this,timertime,timernumber);
}
void JFW_Domination_Controler::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	int neutralmessage;
	int ownedmessage;
	neutralmessage = Get_Int_Parameter("NeutralMessage");
	ownedmessage = Get_Int_Parameter("OwnedMessage");
	if (message == ownedmessage)
	{
		if (param == 0)
		{
			gdizonecount--;
		}
		else
		{
			nodzonecount--;
		}
	}
	if ((message == neutralmessage) || (message == ownedmessage))
	{
		if (param == 1)
		{
			gdizonecount++;
		}
		else
		{
			nodzonecount++;
		}
	}
}
void JFW_Domination_Controler::Timer_Expired(GameObject * obj,int number)
{
	float timertime;
	int timernumber;
	float pointstogive;
	float pointstotake;
	GameObject *gdiobject;
	GameObject *nodobject;
	gdiobject = Commands->Find_Object(Get_Int_Parameter("GDIObjectID"));
	nodobject = Commands->Find_Object(Get_Int_Parameter("NodObjectID"));
	pointstogive = Get_Float_Parameter("PointsToGive");
	pointstotake = Get_Float_Parameter("PointsToTake");
	if (gdizonecount > 0)
	{
		if (pointstogive != 0)
		{
			Commands->Give_Points(gdiobject,pointstogive*gdizonecount,true);
		}
		if (pointstotake != 0)
		{
			Commands->Give_Points(nodobject,-(pointstotake*gdizonecount),true);
		}
	}
	if (nodzonecount > 0)
	{
		if (pointstogive != 0)
		{
			Commands->Give_Points(nodobject,pointstogive*nodzonecount,true);
		}
		if (pointstotake != 0)
		{
			Commands->Give_Points(gdiobject,-(pointstotake*nodzonecount),true);
		}
	}
	timertime = Get_Float_Parameter("Time");
	timernumber = Get_Int_Parameter("TimerNumber");
	Commands->Start_Timer(obj,this,timertime,timernumber);
}
void JFW_Domination_Controler::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&gdizonecount);
	Auto_Save_Variable(2,4,&nodzonecount);
}
void JFW_3D_Sound_Custom::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	int msg;
	Vector3 v;
	const char *c;
	msg = Get_Int_Parameter("Message");
	if (message == msg)
	{
		v = Get_Vector3_Parameter("Position");
		c = Get_Parameter("Preset");
		Commands->Create_Sound(c,v,0);
	}
}
void JFW_Object_Draw_In_Order::Created(GameObject * obj)
{
	currentmodelid = 0;
	currentmodelnumber = 1;
}
void JFW_Object_Draw_In_Order::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	int msg;
	Vector3 location;
	const char *basename;
	char name[20];
	int count;
	float facing;
	GameObject *object;
	msg = Get_Int_Parameter("Custom");
	if (message == msg)
	{
		if (currentmodelid != 0)
		{
			Commands->Destroy_Object(Commands->Find_Object(currentmodelid));
		}
		location = Get_Vector3_Parameter("location");
		basename = Get_Parameter("BaseName");
		count = Get_Int_Parameter("Count");
		facing = Get_Float_Parameter("Facing");
		sprintf(name,"%s%i",basename,currentmodelnumber);
		object = Commands->Create_Object("Generic_Cinematic",location);
		Commands->Enable_Hibernation(object,false);
		Commands->Add_To_Dirty_Cull_List(object);
		Commands->Set_Model(object,name);
		Commands->Set_Facing(object,facing);
		currentmodelid = Commands->Get_ID(object);
		currentmodelnumber++;
		if (currentmodelnumber > count)
		{
			currentmodelnumber = 1;
		}
	}
}
void JFW_Object_Draw_In_Order::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(1,4,&currentmodelnumber);
	Auto_Save_Variable(2,4,&currentmodelid);
}
void JFW_Object_Draw_Random::Created(GameObject * obj)
{
	currentmodelid = 0;
}
void JFW_Object_Draw_Random::Custom(GameObject * obj,int message,int param,GameObject * sender)
{
	int msg;
	Vector3 location;
	const char *basename;
	char name[20];
	int count;
	int currentmodelnumber;
	float facing;
	GameObject *object;
	msg = Get_Int_Parameter("Custom");
	if (message == msg)
	{
		if (currentmodelid != 0)
		{
			Commands->Destroy_Object(Commands->Find_Object(currentmodelid));
		}
		Commands->Destroy_Object(Commands->Find_Object(currentmodelid));
		location = Get_Vector3_Parameter("location");
		basename = Get_Parameter("BaseName");
		count = Get_Int_Parameter("Count");
		facing = Get_Float_Parameter("Facing");
		currentmodelnumber = Commands->Get_Random_Int(1,count);
		sprintf(name,"%s%i",basename,currentmodelnumber);
		object = Commands->Create_Object("Generic_Cinematic",location);
		Commands->Enable_Hibernation(object,false);
		Commands->Add_To_Dirty_Cull_List(object);
		Commands->Set_Model(object,name);
		Commands->Set_Facing(object,facing);
		currentmodelid = Commands->Get_ID(object);
	}
}
void JFW_Object_Draw_Random::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(2,4,&currentmodelid);
}
ScriptRegistrant<JFW_Customs_Play_Cinematic> JFW_Customs_Play_Cinematic_Registrant("JFW_Customs_Play_Cinematic","Message1:int,Message2:int,Message3:int,Message4:int,Message5:int,Message6:int,Message7:int,Message8:int,Script_Name:string,Location:Vector3,Facing:float");
ScriptRegistrant<JFW_Armour_Regen> JFW_Armour_Regen_Registrant("JFW_Armour_Regen","Time:float,TimerNum:int,Points:int");
ScriptRegistrant<JFW_Health_Regen> JFW_Health_Regen_Registrant("JFW_Health_Regen","Time:float,TimerNum:int,Points:int");
ScriptRegistrant<JFW_Turret_Spawn_2> JFW_Turret_Spawn_2_Registrant ("JFW_Turret_Spawn_2","Turret_Preset:string,Bone_Name=Tur_Mount:string,Explosion_Preset:string,Explosion_Bone:string");
ScriptRegistrant<JFW_Zone_Send_Custom_Not_Preset> JFW_Zone_Send_Custom_Not_Preset_Registrant("JFW_Zone_Send_Custom_Not_Preset","ID:int,EnterMessage:int,EnterParam:int,ExitMessage:int,ExitParam:int,Player_Type:int,Preset_Name:string");
ScriptRegistrant<JFW_Zone_Send_Custom_Keycard> JFW_Zone_Send_Custom_Keycard("JFW_Zone_Send_Custom_Keycard","ID:int,EnterMessage:int,EnterParam:int,ExitMessage:int,ExitParam:int,Player_Type:int,Keycard_Number:int");
ScriptRegistrant<JFW_Apply_Damage_On_Enter_Timer> JFW_Apply_Damage_On_Enter_Timer_Registrant("JFW_Apply_Damage_On_Enter_Timer","Warhead:string,Damage:float,Time:float,Distance:float,Player_Type:int");
ScriptRegistrant<JFW_Give_Points_On_Death> JFW_Give_Points_On_Death_Registrant("JFW_Give_Points_On_Death","Points:float,Player_Type:int,Whole_Team:int");
ScriptRegistrant<JFW_Teleport_Custom> JFW_Teleport_Custom_Registrant("JFW_Teleport_Custom","Location:Vector3,Object_ID=0:int,Message:int");
ScriptRegistrant<JFW_Teleport_Custom_Random> JFW_Teleport_Custom_Random_Registrant("JFW_Teleport_Custom_Random","Location1:Vector3,Object_ID1=0:int,Location2:Vector3,Object_ID2=0:int,Location3:Vector3,Object_ID3=0:int,Location4:Vector3,Object_ID4=0:int,Location5:Vector3,Object_ID5=0:int,Message:int");
ScriptRegistrant<JFW_Teleport_Custom_Timer> JFW_Teleport_Custom_Timer_Registrant("JFW_Teleport_Custom_Timer","Location:Vector3,Object_ID=0:int,Message:int,Time:float,TimerNumber:int");
ScriptRegistrant<JFW_Blow_Up_Location_On_Custom> JFW_Blow_Location_Up_On_Custom_Registrant("JFW_Blow_Location_Up_On_Custom","Explosion:string,Message:int,Location:Vector3");
ScriptRegistrant<JFW_Domination_Zone> JFW_Domination_Zone_Registrant("JFW_Domination_Zone","Controler_ID:int,NeutralMessage:int,OwnedMessage:int,Nod_Model:string,GDI_Model:string,Neutral_Model:string,Capture_Delay_Time:float,TimerNumber:int");
ScriptRegistrant<JFW_Domination_Controler> JFW_Domination_Controler_Registrant("JFW_Domination_Controler","NeutralMessage:int,OwnedMessage:int,Time:float,TimerNumber:int,PointsToGive:float,PointsToTake:float,GDIObjectID:int,NodObjectID:int");
ScriptRegistrant<JFW_3D_Sound_Custom> JFW_3D_Sound_Custom_Registrant("JFW_3D_Sound_Custom","Message:int,Preset:string,Position:Vector3");
ScriptRegistrant<JFW_Object_Draw_In_Order> JFW_Object_Draw_In_Order_Registrant("JFW_Object_Draw_In_Order"," Location:Vector3,Custom:int,BaseName:string,Count:int,Facing:float");
ScriptRegistrant<JFW_Object_Draw_Random> JFW_Object_Draw_Random_Registrant("JFW_Object_Draw_Random"," Location:Vector3,Custom:int,BaseName:string,Count:int,Facing:float");
