#include "stdafx.h"
#include "scripts.h"
#include "CTF.h"

void FDSMessage(const char* Message) {
	currdate.refreshdate();
	char FDSlogname[100], messageprint[512], hours[5], mins[5], secs[5], readline[250], msgline[256];
	sprintf(FDSlogname, "renlog_%s.txt",currdate.get_date_string());
	time_t rawtime;
	struct tm *timeinfo;
	time(&rawtime);
	timeinfo = localtime(&rawtime);
	int hour = timeinfo->tm_hour;
	int min = timeinfo->tm_min;
	int sec = timeinfo->tm_sec;
	if (hour < 10) sprintf(hours,"0%d",hour);
	else sprintf(hours,"%d",hour);
	if (min < 10) sprintf(mins,"0%d",min);
	else sprintf(mins,"%d",min);
	if (sec < 10) sprintf(secs,"0%d",sec);
	else sprintf(secs,"%d",sec);

	std::ofstream FDSLog (FDSlogname,ios::app);
	if (FDSLog.is_open()) {
		printf("%s\n",Message);
		sprintf(messageprint,"[%s:%s:%s] %s\n",hours,mins,secs,Message);
		FDSLog << messageprint;
		FDSLog.close();
	}
}

/* ************************************************************************************************************* */

//Handles all CTF messages
void CTF_Message (int message, const char *Event_Name1, const char *Event_Name2) {
	currdate.refreshdate();
	char FDSlogname[100], messageprint[512], hours[5], mins[5], secs[5], readline[250], msgline[256];
	sprintf(FDSlogname, "ctflog_%s.txt",currdate.get_date_string());
	time_t rawtime;
	struct tm *timeinfo;
	time(&rawtime);
	timeinfo = localtime(&rawtime);
	int hour = timeinfo->tm_hour;
	int min = timeinfo->tm_min;
	int sec = timeinfo->tm_sec;
	if (hour < 10) sprintf(hours,"0%d",hour);
	else sprintf(hours,"%d",hour);
	if (min < 10) sprintf(mins,"0%d",min);
	else sprintf(mins,"%d",min);
	if (sec < 10) sprintf(secs,"0%d",sec);
	else sprintf(secs,"%d",sec);

	std::string Name1(Event_Name1),
				Name2(Event_Name2);

	if (message == 1) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag Stolen %s\n",hours,mins,secs,Event_Name1);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFGDISTOLEN","GDI's flag has been stolen.",readline,250,"CTF_Settings.ini");
		std::string Message(readline);
		int n;
		while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
		while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
		sprintf(msgline,"msg %s",Message.c_str());
		ConsoleCommand(msgline);
		printf(Message.c_str());
		Commands->Create_2D_WAV_Sound("MXXDSGN_DSGN0001I1EVAG_SND.wav");
		Commands->Create_2D_WAV_Sound("pickupflag.wav");
	}
	else if (message == 2) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag Stolen %s\n",hours,mins,secs,Event_Name1);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFNODSTOLEN","Nod's flag has been stolen.",readline,250,"CTF_Settings.ini");
		std::string Message(readline);
		int n;
		while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
		while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
		sprintf(msgline,"msg %s",Message.c_str());
		ConsoleCommand(msgline);
		printf(Message.c_str());
		Commands->Create_2D_WAV_Sound("MXXDSGN_DSGN0011I1EVAN_SND.wav");
		Commands->Create_2D_WAV_Sound("pickupflag.wav");
	}

	else if (message == 3) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag Dropped %s %s\n",hours,mins,secs,Event_Name1,Event_Name2);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFGDIDROP","GDI's flag has been dropped.",readline,250,"CTF_Settings.ini");
		std::string Message(readline);
		int n;
		while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
		while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
		sprintf(msgline,"msg %s",Message.c_str());
		ConsoleCommand(msgline);
		printf(Message.c_str());
		Commands->Create_2D_WAV_Sound("dropflag.wav");
	}
	else if (message == 4) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag Dropped %s %s\n",hours,mins,secs,Event_Name1,Event_Name2);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFNODDROP","Nod's flag has been dropped.",readline,250,"CTF_Settings.ini");
		std::string Message(readline);
		int n;
		while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
		while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
		sprintf(msgline,"msg %s",Message.c_str());
		ConsoleCommand(msgline);
		printf(Message.c_str());
		Commands->Create_2D_WAV_Sound("dropflag.wav");
	}

	else if (message == 5) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag PickedUp %s\n",hours,mins,secs,Event_Name1);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFGDIPICKUP","GDI's flag has been picked up.",readline,250,"CTF_Settings.ini");
		std::string Message(readline);
		int n;
		while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
		while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
		sprintf(msgline,"msg %s",Message.c_str());
		ConsoleCommand(msgline);
		Commands->Create_2D_WAV_Sound("pickupflag.wav");
	}
	else if (message == 6) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag PickedUp %s\n",hours,mins,secs,Event_Name1);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFNODPICKUP","Nod's flag has been picked up.",readline,250,"CTF_Settings.ini");
		std::string Message(readline);
		int n;
		while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
		while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
		sprintf(msgline,"msg %s",Message.c_str());
		ConsoleCommand(msgline);
		printf(Message.c_str());
		Commands->Create_2D_WAV_Sound("pickupflag.wav");
	}

	else if (message == 7) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag Returned %s\n",hours,mins,secs,Event_Name1);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFGDIRETURN","GDI's flag has been returned.",readline,250,"CTF_Settings.ini");
		std::string Message(readline);
		int n;
		while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
		while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
		sprintf(msgline,"msg %s",Message.c_str());
		ConsoleCommand(msgline);
		printf(Message.c_str());
		Commands->Create_2D_WAV_Sound("MXXDSGN_DSGN0014I1EVAG_SND.wav");
		Commands->Create_2D_WAV_Sound("levelchange.wav");
	}
	else if (message == 8) {
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag Returned %s\n",hours,mins,secs,Event_Name1);
			FDSLog << messageprint;
			FDSLog.close();
		}
		getProfileString("StringTable","CTFNODRETURN","Nod's flag has been returned.",readline,250,"CTF_Settings.ini");
		std::string Message(readline);
		int n;
		while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
		while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
		sprintf(msgline,"msg %s",Message.c_str());
		ConsoleCommand(msgline);
		printf(Message.c_str());
		Commands->Create_2D_WAV_Sound("MXXDSGN_DSGN0044I1EVAN_SND.wav");
		Commands->Create_2D_WAV_Sound("levelchange.wav");
	}

	else if (message == 9) {
		if (EnableCapLimit == 1) {
			std::ofstream FDSLog (FDSlogname,ios::app);
			if (FDSLog.is_open()) {
				sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag Captured %s %dCapLeft\n",hours,mins,secs,Event_Name1,(TotalCaptures - NodCaps));
				FDSLog << messageprint;
				FDSLog.close();
			}
			getProfileString("StringTable","CTFGDICAPTURE","GDI's flag has been captured.",readline,250,"CTF_Settings.ini");
			std::string Message(readline);
			int n;
			while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
			while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
			sprintf(msgline,"msg %s",Message.c_str());
			ConsoleCommand(msgline);
			printf(Message.c_str());
		}
		else if (EnableCapLimit == 0) {
			std::ofstream FDSLog (FDSlogname,ios::app);
			if (FDSLog.is_open()) {
				sprintf(messageprint,"[%s:%s:%s] CTF: GDIFlag Captured %s 0\n",hours,mins,secs,Event_Name1);
				FDSLog << messageprint;
				FDSLog.close();
			}
			getProfileString("StringTable","CTFGDICAPTURE","GDI's flag has been captured.",readline,250,"CTF_Settings.ini");
			std::string Message(readline);
			int n;
			while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
			while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
			sprintf(msgline,"msg %s\nNod needs to capture GDI's flag %d more time(s) to win.",Message.c_str(),(TotalCaptures - NodCaps));
			ConsoleCommand(msgline);
			printf(Message.c_str());
		}
		Commands->Create_2D_WAV_Sound("MXXDSGN_DSGN0042I1EVAN_SND.wav");
		Commands->Create_2D_WAV_Sound("capflag.wav");
	}
	else if (message == 10) {
		if (EnableCapLimit == 1) {
			std::ofstream FDSLog (FDSlogname,ios::app);
			if (FDSLog.is_open()) {
				sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag Captured %s %dCapLeft\n",hours,mins,secs,Event_Name1,(TotalCaptures - GDICaps));
				FDSLog << messageprint;
				FDSLog.close();
			}
			getProfileString("StringTable","CTFNODCAPTURE","Nod's flag has been captured.",readline,250,"CTF_Settings.ini");
			std::string Message(readline);
			int n;
			while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
			while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
			sprintf(msgline,"msg %s\nGDI needs to capture Nod's flag %d more time(s) to win.",Message.c_str(),(TotalCaptures - GDICaps));
			ConsoleCommand(msgline);
			printf(Message.c_str());
		}
		else if (EnableCapLimit == 0) {
			std::ofstream FDSLog (FDSlogname,ios::app);
			if (FDSLog.is_open()) {
				sprintf(messageprint,"[%s:%s:%s] CTF: NodFlag Captured %s 0\n",hours,mins,secs,Event_Name1);
				FDSLog << messageprint;
				FDSLog.close();
			}
			getProfileString("StringTable","CTFNODCAPTURE","Nod's flag has been captured.",readline,250,"CTF_Settings.ini");
			std::string Message(readline);
			int n;
			while((n = Message.find("<Name1>")) != std::string::npos) Message.replace(n,7,Name1);
			while((n = Message.find("<Name2>")) != std::string::npos) Message.replace(n,7,Name2);
			sprintf(msgline,"msg %s",Message.c_str());
			ConsoleCommand(msgline);
			printf(Message.c_str());
		}
		Commands->Create_2D_WAV_Sound("MXXDSGN_DSGN0012I1EVAG_SND.wav");
		Commands->Create_2D_WAV_Sound("capflag.wav");
	}

	else if (message == 11) {
		FDSMessage("GDI has captured the flag enough times to win.\n");
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: GDI Wins\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
		Commands->Create_2D_WAV_Sound("MXXDSGN_DSGN0047I1EVAG_SND.wav");
		Commands->Create_2D_WAV_Sound("evicted.wav");
	}
	else if (message == 12) {
		FDSMessage("Nod has captured the flag enough times to win.\n");
		std::ofstream FDSLog (FDSlogname,ios::app);
		if (FDSLog.is_open()) {
			sprintf(messageprint,"[%s:%s:%s] CTF: Nod Wins\n",hours,mins,secs);
			FDSLog << messageprint;
			FDSLog.close();
		}
		Commands->Create_2D_WAV_Sound("MXXDSGN_DSGN0043I1EVAN_SND.wav");
		Commands->Create_2D_WAV_Sound("evicted.wav");
	}
}

//Creates the flag at the Ped's location
GameObject *Create_CTF_Flag (int Team, Vector3 PedPosition) {
	Vector3 FlagLoc;
	GameObject *Flag;
	char scriptPar[256];

	FlagLoc = PedPosition;
	FlagLoc.X -= getProfileFloat("Flag","Flag_X",500.000,"Data\\CTF.dat");
	FlagLoc.Y -= getProfileFloat("Flag","Flag_Y",500.000,"Data\\CTF.dat");
	FlagLoc.Z -= getProfileFloat("Flag","Flag_Z",-500.000,"Data\\CTF.dat");
	Flag = Commands->Create_Object(FlagPreset,FlagLoc);
	Commands->Set_Player_Type(Flag,Team);

	sprintf(scriptPar,"%d,%d",Team,Commands->Get_ID(Flag));
	Commands->Attach_Script(Flag,"KAK_CTF_Flag",scriptPar);

	if (Team == 0) {
		NodFlagHolder = 0;
		NodFlagAttached = 0;
	}
	else if (Team == 1) {
		GDIFlagHolder = 0;
		GDIFlagAttached = 0;
	}

	return Flag;
}

//Creates the flag at position X, used for dead flag holder
GameObject *Create_CTF_DropFlag (int Team, Vector3 Position) {
	Vector3 FlagLoc;
	GameObject *Flag;
	char scriptPar[256];

	FlagLoc = Position;
	FlagLoc.X -= getProfileFloat("Flag","Flag_X",500.000,"Data\\CTF.dat");
	FlagLoc.Y -= getProfileFloat("Flag","Flag_Y",500.000,"Data\\CTF.dat");
	FlagLoc.Z -= getProfileFloat("Flag","Flag_Z",-500.000,"Data\\CTF.dat");
	Flag = Commands->Create_Object(FlagPreset,FlagLoc);
	Commands->Set_Player_Type(Flag,Team);

	sprintf(scriptPar,"%d,%d",Team,Commands->Get_ID(Flag));
	Commands->Attach_Script(Flag,"KAK_CTF_DropFlag",scriptPar);

	if (Team == 0) {
		NodFlagHolder = 0;
		NodFlagAttached = Commands->Get_ID(Flag);
	}
	else if (Team == 1) {
		GDIFlagHolder = 0;
		GDIFlagAttached = Commands->Get_ID(Flag);
	}

	return Flag;
}

//Creates the flag at Team's Ped
GameObject *Create_CTF_PedFlag (int Team) {
	Vector3 FlagLoc, PedPosition;
	GameObject *Flag;
	char scriptPar[256], map[256], IDs[100];
	sprintf(IDs,"%d",MapID);
	getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");

	if (Team == 0) {
		PedPosition.X = getProfileFloat(map,"NodFlag_X",500.000,"Data\\CTF.dat");
		PedPosition.Y = getProfileFloat(map,"NodFlag_Y",500.000,"Data\\CTF.dat");
		PedPosition.Z = getProfileFloat(map,"NodFlag_Z",-500.000,"Data\\CTF.dat");
	}
	else if (Team == 1) {
		PedPosition.X = getProfileFloat(map,"GDIFlag_X",500.000,"Data\\CTF.dat");
		PedPosition.Y = getProfileFloat(map,"GDIFlag_Y",500.000,"Data\\CTF.dat");
		PedPosition.Z = getProfileFloat(map,"GDIFlag_Z",-500.000,"Data\\CTF.dat");
	}

	FlagLoc = PedPosition;
	FlagLoc.X -= getProfileFloat("Flag","Flag_X",500.000,"Data\\CTF.dat");
	FlagLoc.Y -= getProfileFloat("Flag","Flag_Y",500.000,"Data\\CTF.dat");
	FlagLoc.Z -= getProfileFloat("Flag","Flag_Z",-500.000,"Data\\CTF.dat");
	Flag = Commands->Create_Object(FlagPreset,FlagLoc);
	Commands->Set_Player_Type(Flag,Team);

	sprintf(scriptPar,"%d,%d",Team,Commands->Get_ID(Flag));
	Commands->Attach_Script(Flag,"KAK_CTF_Flag",scriptPar);

	if (Team == 0) {
		NodFlagHolder = 0;
		NodFlagAttached = 0;
	}
	else if (Team == 1) {
		GDIFlagHolder = 0;
		GDIFlagAttached = 0;
	}

	return Flag;
}

//Creates Team's CTF Ped
void Create_CTF_Pedestal (int Team, int ID) {
	Vector3 PedLoc;
	GameObject *Ped, *Flag;
    char map[256], IDs[100];
	sprintf(IDs,"%d",ID);
	getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");

	if (Team == 0) {
		PedLoc.X = getProfileFloat(map,"NodFlag_X",500.000,"Data\\CTF.dat");
		PedLoc.Y = getProfileFloat(map,"NodFlag_Y",500.000,"Data\\CTF.dat");
		PedLoc.Z = getProfileFloat(map,"NodFlag_Z",-500.000,"Data\\CTF.dat");
		Ped = Commands->Create_Object(NodPedPreset,PedLoc);
	}
	else if (Team == 1) {
		PedLoc.X = getProfileFloat(map,"GDIFlag_X",500.000,"Data\\CTF.dat");
		PedLoc.Y = getProfileFloat(map,"GDIFlag_Y",500.000,"Data\\CTF.dat");
		PedLoc.Z = getProfileFloat(map,"GDIFlag_Z",-500.000,"Data\\CTF.dat");
		Ped = Commands->Create_Object(GDIPedPreset,PedLoc);
	}

	Commands->Attach_Script(Ped,"KAK_Prevent_Kill","");
	Flag = Create_CTF_Flag(Team,PedLoc);
}

/* ************************************************************************************************************* */

//Core of CTF, controls the flag that rests on the Ped
void KAK_CTF_Flag::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == CUSTOM_EVENT_POWERUP && Get_Int_Parameter("Team") != Commands->Get_Player_Type(sender)) {		//Enemy picked up the flag
		//Destroy flag on Ped
		Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("FlagID")));

		//Put flag on person
		GameObject *AttachedFlag = Commands->Create_Object_At_Bone(sender,FlagBackPreset,"bone for bag");
		Commands->Attach_To_Object_Bone(AttachedFlag, sender, "bone for bag");
		Commands->Disable_All_Collisions(AttachedFlag);
		Commands->Set_Player_Type(AttachedFlag,Get_Int_Parameter("Team"));
		
		if (WeaponForHolder == 0) {
			Commands->Give_Powerup(sender,"POW_Uplink",true);
			Commands->Attach_Script(sender,"KAK_Select_Flag","");
		}
		if (RegenForHolder == 1) {
			Commands->Attach_Script(sender,"KAK_FlagHolder_Regen","");
		}
		Commands->Attach_Script(sender,"KAK_FlagHolder_Appear","");

		if (SpoilsofWar == 1) {
			//Spoils of War for picking up flag
			Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","StealPointsTeam",0.0f,"CTF_Settings.ini"),true);
			Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","StealPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","StealPointsInd",0.0f,"CTF_Settings.ini"),false);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","StealPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","StealPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","StealCreditsTeam",0.0f,"CTF_Settings.ini"),true);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","StealCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","StealCreditsInd",0.0f,"CTF_Settings.ini"),false);
		}

		//Set information for later use
		if (Get_Int_Parameter("Team") == 0) {
			NodFlagHolder = Commands->Get_ID(sender);
			NodFlagAttached = Commands->Get_ID(AttachedFlag);
			CTF_Message(2,PlayerName(sender),"");
			NodFlagLoc = 2;
		}
		else if (Get_Int_Parameter("Team") == 1) {
			GDIFlagHolder = Commands->Get_ID(sender);
			GDIFlagAttached = Commands->Get_ID(AttachedFlag);
			CTF_Message(1,PlayerName(sender),"");
			GDIFlagLoc = 2;
		}
	}
	else if (message == CUSTOM_EVENT_POWERUP && Get_Int_Parameter("Team") == Commands->Get_Player_Type(sender)) {	//Friendly picked up the flag (Maybe capture, maybe idiot)
		if (Get_Int_Parameter("Team") == 0 && GDIFlagHolder == Commands->Get_ID(sender)) {		//If Nod captured GDI's Flag
			GDIFlagLoc = 1;
			//Destroy flag on person
			Commands->Destroy_Object(Commands->Find_Object(GDIFlagAttached));
			Commands->Attach_Script(sender,"KAK_Capture_Animation","");
			Commands->Send_Custom_Event(obj,sender,24156,0,0);

			if (SpoilsofWar == 1) {
				//Spoils of War for capturing flag
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","CapturePointsInd",0.0f,"CTF_Settings.ini"),false);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CapturePointsInd",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","CaptureCreditsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CaptureCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","CaptureCreditsInd",0.0f,"CTF_Settings.ini"),false);
			}
			
			//Recreate flag on ped, update information
			GDIFlagHolder = 0;
			GDIFlagAttached = 0;
			NodCaps++;

			if (NodCaps >= TotalCaptures && EnableCapLimit == 1) {	//If Nod reached the cap limit, end game
				CTF_Message(11,"","");
				AllowKillBuilding = true;
				char map[256], IDs[100];
				sprintf(IDs,"%d",MapID);
				getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");
				int BuildingAmount = getProfileInt(map,"GDIBuildings",0,"Data\\CTF.dat");
				int i = 1;
				while (i <= BuildingAmount) {
					char BuildingIDTxt[256];
					sprintf(BuildingIDTxt,"GDIBuilding%d",i);
					Commands->Apply_Damage(Commands->Find_Object(getProfileInt(map,BuildingIDTxt,0,"Data\\CTF.dat")),99999,"Explosive",false);
					i++;
				}
			}
			else {
				CTF_Message(9,PlayerName(sender),"");
				Create_CTF_PedFlag(0);
				Create_CTF_PedFlag(1);
			}
		}
		else if (Get_Int_Parameter("Team") == 1 && NodFlagHolder == Commands->Get_ID(sender)) {		//Else If Nod captured GDI's Flag
			NodFlagLoc = 1;
			//Destroy flag on person
			Commands->Destroy_Object(Commands->Find_Object(NodFlagAttached));
			Commands->Attach_Script(sender,"KAK_Capture_Animation","");
			Commands->Send_Custom_Event(obj,sender,24156,0,0);
			
			if (SpoilsofWar == 1) {
				//Spoils of War for capturing flag
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","CapturePointsInd",0.0f,"CTF_Settings.ini"),false);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CapturePointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CapturePointsInd",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","CaptureCreditsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","CaptureCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","CaptureCreditsInd",0.0f,"CTF_Settings.ini"),false);
			}
			
			//Recreate flag on Ped
			NodFlagHolder = 0;
			NodFlagAttached = 0;
			GDICaps++;

			if (GDICaps >= TotalCaptures  && EnableCapLimit == 1) {			//If GDI reached the cap limit, end game
				CTF_Message(12,"","");
				AllowKillBuilding = true;
				char map[256], IDs[100];
				sprintf(IDs,"%d",MapID);
				getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");
				int BuildingAmount = getProfileInt(map,"NodBuildings",0,"Data\\CTF.dat");
				int i = 1;
				while (i <= BuildingAmount) {
					char BuildingIDTxt[256];
					sprintf(BuildingIDTxt,"NodBuilding%d",i);
					Commands->Apply_Damage(Commands->Find_Object(getProfileInt(map,BuildingIDTxt,0,"Data\\CTF.dat")),99999,"Explosive",false);
					i++;
				}
			}
			else {
				CTF_Message(10,PlayerName(sender),"");
				Create_CTF_PedFlag(0);
				Create_CTF_PedFlag(1);
			}
		}
		else Create_CTF_PedFlag(Commands->Get_Player_Type(obj));
	}
}

/* ************************************************************************************************************* */

//Controls the flag that drops from the dead flag holder
void KAK_CTF_DropFlag::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == CUSTOM_EVENT_POWERUP && Get_Int_Parameter("Team") != Commands->Get_Player_Type(sender)) {		//Enemy picked up the friendly's fallen flag
		//Put flag on new holder
		GameObject *AttachedFlag = Commands->Create_Object_At_Bone(sender,FlagBackPreset,"bone for bag");
		Commands->Attach_To_Object_Bone(AttachedFlag, sender, "bone for bag");
		Commands->Disable_All_Collisions(AttachedFlag);
		Commands->Set_Player_Type(AttachedFlag,Get_Int_Parameter("Team"));
		
		if (WeaponForHolder == 0) {
			Commands->Give_Powerup(sender,"POW_Uplink",true);
			Commands->Attach_Script(sender,"KAK_Select_Flag","");
		}
		if (RegenForHolder == 1) {
			Commands->Attach_Script(sender,"KAK_FlagHolder_Regen","");
		}
		Commands->Attach_Script(sender,"KAK_FlagHolder_Appear","");

		if (SpoilsofWar == 1) {
			//Spoils of War for picking up fallen flag
			Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","PickupPointsTeam",0.0f,"CTF_Settings.ini"),true);
			Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","PickupPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","PickupPointsInd",0.0f,"CTF_Settings.ini"),false);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","PickupPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","PickupPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","PickupCreditsTeam",0.0f,"CTF_Settings.ini"),true);
			Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","PickupCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
			Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","PickupCreditsInd",0.0f,"CTF_Settings.ini"),false);
		}

		//Setup new information
		if (Get_Int_Parameter("Team") == 0) {
			Commands->Destroy_Object(Commands->Find_Object(NodFlagAttached));
			NodFlagHolder = Commands->Get_ID(sender);
			NodFlagAttached = Commands->Get_ID(AttachedFlag);
			CTF_Message(6,PlayerName(sender),"");
			NodFlagLoc = 2;
		}
		else if (Get_Int_Parameter("Team") == 1) {
			Commands->Destroy_Object(Commands->Find_Object(GDIFlagAttached));
			GDIFlagHolder = Commands->Get_ID(sender);
			GDIFlagAttached = Commands->Get_ID(AttachedFlag);
			CTF_Message(5,PlayerName(sender),"");
			GDIFlagLoc = 2;
		}
	}
	else if (message == CUSTOM_EVENT_POWERUP && Get_Int_Parameter("Team") == Commands->Get_Player_Type(sender)) {		//Friendly picked up the friendly's fallen flag
		if (Get_Int_Parameter("Team") == 0) {		//If Player is on Nod
			//Reput flag on Nod Ped
			Create_CTF_PedFlag(0);
			Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("FlagID")));

			if (SpoilsofWar == 1) {
				//Spoils of War for returning flag
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","ReturnPointsInd",0.0f,"CTF_Settings.ini"),false);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","ReturnCreditsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","ReturnCreditsInd",0.0f,"CTF_Settings.ini"),false);
			}

			CTF_Message(8,PlayerName(sender),"");
			NodFlagLoc = 1;
		}
		else if (Get_Int_Parameter("Team") == 1) {	//Else if Player is on GDI
			//Reput flag on GDI Ped
			Create_CTF_PedFlag(1);
			Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("FlagID")));

			if (SpoilsofWar == 1) {
				//Spoils of War for returning flag
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Points(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Points(sender,getProfileFloat("SpoilsOfWar","ReturnPointsInd",0.0f,"CTF_Settings.ini"),false);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","ReturnCreditsTeam",0.0f,"CTF_Settings.ini"),true);
				Commands->Give_Money(sender,(getProfileFloat("SpoilsOfWar","ReturnCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
				Commands->Give_Money(sender,getProfileFloat("SpoilsOfWar","ReturnCreditsInd",0.0f,"CTF_Settings.ini"),false);
			}

			CTF_Message(7,PlayerName(sender),"");
			GDIFlagLoc = 1;
		}
	}
}

void KAK_CTF_DropFlag::Created(GameObject *obj) {
	if (getProfileFloat("Settings","ReturnDropFlagTimer",0.0f,"CTF_Settings.ini") > 0.0f) Commands->Start_Timer(obj,this,getProfileFloat("Settings","ReturnDropFlagTimer",0.0f,"CTF_Settings.ini"),1);
}

void KAK_CTF_DropFlag::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		if (Get_Int_Parameter("Team") == 0) {
			Create_CTF_PedFlag(0);
			Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("FlagID")));
			CTF_Message(8,"the Server","");
			NodFlagLoc = 1;
		}
		else if (Get_Int_Parameter("Team") == 1) {
			Create_CTF_PedFlag(1);
			Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("FlagID")));
			CTF_Message(7,"the Server","");
			GDIFlagLoc = 1;
		}
	}
}

/* ************************************************************************************************************* */

//Map Load Crud
void RecognizeMap(int ID,bool IsLoad) {
	char IDKey[20], MapName[30];
	sprintf(IDKey,"%d",ID);
	getProfileString("Map",IDKey,"NULL",MapName,30,"Data\\CTF.dat");
	if (IDDebug == 1) {
		char DebugMsg[100];
		sprintf(DebugMsg,"MapID_Debug: %d would work to identify this map in the CTF.dat file.",ID);
		FDSMessage(DebugMsg);
	}
	if (strcmp(MapName,"NULL") != 0) {
		if (IsLoad == true) {
			AllowKillBuilding = false;
			MapID = ID;

			char map[256], IDs[256];
			sprintf(IDs,"%d",MapID);
			getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");
			if (EnableCapLimit == 1) TotalCaptures = getProfileInt("CapLimit",map,5,"CTF_Settings.ini");

			Create_CTF_Pedestal(0,MapID);
			Create_CTF_Pedestal(1,MapID);
			GDIFlagLoc = 1;
			NodFlagLoc = 1;
			Commands->Attach_Script(Commands->Find_Object(ID),"KAK_Flag_Icon","0");
			Commands->Attach_Script(Commands->Find_Object(ID),"KAK_Flag_Icon","1");

			rename("data\\objects.ddb","data\\bjects.ddb");
			strcpy(CurrMap,MapName);

			int PSet_SvsT = SvSKillMsgTotal;
			SvSKillMsgTotal = 0;
			for (int a = 1; a <= getProfileInt("SvSKillMsg","Total",0,"CTF_Settings.ini"); a++) {
				char key[5],value[256];
				sprintf(key,"Str%d",a);
				getProfileString("SvSKillMsg",key,"Error_BadKillMsg",value,256,"CTF_Settings.ini");
				SvSKillMsg.push_back(value);
				SvSKillMsgTotal++;
			}

			if (FirstGame) {
				FirstGame = false;
				FDSMessage("First map loaded, auto gameovering now..");
				ConsoleCommand("gameover");
			}
			else {
				if (ShowAnnouncement == true) {
					ShowAnnouncement = false;
					if (EnableCTF == 1) {
						char mapname[100];
						sprintf(mapname,"-> Map \"%s\" detected, loading settings..",MapName);
						FDSMessage(mapname);
						printf("Running in CTF Mode.\n");
						if (WeaponForHolder == 1) printf("Flag holder may use a weapon.\n");
						else if (WeaponForHolder == 0) printf("Flag holder may NOT use a weapon.\n");
						if (getProfileFloat("Settings","RegenAmount",2.0f,"CTF_Settings.ini") > 0.0f && getProfileFloat("Settings","RegenAmount",2.0f,"CTF_Settings.ini") <= 5.0f) RegenAmount = getProfileFloat("Settings","RegenAmount",2.0f,"CTF_Settings.ini");
						else RegenAmount = 2.0f;
						if (RegenForHolder == 1) printf("Flag holder will have %f health regenerated every second.\n",RegenAmount);
						else if (RegenForHolder == 0) printf("Flag holder will not have health regenerated.\n");
						if (DropWeapons == 1) printf("Weapons will drop from fallen soldiers.\n");
						else if (DropWeapons == 0) printf("The greedy dead people will keep their guns.\n");
						if (SpoilsofWar == 1) printf("Spoils of War are turned on.\n");
						else if (SpoilsofWar == 0) printf("Spoils of War are turned off.\n");
						if (EnableCapLimit == 1) printf("Following Cap Limit rules.  This round's limit is %d.\n",TotalCaptures);
						else if (EnableCapLimit == 0) printf("Unlimited captures allowed.\n");

						GameObject *AnnouncementThing = Commands->Create_Object("Invisible_Object",Commands->Get_Position(Commands->Find_Object(ID)));
						Commands->Attach_Script(AnnouncementThing,"KAK_Limit_Announcement","");
					}
				}
			}
			Vector3 loc; loc.X = 0.0f; loc.Y = 0.0f; loc.Z = 0.0f;

			if (HaveWeather == 1) {
				char params[20];
				sprintf(params,"%d",ID);
				GameObject *temp = Commands->Create_Object("Invisible_Object",loc);
				Commands->Attach_Script(temp,"KAK_Random_Weather",params);
			}
		}
		else {
			rename("data\\bjects.ddb","data\\objects.ddb");
			SvSKillMsg.erase(SvSKillMsg.begin(),SvSKillMsg.end());
			GDIFlagHolder = 0;
			NodFlagHolder = 0;
			GDIFlagAttached = 0;
			NodFlagAttached = 0;
			MapID = 0;
			GDICaps = 0;
			NodCaps = 0;
			AllowKillBuilding = false;

			ShowAnnouncement = true;
			EnableCTF = getProfileInt("Settings","EnableCTFMode",1,"CTF_Settings.ini");
			WeaponForHolder= getProfileInt("Settings","AllowWeaponForHolder",0,"CTF_Settings.ini");
			DropWeapons = getProfileInt("Settings","AllowDropWeapons",1,"CTF_Settings.ini");
			SpoilsofWar = getProfileInt("Settings","AllowSpoilsofWar",1,"CTF_Settings.ini");
			EnableCapLimit = getProfileInt("Settings","AllowCapLimit",1,"CTF_Settings.ini");
			RegenForHolder = getProfileInt("Settings","AllowRegenForHolder",0,"CTF_Settings.ini");
			getProfileString("Settings","FlagPresetName","POW_Data_Disc",FlagPreset,100,"CTF_Settings.ini");
			getProfileString("Settings","GDIPedPresetName","CtfPedestalGold",GDIPedPreset,100,"CTF_Settings.ini");
			getProfileString("Settings","NodPedPresetName","CtfPedestalRed",NodPedPreset,100,"CTF_Settings.ini");
			getProfileString("Settings","FlagBackPresetName","CtfFlag",FlagBackPreset,100,"CTF_Settings.ini");
			ShowPlayerKillMessage = getProfileInt("Settings","ShowKillMessages",1,"CTF_Settings.ini");
			IDDebug = getProfileInt("Settings","DebugIDMode",1,"CTF_Settings.ini");
			HaveWeather = getProfileInt("Settings","EnableWeather",1,"CTF_Settings.ini");
			//Perform Cleanup Code Here
		}
	}
}

/* ************************************************************************************************************* */

//Loop fake gun so Player with Flag can not pull out weapon
void KAK_Select_Flag::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,0.1f,1);
}

void KAK_Select_Flag::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		Commands->Select_Weapon(obj,"Weapon_MineTimed_Player");
		Commands->Start_Timer(obj,this,0.1f,1);
	}
}

void KAK_Select_Flag::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 24156) {
		Destroy_Script();
	}
}

/* ************************************************************************************************************* */

//Loop regen health for flag holder
void KAK_FlagHolder_Regen::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,1.0f,1);
	IsAlive = true;
}

void KAK_FlagHolder_Regen::Timer_Expired(GameObject *obj, int number) {
	if (number == 1 && IsAlive) {
		if (Commands->Get_Health(obj) == Commands->Get_Max_Health(obj)) {
			if (Commands->Get_Shield_Strength(obj) != Commands->Get_Max_Shield_Strength(obj)) {
				if (IsAlive) Commands->Set_Shield_Strength(obj,(Commands->Get_Shield_Strength(obj) + RegenAmount));
			}
		}
		else {
			if (IsAlive) Commands->Set_Health(obj,(Commands->Get_Health(obj) + RegenAmount));
		}
		Commands->Start_Timer(obj,this,1.0f,1);
	}
}

void KAK_FlagHolder_Regen::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (Commands->Get_Health(obj) == 0 && Commands->Get_Shield_Strength(obj) == 0) IsAlive = false;
}

void KAK_FlagHolder_Regen::Killed(GameObject *obj, GameObject *shooter) {
	IsAlive = false;
}

void KAK_FlagHolder_Regen::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 24156) {
		Destroy_Script();
	}
}

/* ************************************************************************************************************* */

//Loop to make flag holder appear (SBH Fix)
void KAK_FlagHolder_Appear::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,0.01f,1);
}

void KAK_FlagHolder_Appear::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		Commands->Apply_Damage(obj,0,"Harmless",false);
		Commands->Start_Timer(obj,this,0.01f,1);
	}
}

void KAK_FlagHolder_Appear::Killed(GameObject *obj, GameObject *shooter) {
	Destroy_Script();
}

void KAK_FlagHolder_Appear::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 24156) {
		Destroy_Script();
	}
}

/* ************************************************************************************************************* */

void KAK_Limit_Announcement::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,30.0f,1);
}

void KAK_Limit_Announcement::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		char msgline[256];
		ConsoleCommand("msg Running in CTF mode, created by Vloktboky and the people at Black-Cell.net.");
		if (EnableCapLimit == 1) {
			sprintf(msgline,"msg This round's capture limit is %d.",TotalCaptures);
			ConsoleCommand(msgline);
			Commands->Start_Timer(obj,this,180.0f,2);
		}
	}
	else if (number == 2) {
		char msgline[256];
		sprintf(msgline,"msg GDI needs to capture Nod's flag %d more time(s) to win.  Nod needs to capture GDI's flag %d more time(s) to win.",(TotalCaptures - GDICaps),(TotalCaptures - NodCaps));
		ConsoleCommand(msgline);
		Commands->Start_Timer(obj,this,180.0f,2);
	}
}

/* ************************************************************************************************************* */

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Created(GameObject *obj) {
	if (EnableCTF == 1) {
		if (ShowStartMessage == false) {
			ShowStartMessage = true;
		}

		RecognizeMap(Commands->Get_ID(obj),true);
		
		/*if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks")) {
			rename("Data\\objects.ddb","Data\\bjects.ddb");
			AllowKillBuilding = false;
			MapID = Commands->Get_ID(obj);

			char map[256], IDs[256];
			sprintf(IDs,"%d",MapID);
			getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");
			if (EnableCapLimit == 1) TotalCaptures = getProfileInt("CapLimit",map,5,"CTF_Settings.ini");

			Create_CTF_Pedestal(0,MapID);
			Create_CTF_Pedestal(1,MapID);
			GDIFlagLoc = 1;
			NodFlagLoc = 1;
			Commands->Attach_Script(obj,"KAK_Flag_Icon","0");
			Commands->Attach_Script(obj,"KAK_Flag_Icon","1");

			if (FirstGame == true) {
				FirstGame = false;
				ConsoleCommand("gameover");
			}
			else if (ShowAnnouncement == true) {
				ShowAnnouncement = false;
				if (EnableCTF == 1) {
					printf("Running in CTF Mode.\n");
					if (WeaponForHolder == 1) printf("Flag holder may use a weapon.\n");
					else if (WeaponForHolder == 0) printf("Flag holder may NOT use a weapon.\n");
					if (getProfileFloat("Settings","RegenAmount",2.0f,"CTF_Settings.ini") > 0.0f && getProfileFloat("Settings","RegenAmount",2.0f,"CTF_Settings.ini") <= 5.0f) RegenAmount = getProfileFloat("Settings","RegenAmount",2.0f,"CTF_Settings.ini");
					else RegenAmount = 2.0f;
					if (RegenForHolder == 1) printf("Flag holder will have %f health regenerated every second.\n",RegenAmount);
					else if (RegenForHolder == 0) printf("Flag holder will not have health regenerated.\n");
					if (DropWeapons == 1) printf("Weapons will drop from fallen soldiers.\n");
					else if (DropWeapons == 0) printf("The greedy dead people will keep their guns.\n");
					if (SpoilsofWar == 1) printf("Spoils of War are turned on.\n");
					else if (SpoilsofWar == 0) printf("Spoils of War are turned off.\n");
					if (EnableCapLimit == 1) printf("Following Cap Limit rules.  This round's limit is %d.\n",TotalCaptures);
					else if (EnableCapLimit == 0) printf("Unlimited captures allowed.\n");

					GameObject *AnnouncementThing = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
					Commands->Attach_Script(AnnouncementThing,"KAK_Limit_Announcement","");
				}
			}
		}*/
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (EnableCTF == 1 && AllowKillBuilding == false) {
		if (Commands->Get_Player_Type(damager) == 1 && strstr(Commands->Get_Preset_Name(obj),"GDI")) {
			Commands->Give_Points(damager,damage,false);
			Commands->Give_Money(damager,(damage * (float)-1),false);
		}
		else if (Commands->Get_Player_Type(damager) == 1 && !strstr(Commands->Get_Preset_Name(obj),"GDI")) {
			Commands->Give_Points(damager,(damage * (float)-1),false);
			Commands->Give_Money(damager,(damage * (float)-1),false);
		}
		else if (Commands->Get_Player_Type(damager) == 0 && strstr(Commands->Get_Preset_Name(obj),"Nod")) {
			Commands->Give_Points(damager,damage,false);
			Commands->Give_Money(damager,(damage * (float)-1),false);
		}
		else if (Commands->Get_Player_Type(damager) == 0 && !strstr(Commands->Get_Preset_Name(obj),"Nod")) {
			Commands->Give_Points(damager,(damage * (float)-1),false);
			Commands->Give_Money(damager,(damage * (float)-1),false);
		}


		if (damage >= 500) {
			if (Commands->Get_Player_Type(damager) == 1 && strstr(Commands->Get_Preset_Name(obj),"GDI")) {
				Commands->Give_Points(damager,(float)250,false);
				Commands->Give_Money(damager,(float)-250,false);
			}
			else if (Commands->Get_Player_Type(damager) == 1 && !strstr(Commands->Get_Preset_Name(obj),"GDI")) {
				Commands->Give_Points(damager,(float)-250,false);
				Commands->Give_Money(damager,(float)-250,false);
			}
			else if (Commands->Get_Player_Type(damager) == 0 && strstr(Commands->Get_Preset_Name(obj),"Nod")) {
				Commands->Give_Points(damager,(float)250,false);
				Commands->Give_Money(damager,(float)-250,false);
			}
			else if (Commands->Get_Player_Type(damager) == 0 && !strstr(Commands->Get_Preset_Name(obj),"Nod")) {
				Commands->Give_Points(damager,(float)-250,false);
				Commands->Give_Money(damager,(float)-250,false);
			}
		}

		Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Destroyed(GameObject *obj) {
	if (EnableCTF == 1) {
		RecognizeMap(Commands->Get_ID(obj),false);

		/*if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks")) {
			rename("Data\\bjects.ddb","Data\\objects.ddb");
			GDIFlagHolder = 0;
			NodFlagHolder = 0;
			GDIFlagAttached = 0;
			NodFlagAttached = 0;
			MapID = 0;
			GDICaps = 0;
			NodCaps = 0;
			AllowKillBuilding = false;

			ShowAnnouncement = true;
			EnableCTF = getProfileInt("Settings","EnableCTFMode",1,"CTF_Settings.ini");
			WeaponForHolder= getProfileInt("Settings","AllowWeaponForHolder",0,"CTF_Settings.ini");
			DropWeapons = getProfileInt("Settings","AllowDropWeapons",1,"CTF_Settings.ini");
			SpoilsofWar = getProfileInt("Settings","AllowSpoilsofWar",1,"CTF_Settings.ini");
			EnableCapLimit = getProfileInt("Settings","AllowCapLimit",1,"CTF_Settings.ini");
			RegenForHolder = getProfileInt("Settings","AllowRegenForHolder",0,"CTF_Settings.ini");
			getProfileString("Settings","FlagPresetName","POW_Data_Disc",FlagPreset,100,"CTF_Settings.ini");
			getProfileString("Settings","GDIPedPresetName","CtfPedestalGold",GDIPedPreset,100,"CTF_Settings.ini");
			getProfileString("Settings","NodPedPresetName","CtfPedestalRed",NodPedPreset,100,"CTF_Settings.ini");
			getProfileString("Settings","FlagBackPresetName","CtfFlag",FlagBackPreset,100,"CTF_Settings.ini");
		}*/
	}
}

/* ************************************************************************************************************* */

void M00_Disable_Transition::Created(GameObject *obj) {
	if (EnableCTF == 1) {
		if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester")) { }
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester")) { }
		else Commands->Destroy_Object(obj);
	}
}

void M00_Disable_Transition::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (EnableCTF == 1) {
		if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester") || strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester")) {
			Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
			Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj));
		}
	}
}

/* ************************************************************************************************************* */

void M00_GrantPowerup_Created::Created(GameObject *obj) {
	if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
		if (EnableCTF == 1) {
			Commands->Set_Is_Visible(obj,false);
			Dropper = "the Server";

			IsDestroyed = false;

			if (GDIFlagHolder == Commands->Get_ID(obj) || NodFlagHolder == Commands->Get_ID(obj)) {
				if (WeaponForHolder == 0) {
					Commands->Give_Powerup(obj,"POW_Uplink",true);
					Commands->Attach_Script(obj,"KAK_Select_Flag","");
				}
				if (RegenForHolder == 1) {
					Commands->Attach_Script(obj,"KAK_FlagHolder_Regen","");
				}
				Commands->Attach_Script(obj,"KAK_FlagHolder_Appear","");
			}
		}
		IsAlive = true;
		Commands->Create_Sound("SFX.Spawn",Commands->Get_Position(obj),0);
	}
	Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
}

void M00_GrantPowerup_Created::Timer_Expired(GameObject *obj, int number) {
	if (EnableCTF == 1) {
		if (number == 5) {
			//Commands->Give_Money(obj,1,false);
			Commands->Start_Timer(obj,this,1,5);
		}
	}
}

void M00_GrantPowerup_Created::Destroyed(GameObject *obj) {
	if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
		if (EnableCTF == 1) {
			if (IsDestroyed == false) {
				IsDestroyed = true;
				Vector3 DeathPlace = Commands->Get_Position(obj);

				if (Commands->Get_Player_Type(obj) == 0 && Commands->Get_ID(obj) == GDIFlagHolder) {
					if (Commands->Find_Object(GDIFlagAttached) != 0) Commands->Destroy_Object(Commands->Find_Object(GDIFlagAttached));
					Create_CTF_DropFlag(1,DeathPlace);
					CTF_Message(3,PlayerName(obj),Dropper.c_str());
					GDIFlagLoc = 3;
				}
				else if (Commands->Get_Player_Type(obj) == 1 && Commands->Get_ID(obj) == NodFlagHolder) {
					if (Commands->Find_Object(NodFlagAttached) != 0) Commands->Destroy_Object(Commands->Find_Object(NodFlagAttached));
					Create_CTF_DropFlag(0,DeathPlace);
					CTF_Message(4,PlayerName(obj),Dropper.c_str());
					NodFlagLoc = 3;
				}
			}

			/*if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
				char IDFile[100];
				sprintf(IDFile,"del PL\\PL%d",Commands->Get_ID(obj));
				system(IDFile);
			}*/
		}
	}
}

void M00_GrantPowerup_Created::Killed(GameObject *obj, GameObject *shooter) {
	if (IsAlive && strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
		IsAlive = false;
		if (EnableCTF == 1) {
			if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
				if (DropWeapons == 1) {
					Vector3 DeathPlace = Commands->Get_Position(obj);
					GameObject *BackpackObject = Commands->Create_Object("Invisible_Object",DeathPlace);
					Commands->Attach_Script(BackpackObject,"KAK_Backpack_Object",Commands->Get_Preset_Name(obj));
				}

				if (Commands->Get_Player_Type(obj) == 0 && Commands->Get_ID(obj) == GDIFlagHolder) {
					if (SpoilsofWar == 1) {
						//Spoils of War for killing holder
						Commands->Give_Points(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini"),true);
						Commands->Give_Points(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
						Commands->Give_Points(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderPointsInd",0.0f,"CTF_Settings.ini"),false);
						Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
						Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
						Commands->Give_Money(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsTeam",0.0f,"CTF_Settings.ini"),true);
						Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
						Commands->Give_Money(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsInd",0.0f,"CTF_Settings.ini"),false);
					}
					if (Commands->Get_ID(shooter) == 0) Dropper = "the Server";
					else Dropper = PlayerName(shooter);
				}
				else if (Commands->Get_Player_Type(obj) == 1 && Commands->Get_ID(obj) == NodFlagHolder) {
					if (SpoilsofWar == 1) {
						Commands->Give_Points(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini"),true);
						Commands->Give_Points(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini") * -1),false);
						Commands->Give_Points(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderPointsInd",0.0f,"CTF_Settings.ini"),false);
						Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsTeam",0.0f,"CTF_Settings.ini") * -1),true);
						Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderPointsInd",0.0f,"CTF_Settings.ini") * -1),false);
						Commands->Give_Money(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsTeam",0.0f,"CTF_Settings.ini"),true);
						Commands->Give_Money(shooter,(getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsTeam",0.0f,"CTF_Settings.ini") * -1),false);
						Commands->Give_Money(shooter,getProfileFloat("SpoilsOfWar","KillFlagHolderCreditsInd",0.0f,"CTF_Settings.ini"),false);
					}
					if (Commands->Get_ID(shooter) == 0) Dropper = "the Server";
					else Dropper = PlayerName(shooter);
				}
			}
		}

		std::string SoundName = "Death_01";
		if (IsFemale(obj)) {
			int DS = Commands->Get_Random_Int(1,3);
			if (DS == 1) SoundName = "SFX.Female_Scream_01";
			else if (DS == 2) SoundName = "SFX.Female_Scream_02";
		}
		else {
			int DS = Commands->Get_Random_Int(1,15);
			if (DS == 1) SoundName = "Death_01";
			else if (DS == 2) SoundName = "Death_02";
			else if (DS == 3) SoundName = "Death_03";
			else if (DS == 4) SoundName = "Death_04";
			else if (DS == 5) SoundName = "Death_05";
			else if (DS == 6) SoundName = "Death_06";
			else if (DS == 7) SoundName = "Death_07";
			else if (DS == 8) SoundName = "Death_08";
			else if (DS == 9) SoundName = "Death_09";
			else if (DS == 10) SoundName = "Death_10";
			else if (DS == 11) SoundName = "Death_11";
			else if (DS == 12) SoundName = "Death_12";
			else if (DS == 13) SoundName = "Death_13";
			else if (DS == 14) SoundName = "Death_15";
			else if (DS == 15) SoundName = "Death_16";
		}
		Commands->Create_Sound(SoundName.c_str(),Commands->Get_Position(obj),0);

		if (ShowPlayerKillMessage == 1) {
			if (Commands->Get_ID(shooter) == 0) {
				std::string killer(PlayerName(obj)),
							killerpreset(Translate_Preset(IsPlayerVehicle(obj)));
				char KillMsg[512];
				sprintf(KillMsg,"%s was killed (%s)",killer.c_str(),killerpreset.c_str());
				FDSMessage(KillMsg);
			}
			else if (Commands->Get_ID(obj) == Commands->Get_ID(shooter)) {
				std::string killer(PlayerName(obj)),
							killerpreset(Translate_Preset(IsPlayerVehicle(obj)));
				char KillMsg[512];
				sprintf(KillMsg,"%s killed himself (%s)",killer.c_str(),killerpreset.c_str());
				FDSMessage(KillMsg);
			}
			else {
				std::string killer(PlayerName(shooter)),
							killed(PlayerName(obj)),
							killerpreset(Translate_Preset(IsPlayerVehicle(shooter))),
							killedpreset(Translate_Preset(IsPlayerVehicle(obj)));
				if (strcmp(killer.c_str(),"ERROR_NotPlayer") == 0) {
					char KillMsg[512];
					sprintf(KillMsg,"The %s killed %s (%s)",Translate_Preset(shooter),killed.c_str(),killedpreset.c_str());
					FDSMessage(KillMsg);
				}
				else {
					std::string KillMsg(SvSKillMsg[Commands->Get_Random_Int(0,SvSKillMsgTotal)]);
					int n;
					while((n = KillMsg.find("<killer>")) != std::string::npos) KillMsg.replace(n,8,killer);
					while((n = KillMsg.find("<killed>")) != std::string::npos) KillMsg.replace(n,8,killed);
					while((n = KillMsg.find("<killerpreset>")) != std::string::npos) KillMsg.replace(n,14,killerpreset);
					while((n = KillMsg.find("<killedpreset>")) != std::string::npos) KillMsg.replace(n,14,killedpreset);
					FDSMessage(KillMsg.c_str());
				}
			}
		}
	}
}

void M00_GrantPowerup_Created::Register_Auto_Save_Variables() {
	if (EnableCTF == 1) Auto_Save_Variable(1,1,&IsDestroyed);
}

/* ************************************************************************************************************* */

void KAK_Backpack_Object::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,5,1);
}

void KAK_Backpack_Object::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		DeathPlace = Commands->Get_Position(obj);
		//Commands->Create_Sound("SFX.Weapon_Spawn",DeathPlace,0); - Old Weapon Drop Sound

		int RandomNum = Commands->Get_Random_Int(1,4);

		if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player_Nod",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_ChemSprayer_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_0")) {
			BackpackScript = Commands->Create_Object("POW_Flamethrower_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Grenadier_0")) {
			BackpackScript = Commands->Create_Object("POW_GrenadeLauncher_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserChaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Technician_0")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney_PowerSuit")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_PersonalIonCannon_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_Railgun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("CnC_POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_TiberiumAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Grenadier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_TiberiumFlechetteGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Ignatio_Mobius")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_VoltAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("CnC_POW_VoltAutoRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			}
		}

		else {
			BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
		}

		Commands->Send_Custom_Event(obj,BackpackScript,6000,Commands->Get_ID(obj),0);
	}
}

/* ************************************************************************************************************* */

void KAK_Flag_Icon::Created(GameObject *obj) {
	if (FirstGame == false) {
		char map[512], IDs[200];
		sprintf(IDs,"%d",MapID);
		getProfileString("Map",IDs,"NULL",map,256,"Data\\CTF.dat");
		int Team = Get_Int_Parameter("Team");
		Vector3 PedPosition;
		if (Team == 0) {
			PedPosition.X = getProfileFloat(map,"NodFlag_X",500.000,"Data\\CTF.dat");
			PedPosition.Y = getProfileFloat(map,"NodFlag_Y",500.000,"Data\\CTF.dat");
			PedPosition.Z = getProfileFloat(map,"NodFlag_Z",-500.000,"Data\\CTF.dat");
		}
		else if (Team == 1) {
			PedPosition.X = getProfileFloat(map,"GDIFlag_X",500.000,"Data\\CTF.dat");
			PedPosition.Y = getProfileFloat(map,"GDIFlag_Y",500.000,"Data\\CTF.dat");
			PedPosition.Z = getProfileFloat(map,"GDIFlag_Z",-500.000,"Data\\CTF.dat");
		}
		IconPos = PedPosition;
		IconPos.X -= getProfileFloat("Flag","Flag_X",500.000,"Data\\CTF.dat");
		IconPos.Y -= getProfileFloat("Flag","Flag_Y",500.000,"Data\\CTF.dat");
		IconPos.Z -= getProfileFloat("Flag","Flag_Z",-500.000,"Data\\CTF.dat");
		IconPos.Z += 1.25f;
		Icon = Commands->Create_Object("Invisible_Object",IconPos);
		Commands->Start_Timer(obj,this,0.1f,Get_Int_Parameter("Team"));
	}
}

void KAK_Flag_Icon::Timer_Expired(GameObject *obj, int number) {
	if (number == 0) {
		if (NodFlagLoc == 1 && LastLoc != 1) {
			if (Icon != 0) Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("Artillery_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_CHEVRON.O_EM_CHEVRON",true,0,0.0f,-1.0f,false);
			LastLoc = 1;
		}
		else if (NodFlagLoc == 2 && LastLoc != 2) {
			if (Icon != 0) Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("Stealth_Tank_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_REDARR.O_EM_REDARR",true,0,0.0f,-1.0f,false);
			LastLoc = 2;
		}
		else if (NodFlagLoc == 3 && LastLoc != 3) {
			if (Icon != 0) Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("M06_Servant_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_GRNARR.O_EM_GRNARR",true,0,0.0f,-1.0f,false);
			LastLoc = 3;
		}
		Commands->Start_Timer(obj,this,0.1f,0);
	}
	else if (number == 1) {
		if (GDIFlagLoc == 1 && LastLoc != 1) {
			Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("Artillery_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_CHEVRON.O_EM_CHEVRON",true,0,0.0f,-1.0f,false);
			LastLoc = 1;
		}
		else if (GDIFlagLoc == 2 && LastLoc != 2) {
			Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("Stealth_Tank_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_REDARR.O_EM_REDARR",true,0,0.0f,-1.0f,false);
			LastLoc = 2;
		}
		else if (GDIFlagLoc == 3 && LastLoc != 3) {
			Commands->Destroy_Object(Icon);
			Icon = Commands->Create_Object("M06_Servant_Loc",IconPos);
			Commands->Set_Animation(Icon,"O_EM_GRNARR.O_EM_GRNARR",true,0,0.0f,-1.0f,false);
			LastLoc = 3;
		}
		Commands->Start_Timer(obj,this,0.1f,1);
	}
}

/* ************************************************************************************************************* */

void KAK_Capture_Animation::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,1.0f,1);
}

void KAK_Capture_Animation::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		int Animation2Play = Commands->Get_Random_Int(1,13);
		if (Animation2Play == 1) Commands->Set_Animation(obj,"H_A_SIDEKICK",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 2) Commands->Set_Animation(obj,"H_A_PUNCHCOMBO",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 3) Commands->Set_Animation(obj,"H_A_A0A0_L02",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 4) Commands->Set_Animation(obj,"H_A_J22C",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 5) Commands->Set_Animation(obj,"H_A_A0A0_L23",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 6) Commands->Set_Animation(obj,"H_A_A0A0_L58",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 7) Commands->Set_Animation(obj,"H_A_B0A0_L05",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 8) Commands->Set_Animation(obj,"H_A_A0A0_L12",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 9) Commands->Set_Animation(obj,"H_A_J14C",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 10) Commands->Set_Animation(obj,"H_A_X33C",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 11) Commands->Set_Animation(obj,"H_A_A0A0_L22",false,0,0.0f,-1.0f,false);
		else if (Animation2Play == 12) Commands->Set_Animation(obj,"H_A_A0A0_L24",false,0,0.0f,-1.0f,false);
	}
}

void KAK_Capture_Animation::Animation_Complete(GameObject *obj, const char *anim) {
	Destroy_Script();
}

/* ************************************************************************************************************* */

void KAK_Random_Weather::Created(GameObject *obj) {
	getProfileString("WeatherType",CurrMap,"Rain",WeatherType,256,"CTF_Settings.ini");

	Range = Commands->Get_Random(0,1);
	CurrentClouds = Commands->Get_Random(0,1);
	Commands->Set_Clouds(CurrentClouds,CurrentClouds,true);
	Commands->Start_Timer(obj,this,0.5f,0);
	CurrentWind = 0.0f;
}

void KAK_Random_Weather::Timer_Expired(GameObject *obj, int number) {
	if (number == 0) {
		if (CurrentClouds < Range) {
			if ((CurrentClouds + 0.001f) >= Range) CurrentClouds = Range;
			else CurrentClouds += 0.001f;
		}
		else if (CurrentClouds > Range) {
			if ((CurrentClouds - 0.001f) <= Range) CurrentClouds = Range;
			else CurrentClouds -= 0.001f;
		}

		//Start Making Weather
		Commands->Set_Clouds(CurrentClouds,CurrentClouds,true);

		CurrentWind = 10 * CurrentClouds;
		Commands->Set_Wind(0.0f,CurrentWind,1.0f,true);

		FogEnd = ((-350 * CurrentClouds) + 500);
		Commands->Set_Fog_Enable(true);
		Commands->Set_Fog_Range(5.0f,FogEnd,1.0f);

		if (strstr(MapName,"C&C_Under.mix") || strstr(MapName,"C&C_Conquest_Winter.mix")) {
			if (CurrentClouds >= 0.625f) {
				CurrentSnow = (((8 * CurrentClouds) - 5) / 3);
				Commands->Set_Snow(CurrentSnow,CurrentSnow,true);
			}
			else Commands->Set_Snow(0.0f,0.0f,true);
		}
		else if (strstr(MapName,"C&C_Volcano.mix")) {
			if (CurrentClouds >= 0.625f) {
				CurrentAsh = (((8 * CurrentClouds) - 5) / 3);
				Commands->Set_Ash(CurrentAsh,CurrentAsh,true);
			}
			else Commands->Set_Ash(0.0f,0.0f,true);
		}
		else {
			if (CurrentClouds >= 0.625f) {
				CurrentRain = ((1.875 * CurrentClouds) - 0.125);
				Commands->Set_Rain(CurrentRain,CurrentRain,true);
			}
			else Commands->Set_Rain(0.0f,0.0f,true);

			if (CurrentClouds >= 0.875f) {
				CurrentLightning = (8 * (CurrentClouds + 0.125f)) - 8;
				Commands->Set_Lightning(CurrentLightning,0.0f,1.0f,0.0f,1.0f,true);
			}
			else Commands->Set_Lightning(0.0f,0.0f,1.0f,0.0f,1.0f,true);
		}
		//Stop Making Weather

		if (CurrentClouds == Range) {
			Range = Commands->Get_Random(0,1);
			Commands->Start_Timer(obj,this,0.5f,0);
		}
		else Commands->Start_Timer(obj,this,0.5f,0);
	}
}

/* ************************************************************************************************************* */

void KAK_Prevent_Kill::Damaged(GameObject *obj, GameObject *damager, float damage) {
	Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
	Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj));
}

/* ************************************************************************************************************* */

void M00_PCT_Pokable_DAK::Damaged(GameObject *obj, GameObject *damager, float damage) {
	Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
	Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj));
}

void M00_PCT_Pokable_DAK::Killed(GameObject *obj, GameObject *shooter) {
	//Just in case..
	Commands->Create_Object(Commands->Get_Preset_Name(obj),Commands->Get_Position(obj));
}

void M00_PCT_Pokable_DAK::Poked(GameObject *obj, GameObject *poker) {
	if (strstr(Commands->Get_Preset_Name(obj),"gdi")) Commands->Display_GDI_Player_Terminal();
	else if (strstr(Commands->Get_Preset_Name(obj),"nod")) Commands->Display_NOD_Player_Terminal();
}

/* ************************************************************************************************************* */

ScriptRegistrant<M00_BUILDING_EXPLODE_NO_DAMAGE_DAK> M00_BUILDING_EXPLODE_NO_DAMAGE_DAK_Registrant("M00_BUILDING_EXPLODE_NO_DAMAGE_DAK","");
ScriptRegistrant<M00_Disable_Transition> M00_Disable_Transition_Registrant("M00_Disable_Transition","");
ScriptRegistrant<M00_GrantPowerup_Created> M00_GrantPowerup_Created_Registrant("M00_GrantPowerup_Created","WeaponDef:string");
ScriptRegistrant<KAK_Backpack_Object> KAK_Backpack_Object_Registrant("KAK_Backpack_Object","CharacterType:string");
ScriptRegistrant<KAK_CTF_Flag> KAK_CTF_Flag_Registrant("KAK_CTF_Flag","Team:int,FlagID:int");
ScriptRegistrant<KAK_CTF_DropFlag> KAK_CTF_DropFlag_Registrant("KAK_CTF_DropFlag","Team:int,FlagID:int");
ScriptRegistrant<KAK_Select_Flag> KAK_Select_Flag_Registrant("KAK_Select_Flag","");
ScriptRegistrant<KAK_Limit_Announcement> KAK_Limit_Announcement_Registrant("KAK_Limit_Announcement","");
ScriptRegistrant<KAK_FlagHolder_Regen> KAK_FlagHolder_Regen_Registrant("KAK_FlagHolder_Regen","");
ScriptRegistrant<KAK_FlagHolder_Appear> KAK_FlagHolder_Appear_Registrant("KAK_FlagHolder_Appear","");
ScriptRegistrant<KAK_Capture_Animation> KAK_Capture_Animation_Registrant("KAK_Capture_Animation","");
ScriptRegistrant<KAK_Flag_Icon> KAK_Flag_Icon_Registrant("KAK_Flag_Icon","Team:int");
ScriptRegistrant<KAK_Random_Weather> KAK_Random_Weather_Registrant("KAK_Random_Weather","BarrID:int");
ScriptRegistrant<KAK_Prevent_Kill> KAK_Prevent_Kill_Registrant("KAK_Prevent_Kill","");
ScriptRegistrant<M00_PCT_Pokable_DAK> M00_PCT_Pokable_DAK_Registrant("M00_PCT_Pokable_DAK","");